var fs = require("fs");
var Path = require('path');
/*读取文件目录*/
function readAllFile(parent,reg){
    //判断路径是否存在
    if (fs.existsSync(parent.path)) {
        //读取文件信息
        var item = fs.lstatSync(parent.path);
        //判断是否是文件夹
        if(item.isDirectory()){
            var files = fs.readdirSync(parent.path);
            files.forEach(function (_file,index) {
                var file = fs.lstatSync(parent.path + "/" + _file);
                if(file.isDirectory()) {
                    var folder={
                        type : "folder",
                        path : parent.path+"/"+_file,
                        rPath: parent.rPath+"/"+_file,
                        children : [],
                        name:_file,
                        parent:parent
                    };
                    parent.children.push(folder);
                    readAllFile(folder,reg);
                } else {
                    if(filterFile(parent.path + "/" + _file,reg)) {
                        var obj={
                            type : "file",
                            path : parent.path+"/"+_file,
                            rPath: parent.rPath+"/"+_file,
                            name:_file,
                            parent:parent
                        };
                        parent.children.push(obj);
                    }
                }
            });
        }else {

        }


    }
}

/**
 * 删除文件夹
 * @param path  路径
 */
function deleteFolder(path) {
    var files = [];
    if( fs.existsSync(path) ) {
        files = fs.readdirSync(path);
        files.forEach(function(file,index){
            var curPath = path + "/" + file;
            if(fs.statSync(curPath).isDirectory()) { // recurse
                deleteFolder(curPath);
            } else { // delete file
                fs.unlinkSync(curPath);
            }
        });
        fs.rmdirSync(path);
    }
};
/**
 * 清空文件
 * @param path  路径
 */
function clearFolder(path,state) {
    var files = [];
    if( fs.existsSync(path) ) {
        files = fs.readdirSync(path);
        files.forEach(function(file,index){
            var curPath = path + "/" + file;
            if(fs.statSync(curPath).isDirectory()) { // recurse
                clearFolder(curPath,true);
            } else { // delete file
                fs.unlinkSync(curPath);
            }
        });
        if(state){
            fs.rmdirSync(path);
        }
    }
};


/**
 * 正则验证
 * @param file
 * @returns {boolean}
 */
function filterFile (root,reg) {
    if (reg !== undefined) {
        if (typeof reg.test == 'function' && reg.test(root)) {
            return true;
        }
    }else {
        return true;
    }
}

/**
 * 读取文件
 * @param path路径
 * @param fn  返回结果，
 */
function readFile(path,fn) {
    var item = fs.lstatSync(path);
    //判断是否是文件夹
    if(item.isFile()){
        fs.readFile(path, 'utf8', function(err, str){
            if (err) return fn(err);
            fn(null, str,'DIRECTORY');
        });
    }else if(item.isDirectory()){
        fn(null, null ,'DIRECTORY');
    }
}

//文件路径解析
function readPath(path){
    // Path.dirname(path);
    return Path.basename(path);
}

export {
    readAllFile,
    deleteFolder,
    clearFolder,
    filterFile,
    readFile,
    readPath
};






