//应用连接
(function () {
    var electron = require('electron'); // 控制应用生命周期的模块。
    var BrowserWindow = electron.remote.BrowserWindow;  // 创建原生浏览器窗口的模块
    var remote=require('electron').remote;
    const Zip = electron.remote.require('adm-zip');
    var Application = electron.remote.app;

    var AppPath = Application.getAppPath() + '/';

    var os = require('os');
    var http = require("http");
    var url = require("url");
    var fs= require("fs");
    var DOWNLOAD_DIR = '';
    if(os.platform() == 'win32') {
        try{
            fs.mkdirSync((os.tmpdir() + "/").replace('Local', 'LocalLow'));
        }catch(e){}
        DOWNLOAD_DIR = (os.tmpdir() + "/").replace('Local', 'LocalLow');
    }else{
        DOWNLOAD_DIR = os.tmpdir() + "/";
    }

    /**
     * 下载文件远程更新版本
     * */

    var getHttpDownload =  function(file_url) {
        var options = {
            host: url.parse(file_url).host,
            port: 80,
            path: url.parse(file_url).pathname
        };
        var file_name = url.parse(file_url).pathname.split('/').pop();
        console.log(file_name);
        var strJson = '';
        return new Promise(function (resolve, reject) {
            let req = http.request(options, function(res) {
                if (res.statusCode == 200) {
                    // console.log(res.headers['content-length']);
                }

                res.on('data', function(data) {
                    strJson = strJson + data;
                });
                res.on('end', function() {
                    if (res.statusCode == 404) {
                        resolve({status:false,data:{}});

                    }else {
                        resolve({status:true,data:JSON.parse(strJson)});
                    }

                });
            });

            req.on('error', (e) => {
                console.log(e.message);
                resolve({status:false,data:{}});
            });
            req.end();
        });

    };

    /**
     * 下载文件远程更新包
     * */
    var fileSize = 0;
    var downloaded_size = 0;


    /**
     * 删除文件夹
     * @param path  路径
     */
    function deleteFolder(path) {
        var files = [];
        if( fs.existsSync(path) ) {
            files = fs.readdirSync(path);
            files.forEach(function(file,index){
                var curPath = path + "/" + file;
                if(fs.statSync(curPath).isDirectory()) { // recurse
                    deleteFolder(curPath);
                } else { // delete file
                    fs.unlinkSync(curPath);
                }
            });
            fs.rmdirSync(path);
        }
    };


    var getAppDownload =  function(application,file_url) {
        var options = {
            host: url.parse(file_url).host,
            port: 80,
            path: url.parse(file_url).pathname
        };
        var file_name = url.parse(file_url).pathname.split('/').pop();
        console.log(file_name);
        var strJson = '';
        var appFile = fs.createWriteStream(DOWNLOAD_DIR + file_name, {flags: 'w'});
        return new Promise(function (resolve, reject) {
            let req = http.request(options, function(res) {
                if (res.statusCode == 200) {
                    fileSize = parseInt(res.headers['content-length']);
                    console.log(fileSize);
                }
                res.on('data', function(data) {
                    if(fileSize > 0 ) {
                        var buffer = new Buffer(data);
                        downloaded_size = downloaded_size + buffer.length;
                        i = downloaded_size * 250 / fileSize;
                        console.log(i);
                        appFile.write(data);
                    }
                });
                res.on('end', function() {
                    appFile.end(function(){
                        console.log(AppPath+application);
                        //判断有文件夹是否，有遍历删除
                        if(fs.existsSync(AppPath+application)){
                            deleteFolder(AppPath+application);
                        }
                        var zip = new Zip(DOWNLOAD_DIR + file_name);   /*update.zip*/
                        var zipEntries = zip.getEntries(); // an array of ZipEntry records
                        zipEntries.forEach(function(zipEntry) { });
                        //解压到对应目录
                        zip.extractAllTo(AppPath,true);
                        fs.unlinkSync(DOWNLOAD_DIR + file_name);
                        resolve(true);
                    });


                });
            });

            req.on('error', (e) => {
                console.log(e.message);
                resolve(false);
            });
            req.end();
        });

    };


    //判断文件夹是否存在

    var isUpdate= async function (path,appUrl) {
        var applicationPackageUrl = appUrl+'update.json';
        var applicationHttpPackage= await getHttpDownload(applicationPackageUrl);
        if(!applicationHttpPackage.status){
            if (fs.existsSync(AppPath+path)) {
                return {status:false,zipUrl:"",appActive:true};
            }else {
                return {status:false,zipUrl:"",appActive:false};
            }
        }
        const {zipUrl,version}=applicationHttpPackage.data;

        //判断是否有文件夹
        if (fs.existsSync(AppPath+path)) {
            console.log("目录有");
            var applicationPackage = require(AppPath+path + '/package.json');
            var oldVersion =  applicationPackage.version;

            if(version!=oldVersion){
                // 版本不同
                return {status:true,zipUrl:zipUrl,appActive:true};
            }else {
                // 版本相同
                return {status:false,zipUrl:"",appActive:true};
            }
        }else {
        /*需要更新*/

            return {status:true,zipUrl:zipUrl,appActive:true};
        }

    };

    //下载初始化
    var init=function(){
        fileSize = 0;
        downloaded_size = 0;
    };

    $(function(){
        $("#xnApplication").on("click", ".appApplication", async function () {
            var _this = $(this);
            var application = _this.attr("data-application");
            var appUrl = _this.attr("data-url");


            init();

            //有值代表更新没值代表不更新
            var  updatePage= await isUpdate(application,appUrl);
            if(!updatePage.appActive){
                /*本地远程都没有应用*/
                alert("暂无相关应用！");
                return
            }
            if(updatePage.status){
                _this.addClass("application-active");
                await getAppDownload(application,updatePage.zipUrl);
                _this.removeClass("application-active");
            }

            /*打开项目*/
            var applicationWindow = new BrowserWindow({
                center: true,
                useContentSize: true,
                width: 960,
                height: 620,
                minWidth: 960,
                minHeight: 620,
                webPreferences: {
                    webSecurity: false, allowDisplayingInsecureContent: true, allowRunningInsecureContent: true
                }
            });

            applicationWindow.setMenuBarVisibility(false);
            // if()
            applicationWindow.maximize();

            if (remote.getGlobal('isDebug') == true) {
                applicationWindow.openDevTools();
            }
            applicationWindow.class = 'applicationWindow';

            if (application == "xnTool") {
                applicationWindow.loadURL("file://" + remote.getGlobal('dirname') + "/" + application + "/index.html");
            } else {
                applicationWindow.loadURL("file://" + remote.getGlobal('dirname') + "/" + application + "/index.html");
            }

            applicationWindow.center();
        })
    });
})();
