$(function(){
    collect.init();
});

var collect = new Object();
var remote = require('electron').remote;
var thisBrowserWindow= require('electron').remote.getCurrentWindow(); //获取当前窗口
var dialog = require('electron').remote.dialog;//提示框模块
var uid = localStorage.getItem("uid");
var timer = 0;

//收藏初始化
collect.init = function(){
    $('.app-nav').on('click',function(){
        if($(this).attr('data-index') == 4){
            global.flag = 1;
            let FindCollect = new findCollect();
            FindCollect.setunionId(uid);
            FindCollect.setpageSize(0);
            xn_http_post(FindCollect,function(data){
                if(data.message){
                    alert('collect'+data.message);
                    return;
                }
                if (data.errors == null || data.errors.length > 0) {
                    alert('collect'+data.errors[0].message);
                }else{
                    collect.buildUI($('.collect-active').attr('data-index'),data.result);
                    collect.selectItem(data.result);
                }
            })
        }
    });
};
//渲染页面
collect.buildUI = function(index,collection){
    let content = [];
    let html = '';
    if(index == 0) { //全部
        content = collection;
    }else if(index == 1){ //图片或者视频
        for(let i=0;i<collection.length;i++){
            if(collection[i].objectType == 'IMAGE' || collection[i].objectType == 'VIDEO'){
                content.push(collection[i])
            }
        }
    }else if(index == 2){ //笔记
        for(let i=0;i<collection.length;i++){
            if(collection[i].objectType == 'TEXT'){
                content.push(collection[i])
            }
        }
    }
    for(let i=0;i<content.length;i++){
        if(content[i].objectType == 'TEXT'){ //文本消息渲染
            html += '<div class="collect-content-item" data-id="'+content[i].id+'" data-type="'+content[i].objectType+'"><div class="collect-content-text">'+buildEmoji(content[i].objectContent)+'</div><div class="collect-content-time"><div class="collect-time">'+transTime(Number(content[i].time))+'</div><div class="collect-from">来自：'+content[i].objectName+'</div></div></div>'
        }else if(content[i].objectType == 'IMAGE'){ //图片消息渲染
            html += '<div class="collect-content-item" data-id="'+content[i].id+'" data-type="'+content[i].objectType+'"><div class="collect-content-text"><img class="collect-content-img" src="'+content[i].objectContent+'"></div><div class="collect-content-time"><div class="collect-time">'+transTime(Number(content[i].time))+'</div><div class="collect-from">来自：'+content[i].objectName+'</div></div></div>'
        }else if(content[i].objectType == 'VIDEO'){ //视频消息渲染
            html += '<div class="collect-content-item" data-id="'+content[i].id+'" data-type="'+content[i].objectType+'"><div class="collect-content-text"><div style="width:112px;height:60px;overflow:hidden"><video src="'+content[i].objectContent+'" controls>您的浏览器不支持 video 标签。</video><img class="video-tip" src="./images/video.png"></div></div><div class="collect-content-time"><div class="collect-time">'+transTime(Number(content[i].time))+'</div><div class="collect-from">来自：'+content[i].objectName+'</div></div></div>'
        }else if(content[i].objectType == 'AUDIO'){ //音频消息渲染
            html += '<div class="collect-content-item" data-id="'+content[i].id+'" data-type="'+content[i].objectType+'"><div class="collect-content-text"><div class="collect-content-video"><span href="javascript:;" class="collect-audio"  data-src="'+content[i].objectContent+'">语音消息</span><span title="播放音频"></span></div></div><div class="collect-content-time"><div class="collect-time">'+transTime(Number(content[i].time))+'</div><div class="collect-from">来自：'+content[i].objectName+'</div></div></div>'
        }
    }
    $('.collect-content').html(html);
    collect.deleteItem();//右键删除
    collect.searchCollect();//搜索收藏内容
    collect.detail();//详情查看
};
//选择收藏类型进行筛选
collect.selectItem = function(collection){
    let classObj = document.getElementsByClassName('collect-item');
    for(let i = 0;i<classObj.length;i++ ){
        classObj[i].addEventListener('click',function(){
            $('#collect-search').val('');
            $('.collect-item').removeClass('collect-active');
            $(this).addClass('collect-active');
            $('.collect-name').html($('.collect-active span:last-child').html());
            if($('.collect-active span:last-child').html() == '全部收藏'){
                collect.buildUI(0,collection);
            }else if($('.collect-active span:last-child').html() == '相册'){
                collect.buildUI(1,collection);
            }else if($('.collect-active span:last-child').html() == '笔记'){
                collect.buildUI(2,collection);
            }
        })
    }
};
//右键删除
collect.deleteItem = function(){
    let classObj = document.getElementsByClassName('collect-content-item');
    for(let i=0;i<classObj.length;i++){
        classObj[i].addEventListener('contextmenu',function(e){
            let ev = e || window.event;
            let id = $(ev.target).attr('data-id')?$(ev.target).attr('data-id'):$(ev.target).parents('.collect-content-item').attr('data-id');
            let menu = new Menu();
            menu.append(new MenuItem({label: '删除',visible:true,click:function(){
                var dialogOption = {
                    type: 'question',
                    title: '',
                    buttons: ['确定', '取消'],
                    defaultId: 0,
                    message: '确定删除此收藏？',
                    detail: '',
                    cancelId: 1
                };
                dialog.showMessageBox(dialogOption, function (e) {
                    // e 是选择的目录
                    if (e == 0) {
                        let DeleteCollect = new deleteCollect();
                        DeleteCollect.setId(id);
                        xn_http_post(DeleteCollect,function(data){
                            if(data.message){
                                alert('collect'+data.message);
                                return;
                            }
                            if (data.errors == null || data.errors.length > 0) {
                                alert('collect'+data.errors[0].message);
                            }else{
                                alert('删除成功');
                                if($('.collect-name').html() == '全部收藏'){
                                    collect.uodatePage(0);
                                }else if($('.collect-name').html() == '相册'){
                                    collect.uodatePage(1);
                                }else if($('.collect-name').html() == '笔记'){
                                    collect.uodatePage(2);
                                }
                            }
                        })
                    }
                });
            }}));
            menu.popup(thisBrowserWindow);
        })
    }
};
//刷新页面
collect.uodatePage = function(index){
    let FindCollect = new findCollect();
    FindCollect.setunionId(uid);
    FindCollect.setpageSize(0);
    xn_http_post(FindCollect,function(data){
        if(data.message){
            alert('collect'+data.message);
            return;
        }
        if (data.errors == null || data.errors.length > 0) {
            alert('collect'+data.errors[0].message);
        }else{
            collect.buildUI(index,data.result);
            collect.selectItem(data.result)
        }
    })
};
//搜索收藏内容
collect.searchCollect = function(){
    let target = document.getElementById('collect-search');
    target.addEventListener('keyup',function(e){
        clearTimeout(timer);
        timer = setTimeout(function(){
            let SearchCollect = new searchCollect();
            SearchCollect.setunionId(uid);
            SearchCollect.setkeyWord($('#collect-search').val());
            xn_http_post(SearchCollect,function(data){
                if(data.message){
                    alert('collect'+data.message);
                    return;
                }
                if (data.errors == null || data.errors.length > 0) {
                    alert('collect'+data.errors[0].message);
                }else{
                    if($('#collect-search').val() != ''){
                        $('.collect-name').html('搜索结果');
                        collect.buildUI(0,data.result);
                        if(data.result.length == 0){
                            $('.collect-content').html('<span class="no-result">暂无搜索结果</span>');
                        }
                    }else{
                        $('.collect-name').html($('.collect-active span').eq(1).html());
                        collect.buildUI($('.collect-active').attr('data-index'),data.result);
                    }
                }
            })
        },200);
    })
};
//详情查看
collect.detail = function(){
    let classObj = document.getElementsByClassName('collect-content-item');
    for(let i=0;i<classObj.length;i++){
        classObj[i].addEventListener('click',function(e){
            let ev = e || window.event;
            let type = $(ev.target).attr('data-type') || $(ev.target).parents('.collect-content-item').attr('data-type');
            if(type == 'IMAGE'){
                let target = $('.collect-content-item').eq(i).find('.collect-content-img').eq(0);
                collect.imgView(target);
            }else{
                let targetId = $('.collect-content-item').eq(i).attr('data-id');
                collect.textView(targetId);
            }
        })
    }
};
//图片查看器调用
collect.imgView = function(target){
    let classObj = document.getElementsByClassName('collect-content-img');
    let hrefArr = [];
    for(let i=0;i<classObj.length;i++){
        hrefArr.push($('.collect-content-img').eq(i).attr('src'));
    }
    if(localStorage.getItem('imgList')){
        let currentWindows = BrowserWindow.getAllWindows();
        for(let i=0;i<currentWindows.length;i++){
            if(currentWindows[i].getTitle() == '图片查看器'){
                currentWindows[i].close();
            }
        }
    }
    localStorage.setItem('imgList',JSON.stringify(hrefArr));
    localStorage.setItem('currentImg',target.attr('src'));
    let width = target.naturalWidth;
    let height = target.naturalHeight + 90;
    $('#imgOpen-mask').removeClass('hide');
    var	imgWindow = new BrowserWindow({
        frame:false,
        center:true,
        resizable:true,
        width:width,
        height:height,
        minWidth:330,
        minHeight:420,
        useContentSize:true,
        show:false,
        webPreferences:{
            webSecurity:false,
            allowDisplayingInsecureContent:true,
            allowRunningInsecureContent:true
        }
    });
    imgWindow.loadURL("file://" + remote.getGlobal('dirname')+"/xnChat/page/imgList.html");
    imgWindow.setMenuBarVisibility(false);
    imgWindow.center();
    imgWindow.once('ready-to-show', () => {
        $('#imgOpen-mask').addClass('hide');
        imgWindow.show();
    });
};
//文本及视频详情查看
collect.textView = function(targetId){
    let FindCollect = new findCollect();
    FindCollect.setunionId(uid);
    FindCollect.setpageSize(0);
    xn_http_post(FindCollect,function(data){
        if(data.message){
            alert('collect'+data.message);
            return;
        }
        if (data.errors == null || data.errors.length > 0) {
            alert('collect'+data.errors[0].message);
        }else{
            for(let i=0;i<data.result.length;i++){
                if(data.result[i].id == targetId){
                    if(localStorage.getItem('collectId')){
                        let currentWindows = BrowserWindow.getAllWindows();
                        for(let i=0;i<currentWindows.length;i++){
                            if(currentWindows[i].getTitle() == '收藏详情'){
                                if(localStorage.getItem('edit')){
                                    var dialogOption = {
                                        type: 'question',
                                        title: '',
                                        buttons: ['继续打开', '先去关闭'],
                                        defaultId: 0,
                                        message: '已修改的收藏内容还没有保存，如需保存请先关闭原有收藏，是否继续打开新的收藏？',
                                        detail: '',
                                        cancelId: 1
                                    };
                                    dialog.showMessageBox(dialogOption, function (e) {
                                        // e 是选择的目录
                                        if(e == 0){ //继续打开
                                            localStorage.removeItem('currentItem');
                                            localStorage.setItem('currentItem',JSON.stringify(data.result[i]));
                                            currentWindows[i].close();
                                            collect.openView(targetId);
                                            localStorage.removeItem('edit')
                                        }else if(e == 1){ //先去关闭
                                            currentWindows[i].show();
                                        }
                                    })
                                }else{
                                    localStorage.removeItem('currentItem');
                                    localStorage.setItem('currentItem',JSON.stringify(data.result[i]));
                                    currentWindows[i].close();
                                    collect.openView(targetId);
                                    localStorage.removeItem('edit')
                                }
                            }else{
                                localStorage.setItem('currentItem',JSON.stringify(data.result[i]));
                                collect.openView(targetId);
                                localStorage.removeItem('edit')
                            }
                        }
                    }else{
                        localStorage.setItem('currentItem',JSON.stringify(data.result[i]));
                        collect.openView(targetId);
                        localStorage.removeItem('edit')
                    }
                    break;
                }
            }
        }
    });
};
collect.openView = function(targetId){
    localStorage.setItem('collectId',targetId);
    var viewWindow = new BrowserWindow({
        frame:false,
        center:true,
        resizable:true,
        width:640,
        height:800,
        minWidth:640,
        minHeight:480,
        useContentSize:true,
        show:true,
        webPreferences:{
            webSecurity:false,
            allowDisplayingInsecureContent:true,
            allowRunningInsecureContent:true
        }
    });
    viewWindow.loadURL("file://" + remote.getGlobal('dirname')+"/xnChat/page/collectView.html");
    viewWindow.setMenuBarVisibility(false);
    viewWindow.center();
    viewWindow.on('closed',function(){
        let index = $('.collect-active').attr('data-index');
        let FindCollect = new findCollect();
        FindCollect.setunionId(uid);
        FindCollect.setpageSize(0);
        xn_http_post(FindCollect,function(data){
            if(data.message){
                alert('collect'+data.message);
                return;
            }
            if (data.errors == null || data.errors.length > 0) {
                alert('collect'+data.errors[0].message);
            }else{
                collect.buildUI(index,data.result);
                collect.selectItem(data.result);
            }
        })
    })
};
