$(function(){
    imgView.miniApp();//最小化app
    imgView.maxApp();//缩放app
    imgView.quitApp();//关闭app
    imgView.init();//初始化
    imgView.pre();//向左切换
    imgView.next();//向右切换
    imgView.selectImg();//列表选择切换
    imgView.preview();//预览
    imgView.zoom();//放大缩小
    imgView.scale();//旋转
    imgView.listChange();//列表左右移动切换
    imgView.move();//拖动图片
    imgView.downLoad();//另存为
    clearTimeout(timer);
});

var thisBrowserWindow= require('electron').remote.getCurrentWindow(); //获取当前窗口

var imgView = new Object();
var imgList = JSON.parse(localStorage.getItem('imgList'));
var allNum = imgList.length;
var index = imgList.indexOf(localStorage.getItem('currentImg'));
var timer;
var first = true;
var deg = 0;

//初始化
imgView.init = function(){
    $('.preview-img').html('<img onload="imgView.changeSize()" class="current-img" src="' + localStorage.getItem('currentImg') + '"/>'); //初始化
    imgView.showTip();
    timer = setTimeout(function(){
        $('.tip-msg').addClass('hide');
    },1500);
    if(allNum > 1){
        $('.arrow-box').removeClass('hide')
    }
    if(navigator.userAgent.indexOf('Linux')>0|| navigator.userAgent.indexOf('Mac OS X')>0){
        $('.mac-bar').removeClass('hide');
    }else if(navigator.userAgent.indexOf('Window')>0){
        $('.win-bar').removeClass('hide');
    }
};
//自动调整窗口大小
imgView.changeSize = function(){
    if(first){
        let height = Number($('.current-img').height()) + 90;
        if(height >= 840){
            height = 840;
            $('.current-img').css('height',750)
        }
        let width = Number($('.current-img').width());
        thisBrowserWindow.setSize(width,height);
        imgView.changePosition();
        thisBrowserWindow.center();
        first = false;
    }else{
        $('.current-img').css({'width':'auto','height':'auto'});
        let size = thisBrowserWindow.getSize();
        let oHeight = Number($('.current-img').height());
        let height = oHeight + 90;
        if(height >= 840){
            height = 840;
            $('.current-img').css('height',750);
        }
        let width = Number($('.current-img').width());
        if(Number(size[1]) < height){
            thisBrowserWindow.setSize(Number(size[0]),height);
            thisBrowserWindow.center();
            if(Number(size[0]) < width){
                $('.current-img').css({'width':Number(size[0]),'height':'auto'});
                imgView.changePosition();
            }else if(Number(size[0]) >= width){
                $('.current-img').css({'width':'auto','height':height-90});
                imgView.changePosition();
            }
        }else if(Number(size[1]) > height){
            if(Number(size[0]) < width){
                $('.current-img').css({'width':Number(size[0]),'height':'auto'});
                imgView.changePosition();
            }else if(Number(size[0]) >= width){
                if(Number(size[1]) > oHeight){
                    $('.current-img').css({'width':'auto','height':oHeight});
                }else{
                    $('.current-img').css({'width':'auto','height':Number(size[1])});
                }
                imgView.changePosition();
            }
        }else if(Number(size[1]) == height){
            if(Number(size[0]) < width){
                $('.current-img').css({'width':Number(size[0]),'height':'auto'});
                imgView.changePosition();
            }else if(Number(size[0]) >= width){
                $('.current-img').css({'width':'auto','height':height-90});
                imgView.changePosition();
            }
        }
    }
};
//调整图片位置在窗口居中
imgView.changePosition = function(){
    let width = Number($('.current-img').width());
    let height = Number($('.current-img').height());
    $('.current-img').css({'margin-top':-(height/2)+0.1,'margin-left':-(width/2)+0.1});
};
//最小化窗口
imgView.miniApp = function(){
    $(document).on('click','.mini-icon',function(){
        thisBrowserWindow.minimize();
    })
};
//缩放窗口
imgView.maxApp = function(){
    $(document).on('click','.max-icon',function() {
        if (thisBrowserWindow.isMaximized()) {
            thisBrowserWindow.restore();
            imgView.changeSize();
        } else {
            thisBrowserWindow.maximize();
            imgView.changeSize();
        }
    })
};
//关闭窗口
imgView.quitApp = function(){
    $(document).on('click','.quit-icon',function() {
        localStorage.removeItem('imgList');
        localStorage.removeItem('currentImg');
        thisBrowserWindow.close();
    })
};
//向左切换
imgView.pre = function(){
    $(document).on('click','.pre',function(){
        deg = 0;
        if(!$('.tip-msg').hasClass('hide')){
            return;
        }
        clearTimeout(timer);
        if(index > 0){
            index = index -1;
            $('.current-img').attr('src',imgList[index]).css({'zoom':'1','transform':'rotate(0deg)','left':'50%','top':'50%'});
            $('.list-box').find('.item-img').eq(index).addClass('active-img').siblings('.item-img').removeClass('active-img');
            imgView.showTip();
            imgView.listPosition();
        }else{
            return;
        }
    })
};
//向右切换
imgView.next = function(){
    $(document).on('click','.next',function() {
        deg = 0;
        if(!$('.tip-msg').hasClass('hide')){
            return;
        }
        clearTimeout(timer);
        if(index < allNum - 1){
            index = index + 1;
            $('.current-img').attr('src',imgList[index]).css({'zoom':'1','transform':'rotate(0deg)','left':'50%','top':'50%'});
            $('.list-box').find('.item-img').eq(index).addClass('active-img').siblings('.item-img').removeClass('active-img');
            imgView.showTip();
            imgView.listPosition();
        }else{
            return;
        }
    })
};
//列表选择切换
imgView.selectImg = function(){
    $(document).on('click','.item-img',function(){
        deg = 0;
        $(this).addClass('active-img').siblings('.item-img').removeClass('active-img');
        index = Number(this.getAttribute('data-index'));
        if($('.list-box').hasClass('hide')){
            $('.current-img').attr('src',imgList[index]).css({'zoom':'1','transform':'rotate(0deg)','left':'50%','top':'50%'});
        }else{
            $('.current-img').attr('src',imgList[index]).css({'zoom':'0.8','transform':'rotate(0deg)','left':'50%','top':'50%'});
        }
        imgView.showTip();
    })
};
//列表左右移动切换
imgView.listChange = function(){
    $(document).on('click','.list-left',function(){
        let oLeft = $('.img-list').position().left;
        let number = Math.floor((Number(thisBrowserWindow.getSize()[0]) - 80)/40);
        if(oLeft+(number*40) >=0){
            $('.img-list').css('left',0)
        }else{
            $('.img-list').css('left',oLeft+(number*40))
        }
    });
    $(document).on('click','.list-right',function(){
        let oLeft = $('.img-list').position().left;
        let number = Math.floor((Number(thisBrowserWindow.getSize()[0]) - 80)/40);
        if(oLeft-(number*40) <= -allNum*40){
            return;
        }else{
            $('.img-list').css('left',oLeft-(number*40))
        }
    })
};
//首尾提示
imgView.showTip = function(){
    if(index == allNum -1){
        $('.tip-msg').html('已经是最后一张！').removeClass('hide');
        timer = setTimeout(function(){
            $('.tip-msg').addClass('hide');
        },1000)
    }else if(index == 0){
        $('.tip-msg').html('已经是第一张！').removeClass('hide');
        timer = setTimeout(function(){
            $('.tip-msg').addClass('hide');
        },1000)
    }
};
//预览
imgView.preview = function(){
    $(document).on('click','.preview-icon',function(){
        if($('.list-box').hasClass('hide')){
            $('.preview-img').css('bottom','125px');
            let html = '';
            for(let i=0;i<allNum;i++){
                html += '<span class="item-img" data-index="'+i+'"><img src="' + imgList[i] + '" style="width:100%;height:100%" /></span>'
            }
            $('.img-list').html(html);
            $('.img-list').find('.item-img').eq(index).addClass('active-img');
            $('.list-box').removeClass('hide');
            imgView.listPosition();
        }else{
            $('.preview-img').css('bottom','65px');
            $('.list-box').addClass('hide');
        }
    });
};
//预览列表位置调整
imgView.listPosition = function(){
    let number = Math.floor((Number(thisBrowserWindow.getSize()[0]) - 80)/40);
    if(number < allNum){
        $('.img-box').css('width',number*40);
        $('.list-arrow').removeClass('hide');
        let after = allNum - index -1;
        let result = after%number;
        if(result == 0){
            if((-index*40)+(number-1)*40 >= 0){
                $('.img-list').css('left',0)
            }else{
                $('.img-list').css('left',(-index*40)+(number-1)*40);
            }
        }else{
            if((-index*40)+(number-result-1)*40 >= 0){
                $('.img-list').css('left',0)
            }else{
                $('.img-list').css('left',(-index*40)+(number-result-1)*40)
            }
        }
    }else{
        $('.img-box').css('width',allNum*40);
    }
};
//放大缩小
imgView.zoom = function(){
    $(document).on('click','.enlarge-icon',function(){
        let target = document.getElementsByClassName('current-img')[0];
        imgView.zoomEdit(target,1.1);
    });
    $(document).on('click','.narrow-icon',function(){
        let target = document.getElementsByClassName('current-img')[0];
        imgView.zoomEdit(target,0.9);
    });
    $(document).on('mousewheel','.current-img',function(e,delta){
        let ev = e || window.event;
        ev.preventDefault();
        let n = delta > 0 ? 1.1:0.9;
        imgView.zoomEdit(this,n);
    });
};
//缩放处理
imgView.zoomEdit = function(target,n){
    let size = thisBrowserWindow.getSize();
    let ratioL = (Number(size[0])/2 - target.offsetLeft) / target.offsetWidth;
    let ratioT = (Number(size[1])/2 - target.offsetTop) / target.offsetHeight;
    let ratioDelta = n;
    let w = parseInt(target.offsetWidth * ratioDelta);
    let h = parseInt(target.offsetHeight * ratioDelta);
    let l = Math.round(Number(size[0])/2 - (w * ratioL));
    let t = Math.round(Number(size[1])/2 - (h * ratioT));
    with(target.style) {
        width = w +'px';
        height = h +'px';
        left = l +'px';
        top = t +'px';
    }
    $('.current-img').css({'margin-left':0,'margin-top':0});
};
//拖动图片
imgView.move = function(){
    $('.current-img').draggable({cursor:"move"});
};
//旋转
imgView.scale = function(){
    $(document).on('click','.scale-icon',function(){
        deg = deg + 90;
        $('.current-img').css('transform','rotate('+deg+'deg)')
    });
};
//另存为
imgView.downLoad = function(){
    $(document).on('click','.down-icon',function(){
        let options = {
            title:'另存为...',
            defaultPath:'企信图片'+ Number(new Date()) +'.jpg',
            filters:[
                {name:'Images',extensions:['jpg','png','gif']}
            ],
        };
        var request = require('request');
        var fs = require('fs');
        var {dialog} = require('electron').remote;
        dialog.showSaveDialog(options,function(address){
            let url = $('.current-img').attr('src');
            request(url).pipe(fs.createWriteStream(address))
        });
    })
};
