/**
 * 主要业务逻辑相关
 */

var remote = require("electron").remote;
var electron = require("electron"); // 控制应用生命周期的模块。
var BrowserWindow = electron.remote.BrowserWindow; // 创建原生浏览器窗口的模块

var xnImId = localStorage.getItem("imId");
var xnImAccount = localStorage.getItem("account");
var xnUID = localStorage.getItem("uid");
var xnLoginAccount = localStorage.getItem("xnLoginAccount");
var clipboard = require("electron").clipboard;
var userObject = {};
userObject = localStorage.getItem("user");
var timeout = 0;
var freHeight = 0;
var myApplicationList = [];
var tenantList = [];
var disk = {};
var diskId = "";
var tenantDisk = {};
var tenantId = "";
var yunXin = null;
var cursorPos = 0;
var oContent = "";
var memberName = [];
var oTop;
var oHeight;
var searchKey;
var atId = [];
var timer;
var currentId;

var request = require("request");
var fs = require("fs");
var { dialog } = require("electron").remote;
var shell = require("electron").shell;
var msgId = "";
var msgUrl = "";

const config = require(require("electron").remote.getGlobal("dirname") + "/config.js");

//赋值给全局变量
for (var item in config) {
    global[item] = config[item];
}

const appInfo = JSON.parse(global.appInfo);

var thisBrowserWindow = require("electron").remote.getCurrentWindow();

thisBrowserWindow.setTitle(appInfo.productName);

var Menu = remote.Menu;

var MenuItem = remote.MenuItem;

document.getElementById("j-messageText").addEventListener("keydown", function (e) {
    let ev = e || window.event;
    if (
        ev.keyCode == 13 ||
        ev.keyCode == 108 ||
        (!$("#remind-list").hasClass("hide") && (ev.keyCode == 38 || ev.keyCode == 40))
    ) {
        ev.preventDefault();
    }
});

yunXin = {
    init: function () {
        this.initNode();
        this.initEmoji();
        this.cache = new Cache();
        this.mysdk = new SDKBridge(this, this.cache);
        myTeam.init(this.cache, this.mysdk);
        notification.init(this.cache, this.mysdk);
        this.firstLoadSysMsg = true;
        this.totalUnread = 0;
        this.addEvent();
        localStorage.removeItem("sendFile");
    },
    initNode: function () {
        this.$logout = $("#j-logout");
        this.$userPic = $("#j-userPic");
        this.$userName = $("#j-userName");
        this.$contacts = $("#j-contacts");
        this.$contactsFriends = $("#j-right-friends-ul");
        this.$conversations = $("#j-conversations");
        this.$loadConversations = $("#j-loadConversations");
        this.$loadContacts = $("#j-loadContacts");
        this.$loadTeams = $("#j-loadTeams");

        this.$rightPanel = $("#j-rightPanel");
        this.$chatVernier = $("#j-chatVernier span");
        this.$chatTitle = $("#j-chatTitle");
        this.$chatEditor = $("#j-chatEditor");
        this.$chatContent = $("#j-chatContent");
        this.$sendBtn = $("#j-sendBtn");
        this.$messageText = $("#j-messageText");
        this.$nickName = $("#j-nickName");
        this.$logoutDialog = $("#j-logoutDialog");
        this.$closeDialog = $("#j-closeDialog");
        this.$cancelBtn = $("#j-cancelBtn");
        this.$okBtn = $("#j-okBtn");
        this.$quitBtn = $("#j-quitBtn");
        this.$miniBtn = $("#j-miniBtn");
        this.$maxBtn = $("#j-maxBtn");
        this.$quitBtnDarwin = $("#j-quitBtn-darwin");
        this.$miniBtnDarwin = $("#j-miniBtn-darwin");
        this.$maxBtnDarwin = $("#j-maxBtn-darwin");

        this.$mask = $("#j-mask");
        this.$friendList = $(".friends");
        //添加好友
        this.$addFriend = $("#addFriend");
        this.$addFriendBox = $("#addFriendBox");
        //用户信息
        this.$personCard = $("#personCard");

        //消息中心
        this.$notice = $("#notice");

        //黑名单
        this.$blacklist = $("#blacklist");

        this.$teamInfo = $("#j-teamInfo");
        this.$chooseFileBtn = $("#j-msgType");
        this.$fileInput = $("#j-uploadFile");
        this.$showEmoji = $("#j-showEmoji");
        this.$cloudMsg = $("#j-cloudMsg");
        this.$cloudMsgContainer = $("#j-cloudMsgContainer");
        this.$devices = $("#j-devices");
        this.$searchData = $(".search-name-div");
        this.$searchResult = $(".name-list-ul");
        this.$applocationDiv = $("#application-div");

        this.$union = $(".xn-talk-logo");
    },
    initEmoji: function () {
        var that = this,
            emojiConfig = {
                emojiList: emojiList, //普通表情
                pinupList: pinupList, //贴图
                width: 500,
                height: 300,
                imgpath: "./images/",
                callback: function (result) {
                    that.cbShowEmoji(result);
                },
            };
        this.$emNode = new CEmojiEngine($("#emojiTag")[0], emojiConfig);
    },
    initUI: function () {
        this.buildConversations();
        this.showSysMsgCount();
    },
    //承租人union-ul
    initUnion: function (deferred) {
        tenantList = JSON.parse(localStorage.getItem("unionList"));
        var tenantLength = tenantList.length;
        var tenantTxt = "";
        var enterpriseBookList = "";
        var cdnUrl = require("electron").remote.getGlobal("cdnUrl");

        var avatarUrl = cdnUrl + "#id#/logo.jpg@100w_100h_100q.jpg";

        var img = "<img class='panel_image' src='#url#' alt='#name#' onerror=\"this.src='images/advanced.png'\" />";

        for (var k = 0; k < tenantLength; k++) {
            var name = tenantList[k].name;
            if (tenantList[k].nameAlt && tenantList[k].nameAlt.length > 0) {
                name = tenantList[k].nameAlt;
            }

            var textTemp =
                '<div class="panel_item" data-id="' +
                tenantList[k].id +
                '">' +
                '<div class="panel_avatar">#avatar#</div>' +
                '  <div class="panel_text">' +
                '  	<p class="panel_single-row">' +
                name +
                "</p>" +
                "  </div>" +
                "</div>";
            textTemp = textTemp.replace(
                "#avatar#",
                img.replace("#url#", avatarUrl.replace("#id#", tenantList[k].id)).replace("#name#", tenantList[k].name)
            );
            tenantTxt = tenantTxt + textTemp;
        }
        $("#addressListDiv").html(tenantTxt);

        var unionTxt = "";
        var unionName = "";
        var unionNameOn = "";
        var unionLen = tenantList.length;
        $("#enterpriseBookList").find(".title-num").eq(0).html(unionLen);

        for (var i = 0, len = unionLen; i < len; i++) {
            if (tenantList[i].nameAlt) {
                unionName = tenantList[i].nameAlt;
            } else {
                unionName = tenantList[i].name;
            }
            var activeClass = "";
            if (i == 0) {
                activeClass = "select-union";
            }

            var cdnUrl = require("electron").remote.getGlobal("cdnUrl");
            var avatarUrl = cdnUrl + tenantList[i].id + "/logo.jpg@100w_100h_100q.jpg";

            unionTxt =
                unionTxt +
                '<li class="' +
                activeClass +
                ' clearfix">' +
                '<img  src="' +
                avatarUrl +
                '" onerror="this.src=\'images/capitalIcon.png\'"  class="logo-img f-left">' +
                '<div class="logo-name" data-id="' +
                tenantList[i].id +
                '" title="' +
                unionName +
                '">' +
                unionName +
                "</div>" +
                "</li>";

            /*企业通讯录*/
            var enterpriseBook =
                '<li class="mailItem-li" data-id="tenant-' +
                tenantList[i].id +
                '"><img class="mailItem-avatar" src="' +
                avatarUrl +
                '" onerror="this.src=\'images/capitalIcon.png\'"><span class="mailItem-name">' +
                unionName +
                '</span><span class="mailItem-num">' +
                tenantList[i].userCount +
                "</span></li>";
            enterpriseBookList = enterpriseBookList + enterpriseBook;
        }

        $(".union-ul").html(unionTxt);
        $("#enterpriseBookList").children("ul").eq(0).html(enterpriseBookList);
        yunXin.selectMailItem();

        $("#unionName").on("click", function (e) {
            let ev = e || window.event;
            ev.stopPropagation();
            if ($(".union-ul").hasClass("xn-hidden")) {
                $(".union-ul").removeClass("xn-hidden");
            } else {
                $(".union-ul").addClass("xn-hidden");
            }
        });

        $("#unionName").attr("data-id", tenantList[0].id);
        tenantId = tenantList[0].id;
        localStorage.setItem("tenantId", tenantList[0].id);

        deferred.resolve(tenantId);
        //网盘
        var diskByObjectIdRequest = new DiskByObjectIdRequest();
        diskByObjectIdRequest.setUnionId(xnUID);
        diskByObjectIdRequest.setTenantId(tenantId);
        xn_http_post(diskByObjectIdRequest, function (data) {
            if (data.errors == null || data.errors.length > 0) {
                alert(data.errors[0].message);
            } else {
                disk = data.disk;
                diskId = disk.id;
            }
        });

        //初始化应用
        tabInitUnion(tenantId);
    },
    addEvent: function () {
        this.myApplicationGet();
        this.$chatContent.delegate(".j-img", "click", this.showInfoInChat);
        this.$logout.on("click", this.showDialog.bind(this));
        this.$closeDialog.on("click", this.hideDialog.bind(this));
        this.$cancelBtn.on("click", this.hideDialog.bind(this));
        this.$okBtn.on("click", this.logout.bind(this));
        this.$quitBtn.on("click", this.logout.bind(this));
        this.$miniBtn.on("click", this.miniApp.bind(this));
        this.$maxBtn.on("click", this.maxApp.bind(this));
        this.$quitBtnDarwin.on("click", this.logout.bind(this));
        this.$miniBtnDarwin.on("click", this.miniApp.bind(this));
        this.$maxBtnDarwin.on("click", this.maxApp.bind(this));
        this.$sendBtn.on("click", this.sendTextMessage.bind(this));
        this.$messageText.on("keydown", this.remindMsg.bind(this));
        this.$chooseFileBtn.on("click", "a", this.chooseFile.bind(this));
        this.$showEmoji.on("click", this.showEmoji.bind(this));
        this.$fileInput.on("change", this.uploadFile.bind(this));
        $(".friends .list").on("scroll", this.setVernierPosition);
        //云记录
        this.$cloudMsg.on("click", this.showCloudMsg.bind(this, this.$cloudMsg));
        $("#j-cloudMsgContainer").delegate(".j-backBtn", "click", this.closeCloudMsgContainer.bind(this));
        $("#j-cloudMsgContainer").delegate(".j-loadMore", "click", this.loadMoreCloudMsg.bind(this));
        // 踢人 0：移动端 1：pc端
        $("#j-devices .j-kickMoblie").on("click", this.mysdk.kick.bind(this.mysdk, 0));
        $("#j-devices .j-kickPc").on("click", this.mysdk.kick.bind(this.mysdk, 1));
        $("#j-backBtn2").on("click", this.hideDevices.bind(this));
        $(".m-devices").on("click", this.showDevices.bind(this));

        $(".m-emoji-picCol-ul").on("click", function () {
            $("#j-messageText").focus();
        });
        this.$addFriend.on("click", this.showAddFriend.bind(this));
        this.$loadConversations.on("click", function () {
            $("#j-messageText").focus();
        });
        this.$chatEditor.on("click", function () {
            $("#j-messageText").focus();
        });
        this.$addFriendBox.delegate(".j-close", "click", this.hideAddFriend.bind(this));
        this.$addFriendBox.delegate(".j-search", "click", this.searchFriend.bind(this));
        this.$addFriendBox.delegate(".j-back", "click", this.resetSearchFriend.bind(this));
        this.$addFriendBox.delegate(".j-add", "click", this.applyFriend.bind(this));
        this.$addFriendBox.delegate(".j-blacklist", "click", this.rmBlacklist.bind(this));
        this.$addFriendBox.delegate(".j-chat", "click", this.beginChat.bind(this));
        this.$addFriendBox.delegate(".j-account", "keydown", this.inputAddFriend.bind(this));

        this.$personCard.delegate(".j-close", "click", this.hideInfoBox.bind(this));
        this.$personCard.delegate(".j-saveAlias", "click", this.addFriendAlias.bind(this));
        this.$personCard.delegate(".j-add", "click", this.addFriendInBox.bind(this));
        this.$personCard.delegate(".j-del", "click", this.removeFriend.bind(this));
        this.$personCard.delegate(".j-chat", "click", this.doChat.bind(this));
        this.$personCard.delegate(".mutelist>.u-switch", "click", this.doMutelist.bind(this));
        this.$personCard.delegate(".blacklist>.u-switch", "click", this.doBlacklist.bind(this));
        $("#headImg").on("click", this.showInfo2.bind(this));

        $("#showBlacklist").on("click", this.showBlacklist.bind(this));
        this.$blacklist.delegate(".j-close", "click", this.hideBlacklist.bind(this));
        this.$blacklist.delegate(".items .j-rm", "click", this.removeFromBlacklist);

        //我的手机
        $("#myPhone").on("click", this.sendToMyPhone.bind(this));
        $("#myApplication").on("click", this.toMyApplication.bind(this));

        //我的应用
        $("#myApplication").on("click", this.myApplicationShow.bind(this));
        this.$applocationDiv.delegate(".panel_item", "click", this.toNewApplication);

        //企业通讯录
        $("#addressList").on("click", this.toAddressList.bind(this));

        $("#j-cloudMsgContainer").delegate(".j-mbox", "click", this.playAudio);
        $("#j-chatContent").delegate(".j-mbox", "click", this.playAudio);

        //我的好友
        $("#myFriends").on("click", this.myFriendsShow.bind(this));
        $("#j-loadContacts .panel_item").on("click", function () {
            $("#j-loadContacts .panel_item").removeClass("active");

            $(this).addClass("active");
        });

        $("#addressListDiv ").on("click", ".panel_item", function () {
            $("#addressListDiv").find(".panel_item").removeClass("active");
            $("#addressList").removeClass("active");
            $(this).addClass("active");
        });

        /*@*/
        $("#remind-list").delegate(".remind-item", "click", this.selectMember.bind(this));
        $("#remind-list").delegate(".remind-item", "mouseenter", this.memberHover.bind(this));
        //消息中心
        $("#showNotice").on("click", this.clickNotice.bind(this));
        $("#showApply").on("click", this.clickApply.bind(this));
        this.$notice.delegate(".j-close", "click", this.hideNotice.bind(this));
        this.$notice.delegate(".j-reject", "click", this.rejectNotice);
        this.$notice.delegate(".j-apply", "click", this.acceptNotice);
        this.$notice.delegate(".f-apply", "click", this.passFriendApply);
        this.$notice.delegate(".f-reject", "click", this.rejectFriendApply);
        this.$notice.delegate(".j-rmAllSysNotice", "click", this.rmAllSysNotice.bind(this));
        this.$notice.delegate(".tab li", "click", this.changeNotice);
    },

    //获取用户信息
    initInfo: function (obj, team) {
        this.lockPerson = true;
        this.lockTeam = true;
        var array = Object.keys(obj),
            teamArray = [];
        for (var i = team.length - 1; i >= 0; i--) {
            if (!this.cache.hasTeam(team[i])) {
                teamArray.push(team[i]);
            }
        }
        if (teamArray.length > 0) {
            this.mysdk.getLocalTeams(teamArray, this.cbInitLocakTeamInfo.bind(this));
        } else {
            this.lockTeam = false;
        }
        this.mysdk.getUsers(array, this.cbInitInfo.bind(this));
    },

    cbInitInfo: function (error, data) {
        if (!error) {
            this.cache.setPersonlist(data);
            this.lockPerson = false;
            if (this.lockTeam === false) {
                this.initUI();
            }
        } else {
            console.log("获取用户信息失败");
        }
    },
    cbInitLocakTeamInfo: function (err, data) {
        if (!err) {
            this.cache.addTeamMap(data.teams);
            this.lockTeam = false;
            if (this.lockPerson === false) {
                this.initUI();
            }
        } else {
            alert("获取本地群组失败");
        }
    },
    //左栏上方自己的信息
    showMe: function () {
        var user = this.cache.getUserById(localStorage.getItem("imId"));
        this.$userName.text(user.nick);

        this.$userPic.attr("src", getAvatar(user.avatar));
        localStorage.setItem("nickName", user.nick);
        localStorage.setItem("avatar", user.avatar);
    },
    showMyInfo: function () {
        var user = this.cache.getUserById(localStorage.getItem("imId"));

        var $node = this.$myInfo.data({ info: user });
        $node.find(".u-icon").attr("src", getAvatar(user.avatar));
        $node.find(".j-nick").text(user.nick);
        $node.find(".j-nickname").text(user.nick);
        var avatarSrc = "";
        if (user.gender && user.gender !== "unknown") {
            avatarSrc = "images/" + user.gender + ".png";
            $node.find(".j-gender").removeClass("hide");
        } else {
            $node.find(".j-gender").addClass("hide");
        }
        $node.find(".j-gender").attr("src", avatarSrc);
        $node.find(".j-username").text("帐号：" + user.account);
        $node.find(".j-birth").text(user.birth === undefined ? "--" : user.birth || "--");
        $node.find(".j-tel").text(user.tel === undefined ? "--" : user.tel || "--");
        $node.find(".j-email").text(user.email === undefined ? "--" : user.email || "--");
        $node.find(".j-sign").text(user.sign === undefined ? "--" : user.sign || "--");
        $node.removeClass("hide");
        this.$mask.removeClass("hide");
    },
    /**
     * 多端登录管理
     * @param  {object} devices 设备
     * @return {void}
     */
    loginPorts: function (devices) {
        var pc, mobile;
        for (var i = devices.length - 1; i >= 0; i--) {
            if (/iOS|Android|WindowsPhone/i.test(devices[i].type)) {
                mobile = devices[i];
            } else if (/PC/i.test(devices[i].type)) {
                pc = devices[i];
            }
        }
        if ((pc && pc.online) || (mobile && mobile.online)) {
            if (pc && pc.online && mobile && mobile.online) {
                $(".m-devices").html("正在使用犀牛企信手机版，电脑版");
                $("#j-devices .pc").removeClass("hide");
                $("#j-devices .mobile").removeClass("hide");
                this.mysdk.mobileDeviceId = mobile.deviceId;
                this.mysdk.pcDeviceId = pc.deviceId;
            } else if (pc && pc.online) {
                $(".m-devices").html("正在使用犀牛企信电脑版");
                $("#j-devices .pc").removeClass("hide");
                $("#j-devices .mobile").addClass("hide");
                this.mysdk.mobileDeviceId = false;
                this.mysdk.pcDeviceId = pc.deviceId;
            } else {
                $(".m-devices").html("正在使用犀牛企信手机版");
                $("#j-devices .mobile").removeClass("hide");
                $("#j-devices .pc").addClass("hide");
                this.mysdk.mobileDeviceId = mobile.deviceId;
                this.mysdk.pcDeviceId = false;
            }
            $(".m-devices").removeClass("hide");
            $(".friends").height(463);
            $("#j-chatVernier").css({ marginTop: "41px" });
        } else {
            $(".m-devices").addClass("hide");
            $("#j-devices").addClass("hide");
            $("#j-devices .pc").addClass("hide");
            $("#j-devices .mobile").addClass("hide");
            this.mysdk.mobileDeviceId = false;
            this.mysdk.pcDeviceId = false;
            $(".friends").height(504);
            $("#j-chatVernier").css({ marginTop: "0" });
        }
    },
    /**
     * 多端登录面板UI
     */
    showDevices: function () {
        this.$devices.removeClass("hide");
    },
    hideDevices: function () {
        this.$devices.addClass("hide");
    },

    /**
     * 添加好友窗口
     */
    showAddFriend: function () {
        this.friendData = null;
        this.$addFriendBox.removeClass("hide");
        this.$mask.removeClass("hide");
        this.$addFriendBox.find(".j-account").focus();
    },
    hideAddFriend: function () {
        this.resetSearchFriend();
        this.$addFriendBox.addClass("hide");
        this.$mask.addClass("hide");
    },
    searchFriend: function () {
        let account = $.trim(this.$addFriendBox.find(".j-account").val().toLowerCase());
        if (account !== "") {
            let unionGetByAccountRequest = new UnionGetByAccountRequest();
            unionGetByAccountRequest.setAccount(account);
            xn_http_post(unionGetByAccountRequest, function (data) {
                yunXin.cbGetUserInfo(data);
            });
        }
    },
    beginChat: function () {
        var account = $.trim(this.$addFriendBox.find(".j-account").val().toLowerCase());
        this.hideAddFriend();
        this.openChatBox(account, "p2p");
    },
    resetSearchFriend: function () {
        this.$addFriendBox.attr("class", "m-dialog");
        this.$addFriendBox.find(".j-account").val("");
    },
    addFriend: function () {
        var id = $.trim(this.$addFriendBox.find(".j-account").val().toLowerCase());
        this.mysdk.addFriend(id, this.cbAddFriend.bind(this));
    },
    applyFriend: function () {
        var id = $.trim(this.$addFriendBox.find(".j-username").attr("data-id").toLowerCase());
        this.mysdk.applyFriend(id, this.cbAddFriend.bind(this));
    },
    rmBlacklist: function () {
        var id = $.trim(this.$addFriendBox.find(".j-account").val().toLowerCase());
        this.mysdk.markInBlacklist(id, false, this.cbRmBlacklist.bind(this));
    },
    cbRmBlacklist: function (err, data) {
        if (!err) {
            var account = data.account;
            this.cache.removeFromBlacklist(account);
            this.buildContacts();
            var isFriend = this.cache.isFriend(account);
            if (!isFriend) {
                this.friendData = data;
            }
            this.$addFriendBox.removeClass("blacklist");
            this.$addFriendBox.addClass(isFriend ? "friend" : "noFriend");
        }
    },
    inputAddFriend: function (evt) {
        if (evt.keyCode == 13) {
            $("#addFriendBox .j-account").blur();
            this.searchFriend();
        }
    },
    buildFriends: function () {
        var data = {
            friends: this.cache.getFriendslistOnShow(),
            personSubscribes: this.cache.getPersonSubscribes(),
            account: xnImId,
        };
        if (!this.friends) {
            var options = {
                data: data,
                onclickavatar: this.showInfo.bind(this),
                onclickitem: this.openChatBox.bind(this),
                infoprovider: this.infoProvider.bind(this),
            };
            this.friends = new NIMUIKit.FriendList(options);
            this.friends.inject($("#friends").get(0));
        } else {
            this.friends.update(data);
        }
        this.doPoint();
    },
    cbAddFriend: function (error, params) {
        if (!error) {
            this.$addFriendBox.find(".tip").html("已发送好友请求！");
            this.$addFriendBox.attr("class", "m-dialog done");
        } else {
            alert(error);
        }
    },
    cbGetUserInfo: function (data) {
        $(".desc").find("desc").addClass("hide");
        if (data.result != 0) {
            var $info = this.$addFriendBox.find(".info"),
                user = data.union,
                account = data.union.account;
            $info.find("img").attr("src", getAvatar(user.avatar));
            $info.find(".j-nickname").html(user.name ? user.name : user.nickName);
            $info
                .find(".j-username")
                .html("帐号：" + account)
                .attr("data-id", user.imId);
            if (account == xnImAccount) {
                this.$addFriendBox.find(".tip").html("不能添加自己为好友！");
                this.$addFriendBox.attr("class", "m-dialog done");
            } else {
                var isFriend = this.cache.isFriend(user.imId),
                    inBlacklist = this.cache.inBlacklist(user.imId);
                if (!isFriend) {
                    this.friendData = data;
                } else {
                    $(".already-friend").removeClass("hide");
                }
                if (inBlacklist) {
                    this.$addFriendBox.addClass("blacklist");
                } else {
                    this.$addFriendBox.addClass(isFriend ? "friend" : "noFriend");
                }
            }
        } else {
            this.$addFriendBox.find(".tip").html("该帐号不存在，请检查你输入的帐号是否正确");
            this.$addFriendBox.attr("class", "m-dialog done");
        }
    },
    /**
     * 用户名片
     */
    showInfo: function (account, type) {
        if (type == "p2p") {
            var user = yunXin.cache.getUserById(account);
            this.showInfoBox(user);
        }
    },
    //从聊天面板点进去
    showInfo2: function () {
        if ($("#j-chatEditor").data("type") == "p2p") {
            var account = $("#j-chatEditor").data("to");
            var user = yunXin.cache.getUserById(account);
            this.showInfoBox(user);
        }
    },
    showInfoBox: function (user) {
        if (user.account === xnImId) {
            this.showMyInfo();
            return;
        }
        let unionList = JSON.parse(localStorage.getItem("unionList"));
        for (let i = 0; i < unionList.length; i++) {
            if (user.account.indexOf(unionList[i].id) != -1) {
                return;
            } else {
                continue;
            }
        }
        var controllerScope = $('div[ng-controller="personCardController"]').scope(); // Get controller's scope
        controllerScope.isBuddy = this.cache.isFriend(user.account);
        controllerScope.imId = user.account;
        controllerScope.showPersonCard(user);
    },
    showInfoInChat: function (account, type) {
        var account = $(this).attr("data-account"),
            user = yunXin.cache.getUserById(account);
        if (account == xnImId) {
            return;
        }

        // 判断是不是机器人
        var isPerson = JSON.parse(user.custom);
        if (isPerson.type === "SYSTEM") {
            alert("我是机器人");
        } else {
            yunXin.showInfoBox(user);
        }

        console.log(JSON.parse(user.custom));
    },
    hideInfoBox: function () {
        this.$personCard.addClass("hide");
        this.$mask.addClass("hide");
        this.$personCard.removeClass("notFriend");
        this.$personCard.removeClass("blacklist");
        this.$personCard.find(".mutelist .u-switch").removeClass("off");
        this.$personCard.find(".blacklist .u-switch").removeClass("off");
    },
    // 好友备注
    addFriendAlias: function () {
        var account = this.$personCard.data("account");
        var alias = this.$personCard.find(".e-alias").val().trim();
        this.mysdk.updateFriend(account, alias, this.cbAddFriendAlias.bind(this));
    },
    cbAddFriendAlias: function (err, data) {
        if (!err) {
            alert("修改备注成功");
            this.$personCard.find(".e-alias").val(data.alias);
            this.cache.updateFriendAlias(data.account, data.alias);
            this.$personCard.find(".j-nick").text(getNick(data.account));
            if ($("#j-chatEditor").data("to") === data.account) {
                this.$nickName.text(getNick(data.account));
            }
            this.buildConversations();
            this.buildContacts();
        } else {
            alert("修改备注失败");
        }
    },
    addFriendInBox: function (account, unionId) {
        account = this.$personCard.find(".j-username").attr("data-id") || account;
        unionId = this.$personCard.find(".j-username").attr("union-id") || unionId;
        this.mysdk.applyFriend(account, this.cbAddFriendInBox.bind(this));
    },
    cbAddFriendInBox: function (error, params) {
        if (!error) {
            alert("消息发送成功！");
            this.cache.updatePersonlist(this.friendData);
            this.buildContacts();
        } else {
            this.$addFriendBox.find(".tip").html("该帐号不存在，请检查你输入的帐号是否正确");
            this.$addFriendBox.attr("class", "m-dialog done");
        }
    },
    removeFriend: function (account) {
        if (window.confirm("确定要删除")) {
            account = this.$personCard.data("account") || account;
            this.mysdk.deleteFriend(account, this.cbRemoveFriend.bind(this));
        }
    },
    cbRemoveFriend: function (error, params) {
        if (!error) {
            this.hideInfoBox();
            this.cache.removeFriend(params.account);
            if ($("#j-chatEditor").data("to") === params.account) {
                this.$nickName.text(getNick(params.account));
            }
            this.buildContacts();
        } else {
            alert("删除好友失败");
        }
    },
    doChat: function (account) {
        if (account == null || account == undefined) {
            account = this.$personCard.data("account");
        }
        this.hideInfoBox();
        var $container;
        if (!this.$loadConversations.is(".hide")) {
            $container = this.$loadConversations;
        } else if (!this.$loadContacts.is(".hide")) {
            $container = this.$loadContacts;
        } else {
            this.openChatBox(account, "p2p");
            return;
        }
        var $li = $container.find('.m-panel li[data-account="' + account + '"]');
        if ($li.length > 0) {
            $li.find(".count").addClass("hide");
            $li.find(".count").text(0);
        }
        this.openChatBox(account, "p2p");
    },
    doMutelist: function () {
        if (this.$personCard.is(".blacklist")) {
            return;
        }
        var account = this.$personCard.data("account"),
            status = !this.$personCard.data("inMutelist");
        this.mysdk.markInMutelist(account, status, this.cbDoMutelist.bind(this));
    },
    cbDoMutelist: function (err, data) {
        if (!err) {
            if (data.isAdd) {
                this.cache.addToMutelist(data.record);
                this.$personCard.data("inMutelist", true);
            } else {
                this.cache.removeFromMutelist(data.account);
                this.$personCard.data("inMutelist", false);
            }
            this.$personCard.find(".mutelist .u-switch").toggleClass("off");
        } else {
            alert("操作失败");
        }
    },
    doBlacklist: function () {
        var account = this.$personCard.data("account"),
            status = !this.$personCard.data("inBlacklist");
        this.mysdk.markInBlacklist(account, status, this.cbDoBlacklist.bind(this));
    },
    cbDoBlacklist: function (err, data) {
        if (!err) {
            if (data.isAdd) {
                this.cache.addToBlacklist(data.record);
                this.$personCard.data("inBlacklist", true);
                this.$personCard.addClass("blacklist");
            } else {
                this.cache.removeFromBlacklist(data.account);
                this.$personCard.data("inBlacklist", false);
                this.$personCard.removeClass("blacklist");
            }
            this.$personCard.find(".blacklist .u-switch").toggleClass("off");
            this.buildConversations();
            this.buildContacts();
        } else {
            alert("操作失败");
        }
    },
    /**
     * 我的手机
     */
    sendToMyPhone: function () {
        this.openChatBox(xnImId, "p2p");
    },
    /**
     * 我的应用
     */
    toMyApplication: function () {
        //嵌入代码
    },
    myApplicationGet: function () {
        myApplicationList = JSON.parse(localStorage.getItem("unionList"));
        var applicationTxt = "";
        var nameAlt = "";
        if (myApplicationList.length > 0) {
            for (var j = 0, len = myApplicationList.length; j < len; j++) {
                if (myApplicationList[j].nameAlt) {
                    nameAlt = myApplicationList[j].nameAlt;
                } else {
                    nameAlt = myApplicationList[j].name;
                }
                applicationTxt =
                    applicationTxt +
                    ('<div  class="panel_item" data-json="' +
                        encodeURI(JSON.stringify(myApplicationList[j])) +
                        '">' +
                        '		<div class="panel_avatar">' +
                        '			<img class="panel_image" src="images/advanced.png" alt="' +
                        myApplicationList[j].name +
                        '"/>' +
                        "		</div>" +
                        '		<div class="panel_text">' +
                        '			<p class="panel_single-row">' +
                        nameAlt +
                        "</p>" +
                        "		</div>" +
                        "	</div>");
            }
            $("#application-div").html(applicationTxt);
        }
    },
    myApplicationShow: function () {
        if ($("#application-div").hasClass("hide")) {
            $("#application-div").removeClass("hide");
        } else {
            $("#application-div").addClass("hide");
        }
    },
    toAddressList: function () {
        if ($("#addressListDiv").hasClass("hide")) {
            $("#addressListDiv").removeClass("hide");
        } else {
            $("#addressListDiv").addClass("hide");
        }
    },
    toAddressShow: function () {
        var tenantId = $(this).attr("data-id");
    },

    myFriendsShow: function () {
        yunXin.buildContacts();
        $(".right-panel").addClass("hide");
        $("#j-right-friends").removeClass("hide");
    },
    toNewApplication: function () {
        var thisData = $(this).attr("data-json");
        console.log(decodeURI(thisData));
        var tenant = JSON.parse(decodeURI(thisData));
        var passportIdGetByUnionIdAndTenantIdRequest = new PassportIdGetByUnionIdAndTenantIdRequest();
        passportIdGetByUnionIdAndTenantIdRequest.setTenantId(tenant.id);
        passportIdGetByUnionIdAndTenantIdRequest.setUnionId(xnUID);
        xn_http_post(passportIdGetByUnionIdAndTenantIdRequest, function (data) {
            console.log(data);
            var electron = require("electron"); // 控制应用生命周期的模块。
            var BrowserWindow = electron.remote.BrowserWindow; // 创建原生浏览器窗口的模块
            //
            mainWindow = new BrowserWindow({
                useContentSize: true,
                center: true,
                webPreferences: {
                    allowDisplayingInsecureContent: true,
                    allowRunningInsecureContent: true,
                    webSecurity: false,
                },
            });
            mainWindow.setProgressBar(1.0);
            //  mainWindow.setMenuBarVisibility(false);
            if (require("electron").remote.getGlobal("isDebug") == true) {
                //   mainWindow.openDevTools();
            }
            var authUrl = require("electron").remote.getGlobal("authUrl");
            var employeeUrl = require("electron").remote.getGlobal("employeeUrl");

            var url = (
                authUrl +
                "sso/autoLogin.do?token=#passportId#&returnUrl=" +
                encodeURI(employeeUrl + "application.htm")
            ).replace("#passportId#", data.passportId);

            //注意 生产passportId不行
            console.log(url);
            mainWindow.loadURL(url);
        });
    },

    /**
     * 消息中心
     */
    showSysMsgCount: function () {
        var $node = $("#showApply .panel_count");
        var count = this.cache.getSysMsgCount();
        var allmsgs = this.cache.getSysMsgs();
        if (this.$notice.hasClass("hide")) {
            if (count > 0) {
                if (count > 99) {
                    $node.removeClass("hide").text("...");
                } else {
                    $node.removeClass("hide").text(count);
                }
            } else {
                $node.addClass("hide").text(count);
            }
        } else {
            this.cache.setSysMsgCount(0);
        }
    },
    clickNotice: function () {
        //if(freHeight<600) {
        //    window.resizeTo(1015, 660);
        //}
        var that = this;
        this.cache.setSysMsgCount(0);
        this.showSysMsgCount();
        if (this.firstLoadSysMsg) {
            this.mysdk.getLocalSysMsgs(function (error, obj) {
                if (!error) {
                    if (obj.sysMsgs.length > 0) {
                        that.cache.setSysMsgs(obj.sysMsgs);
                    }
                    that.firstLoadSysMsg = false;
                    that.showNotice();
                } else {
                    alert("获取系统消息失败");
                }
            });
        } else {
            this.showNotice();
        }
    },
    showNotice: function () {
        this.buildSysNotice();
        this.buildCustomSysNotice();
        this.$notice.removeClass("hide");
        this.$mask.removeClass("hide");
        document.documentElement.style.overflow = "hidden";
    },
    buildSysNotice: function () {
        var data = this.cache.getSysMsgs(),
            array = [],
            that = this;
        //确保用户信息存在缓存中
        for (var i = 0; i < data.length; i++) {
            if (!this.cache.getUserById(data[i].from)) {
                array.push(data[i].from);
            }
        }
        if (array.length > 0) {
            this.mysdk.getUsers(array, function (err, data) {
                for (var i = data.length - 1; i >= 0; i--) {
                    that.cache.setPersonlist(data[i]);
                }
            });
        }
        var html = appUI.buildSysMsgs(data, this.cache);

        this.$notice.find(".j-sysMsg").html(html);
    },
    buildCustomSysNotice: function () {
        var data = this.cache.getCustomSysMsgs(),
            array = [],
            that = this;
        //确保用户信息存在缓存中
        for (var i = 0; i < data.length; i++) {
            if (!this.cache.getUserById(data[i].from)) {
                array.push(data[i].from);
            }
        }
        if (array.length > 0) {
            this.mysdk.getUsers(array, function (err, data) {
                for (var i = data.length - 1; i >= 0; i--) {
                    that.cache.setPersonlist(data[i]);
                }
            });
        }
        var html = appUI.buildCustomSysMsgs(data, this.cache);
        this.$notice.find(".j-customSysMsg").html(html);
    },
    clickApply: function () {
        let that = this;
        this.cache.setSysMsgCount(0);
        $(".new-friend-who").html("暂无新的好友请求");
        $(".applyTime").html();
        this.showSysMsgCount();
        if (this.firstLoadSysMsg) {
            this.mysdk.getLocalSysMsgs(function (error, obj) {
                if (!error) {
                    if (obj.sysMsgs.length > 0) {
                        that.cache.setSysMsgs(obj.sysMsgs);
                    }
                    that.firstLoadSysMsg = false;
                    that.showApply();
                } else {
                    alert("获取系统消息失败");
                }
            });
        } else {
            this.showApply();
        }
    },
    showApply: function () {
        $(".right-panel").addClass("hide");
        $("#applyFriend").removeClass("hide");
        let data = this.cache.getSysMsgs(),
            array = [],
            that = this;
        //确保用户信息存在缓存中
        for (let i = 0; i < data.length; i++) {
            if (!this.cache.getUserById(data[i].from)) {
                array.push(data[i].from);
            }
        }
        if (array.length > 0) {
            this.mysdk.getUsers(array, function (err, data) {
                for (var i = data.length - 1; i >= 0; i--) {
                    that.cache.setPersonlist(data[i]);
                }
            });
        }
        // appUI.buildApplyFriendUI(data,this.cache)
        appUI.buildSysMsgs(data, this.cache);
    },
    hideNotice: function () {
        this.$notice.addClass("hide");
        this.$mask.addClass("hide");
        document.documentElement.style.overflow = "";
    },
    changeNotice: function () {
        var $node = yunXin.$notice;
        $node.find(".tab li").removeClass("crt");
        $(this).addClass("crt");
        if ($(this).attr("data-value") === "sys") {
            $node.find(".j-sysMsg").removeClass("hide");
            $node.find(".j-customSysMsg").addClass("hide");
        } else {
            $node.find(".j-sysMsg").addClass("hide");
            $node.find(".j-customSysMsg").removeClass("hide");
        }
    },
    acceptNotice: function () {
        var $this = $(this),
            $node = $this.parent(),
            teamId = $node.attr("data-id"),
            from = $node.attr("data-from"),
            type = $node.attr("data-type"),
            idServer = $node.attr("data-idServer");
        if (type === "teamInvite") {
            yunXin.mysdk.acceptTeamInvite(teamId, from, idServer);
        } else {
            yunXin.mysdk.passTeamApply(teamId, from, idServer);
        }
    },
    passFriendApply: function () {
        var $this = $(this),
            $node = $this.parent(),
            account = $node.attr("data-from"),
            idServer = $node.attr("data-idServer");
        var data = {
            account: account,
            idServer: idServer,
        };
        yunXin.mysdk.passFriendApply(idServer, account, function () {
            alert("您同意了" + getNick(account) + "的好友申请！");
        });
        yunXin.mysdk.updateLocalSysMsg(idServer);
        yunXin.cache.addFriend(data);
        yunXin.cache.updatePersonlist(data);
        yunXin.buildContacts();
    },

    rejectFriendApply: function () {
        var $this = $(this),
            $node = $this.parent(),
            account = $node.attr("data-from"),
            idServer = $node.attr("data-idServer");
        yunXin.mysdk.rejectFriendApply(idServer, account);
        yunXin.mysdk.updateLocalSysMsg(idServer);
    },
    rejectNotice: function () {
        var $this = $(this),
            $node = $this.parent(),
            teamId = $node.attr("data-id"),
            from = $node.attr("data-from"),
            type = $node.attr("data-type"),
            idServer = $node.attr("data-idServer");
        if (type === "teamInvite") {
            yunXin.mysdk.rejectTeamInvite(teamId, from, idServer);
        } else {
            yunXin.mysdk.rejectTeamApply(teamId, from, idServer);
        }
    },
    rmAllSysNotice: function () {
        var that = this;
        var type = this.$notice.find(".tab .crt").attr("data-value");
        if (type === "sys") {
            this.mysdk.deleteAllLocalSysMsgs(function (err, obj) {
                if (err) {
                    alert("删除失败");
                } else {
                    that.cache.setSysMsgs([]);
                    that.buildSysNotice();
                }
            });
        } else {
            this.cache.deleteCustomSysMsgs();
            this.buildCustomSysNotice();
        }
    },
    /**
     * 显示黑名单列表
     */
    showBlacklist: function () {
        //if(freHeight<600) {
        //    window.resizeTo(1015, 660);//改变大小
        //}
        var data = this.cache.getBlacklist();
        var html = appUI.buildBlacklist(data, this.cache);
        this.$blacklist.find(".list").html(html);
        this.$blacklist.removeClass("hide");
        this.$mask.removeClass("hide");
        document.documentElement.style.overflow = "hidden";
    },
    hideBlacklist: function () {
        $("#blacklist").addClass("hide");
        this.$mask.addClass("hide");
        document.documentElement.style.overflow = "";
    },
    removeFromBlacklist: function () {
        var id = $(this).attr("data-id");
        yunXin.mysdk.markInBlacklist(id, false, yunXin.cbRemoveFromBlacklist.bind(yunXin));
    },
    cbRemoveFromBlacklist: function (err, data) {
        if (!err) {
            this.cache.removeFromBlacklist(data.account);
            var html = appUI.buildBlacklist(this.cache.getBlacklist(), this.cache);
            this.$blacklist.find(".list").html(html);
            this.buildContacts();
        } else {
            alert("操作失败");
        }
    },
    /**
     * 查看云记录
     */
    showCloudMsg: function () {
        var that = this;
        // var	recordWindow = new BrowserWindow({
        //     frame:false,
        //     center:true,
        //     resizable:true,
        //     minWidth:550,
        //     minHeight:680,
        //     useContentSize:true,
        //     webPreferences:{
        //         webSecurity:false,
        //         allowDisplayingInsecureContent:true,
        //         allowRunningInsecureContent:true
        //     }
        // });
        // recordWindow.setMenuBarVisibility(false);
        // recordWindow.center();
        // localStorage.setItem('getHistoryId',this.$chatEditor.data('to'));
        // localStorage.setItem('getHistorysScene',this.$chatEditor.data('type'));
        // localStorage.setItem('name',$('#j-nickName').html());
        // recordWindow.loadURL("file://" + remote.getGlobal('dirname')+"/xnChat/page/cloudMsg.html");
        // if (this.$chatEditor.data("type") === "team") {
        //     var teamId = this.$teamInfo.data("team-id");
        //     var teamInfo = that.cache.getTeamById(teamId);
        //     if (!teamInfo) {
        //         return;
        //     }
        // }
        this.$cloudMsgContainer.load("./cloud-msg.html", function () {
            that.$cloudMsgContainer.removeClass("hide");
            var id = that.$chatEditor.data("to"),
                scene = that.$chatEditor.data("type"),
                param = {
                    scene: scene,
                    to: id,
                    lastMsgId: 0,
                    limit: 100,
                    reverse: false,
                    done: that.cbCloudMsg.bind(that),
                };
            // console.log(that.$chatEditor)
            that.mysdk.getHistoryMsgs(param);
        });
    },
    /**
     * 云记录面板显示
     * @return {[type]} [description]
     */
    closeCloudMsgContainer: function () {
        $("#j-cloudMsgContainer").addClass("hide");
    },

    /**
     * 加载更多云记录
     */
    loadMoreCloudMsg: function () {
        var time = $("#j-cloudMsgList .item").first();
        alert("时间" + time.attr("data-time"));
        var id = this.$chatEditor.data("to"),
            scene = this.$chatEditor.data("type"),
            lastItem = $("#j-cloudMsgList .item").first(),
            param = {
                scene: scene,
                to: id,
                beginTime: 0,
                endTime: parseInt(lastItem.attr("data-time")),
                lastMsgId: parseInt(lastItem.attr("data-idServer")), //idServer 服务器用于区分消息用的ID，主要用于获取历史消息
                limit: 100,
                reverse: false,
                done: this.cbCloudMsg.bind(this),
            };
        this.mysdk.getHistoryMsgs(param);
    },

    /**
     * 云记录获取回调
     * @param  {boolean} error
     * @param  {object} obj 云记录对象
     */
    cbCloudMsg: function (error, obj) {
        var node = $("#j-cloudMsgList"),
            tip = $("#j-cloudMsgContainer .u-status span");
        if (!error) {
            if (obj.msgs.length === 0) {
                tip.html("没有更早的聊天记录");
            } else {
                if (obj.msgs.length < 20) {
                    tip.html("没有更早的聊天记录");
                } else {
                    tip.html('<a class="j-loadMore">加载更多记录</a>');
                }
                var msgHtml = appUI.buildCloudMsgUI(obj.msgs, this.cache);
                $(msgHtml).prependTo(node);
            }
        } else {
            console && console.error("获取历史消息失败");
            tip.html("获取历史消息失败");
        }
    },
    //滚动监听圆点
    setVernierPosition: function () {
        var $active = $(this).find(".active"),
            type = $active.parents(".friends").data("type"),
            $container = "",
            that = yunXin;
        if (type == "contacts") {
            $container = that.$loadContacts;
        } else if (type == "teams") {
            $container = that.$loadTeams;
        } else {
            $container = that.$loadConversations;
        }
        if ($active.length) {
            var top = $active.offset().top - $container.offset().top + 60;
            that.$chatVernier.css("top", top);
        }
    },

    uploadFile: function (e) {
        let name = e.currentTarget.files[0].name;
        let size = e.currentTarget.files[0].size;
        let hour = new Date().getHours();
        let minutes = new Date().getMinutes();
        if (hour < 10) {
            hour = "0" + hour;
        }
        if (minutes < 10) {
            minutes = "0" + minutes;
        }
        let time = hour + ":" + minutes;
        var that = this,
            scene = that.$chatEditor.data("type"),
            to = that.$chatEditor.data("to"),
            fileInput = this.$fileInput.get(0);
        if (fileInput.files[0].size == 0) {
            alert("不能传空文件");
            return;
        }
        let html =
            '<div id="previewFile"><p class="u-msgTime"><span>' +
            time +
            '</span></p><div class="item item-me"><img class="img j-img" src="' +
            $("#j-userPic").attr("src") +
            '"><p style="height:9px"></p><div class="msg msg-text msg-file" style="background-color:#fff"><div class="box"><div class="cnt"><a href="javascript:void(0)" class="download-file f-maxWid" style="color:#000"><span class="icon icon-file2"></span>' +
            name +
            "&nbsp;&nbsp;&nbsp;" +
            this.bytesToSize(size) +
            '</a></div><div class="progress-box"><div class="progress-file"></div></div></div></div></div></div>';
        $("#j-chatContent").append(html).scrollTop(99999);
        localStorage.setItem(
            "sendFile",
            JSON.stringify({
                scene: $("#j-conversations").find(".active").eq(0).attr("data-scene"),
                account: $("#j-conversations").find(".active").eq(0).attr("data-account"),
                html: html,
            })
        );
        this.mysdk.sendFileMessage(scene, to, fileInput, this.sendMsgDone.bind(this));
    },

    bytesToSize: function (bytes) {
        if (bytes === 0) return "0 B";

        var k = 1024;

        sizes = ["B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];

        i = Math.floor(Math.log(bytes) / Math.log(k));

        return (bytes / Math.pow(k, i)).toFixed(2) + " " + sizes[i];
    },

    chooseFile: function () {
        let item = localStorage.getItem("sendFile");
        if (item) {
            const dialog = require("electron").remote.dialog;
            var dialogOption = {
                type: "warning",
                title: "警告",
                buttons: ["确定"],
                defaultId: 0,
                message: "存在待发送的文件，发送失败！",
                detail: "",
                cancelId: 1,
            };
            dialog.showMessageBox(dialogOption, function (e) {});
            return;
        }
        this.$fileInput.click();
    },

    /**
     * 通讯录列表显示
     * @param  {object} 数据对象
     * @return {void}
     */
    buildContacts: function () {
        var data = {
            friends: this.cache.getFriendslistOnShow(),
            account: xnImId,
        };
        if (!this.friend) {
            var options = {
                data: data,
                onclickavatar: this.showInfo.bind(this),
                onclickitem: this.openChatBox.bind(this),
                infoprovider: this.infoProvider.bind(this),
            };
            this.friends = new NIMUIKit.FriendList(options);
            this.friends.inject(this.$contactsFriends.get(0));
        } else {
            this.friends.update(data);
        }
        this.doPoint();
    },

    //获取好友备注名或者昵称
    getNick: function (account) {
        // 使用util中的工具方法
        return getNick(account, this.cache);
    },
    /**
     * 列表想内容提供方法（用于ui组件）
     * @param  {Object} data 数据
     * @param  {String} type 类型
     * @return {Object} info 需要呈现的数据
     */
    infoProvider: function (data, type) {
        var info = {};
        switch (type) {
            case "session":
                var msg = data.lastMsg;
                if (!msg) {
                    return;
                }
                var scene = msg.scene;
                info.scene = scene;
                info.account = msg.target;
                info.target = msg.scene + "-" + msg.target;
                info.time = transTime2(msg.time);
                info.crtSession = this.crtSession;
                info.unread = data.unread > 99 ? "99+" : data.unread;
                info.getMsg = data.getMsg != null || data.getMsg != undefined ? data.getMsg : true;
                info.text = buildSessionMsg(msg);
                if (scene === "p2p") {
                    //点对点
                    if (msg.target === xnImId) {
                        info.nick = "我的手机";
                        info.avatar = "images/myPhone.png";
                    } else {
                        var userInfo = this.cache.getUserById(msg.target);
                        let that = this;
                        if (userInfo == undefined || userInfo == null || !userInfo) {
                            this.mysdk.getUsers([msg.target], function (err, data) {
                                if (!err) {
                                    for (var j = 0; j < data.length; j++) {
                                        that.cache.updatePersonlist(data[j]);
                                    }
                                    let userInfo = that.cache.getUserById(msg.target);
                                    info.nick = this.getNick(msg.target);
                                    info.avatar = getAvatar(userInfo.avatar);
                                } else {
                                    console.log("获取用户信息失败");
                                }
                            });
                        } else {
                            info.nick = this.getNick(msg.target);
                            info.avatar = getAvatar(userInfo.avatar);
                        }
                    }
                } else {
                    //群组
                    var teamInfo = this.cache.getTeamById(msg.target);
                    if (teamInfo) {
                        info.nick = teamInfo.name;
                        if (teamInfo.avatar) {
                            info.avatar = teamInfo.avatar;
                        } else {
                            info.avatar = "images/advanced.png";
                        }
                    } else {
                        info.nick = msg.target;
                        info.avatar = "images/advanced.png";
                    }
                }
                break;
            case "friend":
                info.target = "p2p-" + data.account;
                info.account = data.account;
                info.nick = this.getNick(info.account);
                info.avatar = getAvatar(data.avatar);
                info.crtSession = this.crtSession;
                break;
            case "team":
                info.type = data.type;
                info.nick = data.name;
                info.target = "team-" + data.teamId;
                info.teamId = data.teamId;
                if (data.avatar) {
                    info.avatar = data.avatar;
                } else {
                    info.avatar = "images/advanced.png";
                }
                info.crtSession = this.crtSession;
                break;
        }
        return info;
    },
    /*显示@消息*/
    showPushMsg: function () {
        let sessions = JSON.parse(JSON.stringify(this.cache.getSessions()));
        let teams = JSON.parse(JSON.stringify(this.cache.getTeamlist()));
        let teamId = [];
        let result = [];
        let resultId = [];
        let arr = [];
        for (let i = 0; i < teams.length; i++) {
            teamId.push("team-" + teams[i].teamId);
        }
        for (let i = 0; i < sessions.length; i++) {
            if (sessions[i].scene == "team") {
                if (teamId.indexOf(sessions[i].id) != -1) {
                    result.push(sessions[i]);
                    resultId.push(sessions[i].id);
                    arr.push(sessions[i].unread);
                }
            } else {
                result.push(sessions[i]);
                resultId.push(sessions[i].id);
            }
        }
        let count = 0;
        for (let i = 0; i < arr.length; i++) {
            if (arr[i] == 0) {
                count = count + 1;
            }
        }
        if (arr.length == count) {
            clearInterval(timer);
            count = 0;
            thisBrowserWindow.setProgressBar(-1);
        }
        for (let i = 0; i < result.length; i++) {
            if (result[i].scene == "team") {
                let id = result[i].id;
                let unread = result[i].unread;
                let msgs = this.cache.getMsgs(id);
                let count = 0;
                if ($(".u-unread").html().length == 0 || Number($(".u-unread").html()) == 0) {
                    // thisBrowserWindow.setTitle(appInfo.productName);
                    clearInterval(timer);
                    count = 0;
                    thisBrowserWindow.setProgressBar(-1);
                    return;
                }
                if (unread != 0) {
                    if (msgs.length == 0) {
                        this.mysdk.getLocalMsgs(id, function (err, data) {
                            if (!err) {
                                let index = resultId.indexOf(data.sessionId);
                                if (index != -1) {
                                    let reverse = data.msgs.slice(0, result[index].unread);
                                    for (let k = 0; k < reverse.length; k++) {
                                        if (
                                            reverse[k].apns &&
                                            reverse[k].apns.accounts &&
                                            reverse[k].apns.accounts.indexOf(xnImId) != -1
                                        ) {
                                            $(".j-session")
                                                .find(".panel_lastMsg")
                                                .eq(index)
                                                .html(
                                                    '<span style="color:#f24c3d">[有人@我]</span><span style="color:#999"></span>'
                                                );
                                            // thisBrowserWindow.setTitle(appInfo.productName+'('+$('.u-unread').html()+'条消息)');
                                            break;
                                        }
                                        // $('.j-session').find('.panel_lastMsg').eq(index).text(result[index].lastMsg.fromNick+':'+result[index].lastMsg.text).css('color','#999');
                                        // thisBrowserWindow.setTitle(appInfo.productName+'('+$('.u-unread').html()+'条消息)');
                                    }
                                    for (let i = 0; i < $(".panel_lastMsg").length; i++) {
                                        if (
                                            $(".panel_lastMsg")[i].innerHTML.indexOf(
                                                '<span style="color:#f24c3d">[有人@我]</span>'
                                            ) != -1
                                        ) {
                                            clearInterval(timer);
                                            count = 0;
                                            timer = setInterval(function () {
                                                count++;
                                                if (count % 2 == 0) {
                                                    thisBrowserWindow.setProgressBar(1);
                                                } else {
                                                    thisBrowserWindow.setProgressBar(-1);
                                                }
                                            }, 400);
                                            break;
                                        }
                                        clearInterval(timer);
                                        count = 0;
                                        thisBrowserWindow.setProgressBar(-1);
                                    }
                                }
                            } else {
                                alert("获取历史消息失败");
                            }
                        });
                    } else {
                        let index = resultId.indexOf(id);
                        if (index != -1) {
                            let reverse = this.cache.getMsgs(id).slice(-result[index].unread);
                            for (let k = 0; k < reverse.length; k++) {
                                if (
                                    reverse[k].apns &&
                                    reverse[k].apns.accounts &&
                                    reverse[k].apns.accounts.indexOf(xnImId) != -1
                                ) {
                                    $(".j-session")
                                        .find(".panel_lastMsg")
                                        .eq(index)
                                        .html(
                                            '<span style="color:#f24c3d">[有人@我]</span><span style="color:#999"></span>'
                                        );
                                    // thisBrowserWindow.setTitle(appInfo.productName+'('+$('.u-unread').html()+'条消息)');
                                    break;
                                }
                                // $('.j-session').find('.panel_lastMsg').eq(index).text(result[index].lastMsg.fromNick+':'+result[index].lastMsg.text).css('color','#999');
                                // thisBrowserWindow.setTitle(appInfo.productName+'('+$('.u-unread').html()+'条消息)');
                            }
                            for (let i = 0; i < $(".panel_lastMsg").length; i++) {
                                if (
                                    $(".panel_lastMsg")[i].innerHTML.indexOf(
                                        '<span style="color:#f24c3d">[有人@我]</span>'
                                    ) != -1
                                ) {
                                    clearInterval(timer);
                                    count = 0;
                                    timer = setInterval(function () {
                                        count++;
                                        if (count % 2 == 0) {
                                            thisBrowserWindow.setProgressBar(1);
                                        } else {
                                            thisBrowserWindow.setProgressBar(-1);
                                        }
                                    }, 400);
                                    break;
                                }
                                clearInterval(timer);
                                count = 0;
                                thisBrowserWindow.setProgressBar(-1);
                            }
                        }
                    }
                }
            }
        }
    },
    /**
     * 最近联系人显示
     * @return {void}
     */
    buildConversations: function (id) {
        var sessions = JSON.parse(JSON.stringify(this.cache.getSessions()));
        var teams = JSON.parse(JSON.stringify(this.cache.getTeamlist()));
        var teamId = [];
        var alreadyTeam = [];
        var result = [];
        for (let i = 0; i < teams.length; i++) {
            alreadyTeam.push({ id: "team-" + teams[i].teamId, getMsg: teams[i].getMsg });
            teamId.push("team-" + teams[i].teamId);
        }
        for (let i = 0; i < sessions.length; i++) {
            if (sessions[i].scene == "team") {
                if (teamId.indexOf(sessions[i].id) != -1) {
                    sessions[i].getMsg = alreadyTeam[teamId.indexOf(sessions[i].id)].getMsg;
                    result.push(sessions[i]);
                }
            } else {
                result.push(sessions[i]);
            }
        }
        var data = {
            sessions: result,
        };
        if (!this.sessions) {
            var options = {
                data: data,
                onclickavatar: this.showInfo.bind(this),
                onclickitem: this.openChatBox.bind(this),
                infoprovider: this.infoProvider.bind(this),
            };
            this.sessions = new NIMUIKit.SessionList(options);
            this.sessions.inject(this.$conversations.get(0));
        } else {
            this.sessions.update(data);
        }
        //导航上加未读示例
        this.showUnread();
        this.doPoint();
        //已读回执处理
        this.markMsgRead(id);
        //@消息提示
        this.showPushMsg();
        //右键删除
        let that = this;
        let classObj = document.getElementsByClassName("panel_item");
        for (let i = 0; i < classObj.length; i++) {
            classObj[i].addEventListener(
                "contextmenu",
                function (e) {
                    let ev = e || window.event;
                    let account = $(this).attr("data-account");
                    ev.preventDefault();
                    $(".team-introduce").animate({ right: -260 }, 200);
                    currentId = $(this).attr("data-scene") + "-" + $(this).attr("data-account");
                    let currentTop = localStorage.getItem("currentTop")
                        ? JSON.parse(localStorage.getItem("currentTop"))
                        : [];
                    if (currentId.indexOf("team") != -1) {
                        yunXin.mysdk.notifyForNewTeamMsg({
                            teamIds: [$(this).attr("data-account")],
                            done: function (error, param) {
                                if (!error) {
                                    for (let key in param) {
                                        let menu = new Menu();
                                        menu.append(
                                            new MenuItem({
                                                label: "删除会话",
                                                visible: true,
                                                click: function () {
                                                    yunXin.delConversation(currentId);
                                                },
                                            })
                                        );
                                        menu.append(
                                            new MenuItem({
                                                label: param[key] == true ? "消息免打扰" : "开启消息提醒",
                                                visible: true,
                                                click: function () {
                                                    param[key] == true
                                                        ? yunXin.openMute(currentId, true)
                                                        : yunXin.openMute(currentId, false);
                                                },
                                            })
                                        );
                                        menu.append(
                                            new MenuItem({
                                                label: currentTop.indexOf(account) == -1 ? "置顶" : "取消置顶",
                                                visible: true,
                                                click: function () {
                                                    yunXin.toTop(account);
                                                },
                                            })
                                        );
                                        menu.popup(remote.getCurrentWindow());
                                    }
                                }
                            },
                        });
                    } else if (currentId.indexOf("p2p") != -1) {
                        let muteList = that.cache.getMutelist();
                        let muteId = [];
                        for (let i = 0; i < muteList.length; i++) {
                            muteId.push(muteList[i].account);
                        }
                        let menu = new Menu();
                        menu.append(
                            new MenuItem({
                                label: "删除会话",
                                visible: true,
                                click: function () {
                                    yunXin.delConversation(currentId);
                                },
                            })
                        );
                        menu.append(
                            new MenuItem({
                                label: muteId.indexOf(account) == -1 ? "消息免打扰" : "开启消息提醒",
                                visible: true,
                                click: function () {
                                    muteId.indexOf(account) == -1
                                        ? yunXin.openMute(currentId, true)
                                        : yunXin.openMute(currentId, false);
                                },
                            })
                        );
                        menu.append(
                            new MenuItem({
                                label: currentTop.indexOf(account) == -1 ? "置顶" : "取消置顶",
                                visible: true,
                                click: function () {
                                    yunXin.toTop(account);
                                },
                            })
                        );
                        menu.popup(remote.getCurrentWindow());
                    }
                },
                false
            );
        }
    },
    /*删除会话*/
    delConversation(currentId) {
        yunXin.mysdk.deleteLocalSession({
            id: currentId,
            done: function (error, param) {
                if (!error) {
                    for (let i = 0; i < $(".panel_item").length; i++) {
                        if (currentId.indexOf($(".panel_item").eq(i).attr("data-account")) != -1) {
                            $(".panel_item").eq(i).remove();
                            break;
                        }
                    }
                    for (let i = 0; i < yunXin.sessions.length; i++) {
                        if (yunXin.sessions[i].id == currentId) {
                            yunXin.sessions.splice(i, 1);
                            break;
                        }
                    }
                    yunXin.cache.setSessions(yunXin.sessions);
                    $(".chat-box").addClass("hide");
                    $("#j-chatEditor").addClass("hide");
                    $("#remind-list").addClass("hide");
                    $(".right-background").removeClass("hide");
                } else {
                    alert("删除会话失败");
                }
            },
        });
    },
    /*消息免打扰*/
    openMute(currentId, type) {
        if (currentId.indexOf("team") != -1) {
            let teamId = currentId.substring(5);
            yunXin.mysdk.updateInfoInTeam({
                teamId: teamId,
                muteTeam: type,
                muteNotiType: type ? 1 : 0,
                done: function (error, params) {
                    if (error) {
                        alert("修改失败！");
                    }
                },
            });
        } else {
            let personId = "";
            if (personId == xnImId) {
                alert("我的手机无法开启消息免打扰");
                return;
            }
            if (currentId.indexOf("xnnt") != -1) {
                personId = currentId.substring(4);
            } else {
                personId = currentId;
            }
            yunXin.mysdk.markInMutelist(personId, type, function (error, param) {
                if (error) {
                    alert("修改失败！");
                } else {
                    if (type) {
                        yunXin.cache.addToMutelist(param);
                    } else {
                        yunXin.cache.removeFromMutelist(param.account);
                    }
                    yunXin.buildConversations();
                }
            });
        }
    },
    /*置顶*/
    toTop: function (account) {
        let currentTop = localStorage.getItem("currentTop") ? JSON.parse(localStorage.getItem("currentTop")) : [];
        if (currentTop.indexOf(account) == -1) {
            currentTop.push(account);
        } else {
            currentTop.splice(currentTop.indexOf(account), 1);
        }

        localStorage.removeItem("currentTop");
        localStorage.setItem("currentTop", JSON.stringify(currentTop));
        yunXin.buildConversations();
    },

    /**
     * 点击群组列表头像
     * demo里跟点击列表处理一致了
     */
    clickTeamAvatar: function (account, type) {
        $("#j-teams").find("li.active").removeClass("active");
        this.openChatBox(account, type);
    },
    /**
     * 导航圆点显示
     */
    doPoint: function () {
        var $container;
        if (!this.$loadConversations.is(".hide")) {
            $container = this.$loadConversations;
        } else if (!this.$loadContacts.is(".hide")) {
            $container = this.$loadContacts;
        } else {
            $container = this.$loadTeams;
        }
        var $li = $container.find(".m-panel li");
        var $active = $li.map(function () {
            $(this).removeClass("active");
            if ($(this).attr("data-account") == $("#j-chatEditor").data("to")) {
                $(this).addClass("active");
                return this;
            }
        });
        if ($active.length) {
            var top = $active.offset().top - $container.offset().top + 105;
            this.$chatVernier.css("top", top).removeClass("hide");
        } else {
            this.$chatVernier.addClass("hide");
        }
    },
    // 导航上加未读数
    showUnread: function () {
        var counts = $("#j-conversations .panel_count");
        this.totalUnread = 0;
        if (counts.length != 0) {
            if (this.totalUnread != 99) {
                for (var i = counts.length - 1; i >= 0; i--) {
                    if ($(counts[i]).text() == "...") {
                        this.totalUnread = 99;
                        break;
                    } else {
                        this.totalUnread += parseInt($(counts[i]).text(), 10);
                    }
                }
            }
        }
        var $node = $(".m-unread .u-unread");
        var $showNum = $(".nav-message");
        if (Number(this.totalUnread) >= 99) {
            $node.text("99");
            $(".app-nav .u-unread").text("99");
        } else {
            $node.text(this.totalUnread);
            $(".app-nav .u-unread").text(this.totalUnread);
        }
        this.totalUnread ? $node.removeClass("hide") : $node.addClass("hide");
        this.totalUnread ? $(".app-nav .u-unread").removeClass("hide") : $(".app-nav .u-unread").addClass("hide");
        this.totalUnread ? $showNum.removeClass("xn-hidden") : $showNum.addClass("xn-hidden");
    },
    sendTextMessage: function () {
        let resultId = [];
        let content = $("#j-messageText").val();
        for (let i = 0; i < atId.length; i++) {
            let index = content.indexOf(atId[i].name);
            if (index != -1 && content.substring(index - 1, index) == "@") {
                resultId.push(atId[i].id);
            }
        }
        var scene = this.$chatEditor.data("type"),
            to = this.$chatEditor.data("to"),
            text = this.$messageText.val().trim();

        if (!!to && !!text) {
            if (text.length > 500) {
                alert("消息长度最大为500字符");
            } else if (text.length === 0) {
                return;
            } else {
                if (resultId.length != 0) {
                    let custom = {
                        type: "@",
                    };
                    let apns = {
                        accounts: resultId,
                        content: localStorage.getItem("nickName") + "在群里@了你",
                        forcePush: true,
                    };
                    this.mysdk.sendPushMessage(scene, to, text, custom, apns, this.sendMsgDone.bind(this));
                } else {
                    this.mysdk.sendTextMessage(scene, to, text, this.sendMsgDone.bind(this));
                }
            }
        }
    },

    /**
     * 发送消息完毕后的回调
     * @param error：消息发送失败时，error != null
     * @param msg：消息主体，类型分为文本、文件、图片、地理位置、语音、视频、自定义消息，通知等
     */
    sendMsgDone: function (error, msg) {
        atId = [];
        this.cache.addMsgs(msg);
        $("#j-messageText").val("");
        $("#j-chatContent").find(".no-msg").remove();
        var msgHtml = appUI.updateChatContentUI(msg, this.cache);
        $("#j-chatContent").append(msgHtml).scrollTop(99999);
        yunXin.msgSetting();
        $("#j-uploadForm").get(0).reset();
        document.getElementById("fileSend-mask").classList.add("hide");
    },
    /*@功能添加*/
    //设置光标位置
    setCursor: function (position) {
        let target = document.getElementById("j-messageText");
        if (target.setSelectionRange) {
            // IE Support
            target.focus();
            target.setSelectionRange(position, position);
        } else if (target.createTextRange) {
            // Firefox support
            var range = target.createTextRange();
            range.collapse(true);
            range.moveEnd("character", position);
            range.moveStart("character", position);
            range.select();
        }
    },
    remindMsg: function (e) {
        let ev = event || window.event || arguments.callee.caller.arguments[0];
        let $this = $("#j-messageText");
        let that = this;
        setTimeout(function () {
            if (ev.keyCode != 8 && ev.keyCode != 46) {
                oContent = $this.val();
            }
            let content = $this.val();
            let length = content.length;
            let target = document.getElementById("j-messageText");
            //搜索群内成员
            let keys = [38, 40, 13, 108, 16]; //上下键、enter键、shift键
            if (oContent.charAt(cursorPos - 1) == "@" && keys.indexOf(ev.keyCode) == -1) {
                /*获取当前光标的位置*/
                let endPos;
                if (document.selection) {
                    target.focus();
                    var selectRange = document.selection.createRange();
                    selectRange.moveStart("character", -target.value.length);
                    endPos = selectRange.text.length;
                } else if (target.selectionStart || target.selectionStart == "0") {
                    endPos = target.selectionStart;
                }
                /*获取搜索的关键字*/
                if (endPos >= cursorPos) {
                    searchKey = content.substring(cursorPos, endPos) || "";
                    if (searchKey.indexOf("@") == -1) {
                        //搜索的关键字不能有@
                        let html = "";
                        let currentName = [];
                        for (let i = 0; i < memberName.length; i++) {
                            if (memberName[i].name.indexOf(searchKey) != -1) {
                                currentName.push(memberName[i]);
                            }
                        }
                        for (let i = 0; i < currentName.length; i++) {
                            let avatar = getAvatar(
                                that.cache.getUserById(currentName[i].id)
                                    ? that.cache.getUserById(currentName[i].id).avatar
                                    : ""
                            );
                            html +=
                                '<li class="remind-item" data-num = ' +
                                i +
                                " data-id = " +
                                currentName[i].id +
                                " data-name = " +
                                currentName[i].name +
                                '><image style="width:30px;height:30px;margin-right:4px" src="' +
                                avatar +
                                '"/><span>' +
                                currentName[i].name +
                                "</span></li>";
                        }
                        $("#remind-list ul").html(html);
                        $("#remind-list ul .remind-item:last").addClass("memberActive");
                        $("#remind-list").removeClass("hide");
                        $("#remind-list").scrollTop($("#remind-list ul").height());
                        //根据搜索结果调整列表位置
                        let height = Number($("#remind-list").height());
                        if (height != 0 && height <= oHeight) {
                            $("#remind-list").css("top", oTop + (oHeight - height));
                        } else if ((currentName.length = memberName.length)) {
                            $("#remind-list").css("top", oTop);
                        }
                        if ($(".remind-item").length == 0) {
                            $("#remind-list").addClass("hide");
                        }
                    } else {
                        $("#remind-list").addClass("hide");
                        cursorPos = 0;
                    }
                } else {
                    $("#remind-list").addClass("hide");
                    cursorPos = 0;
                }
            }
            //当@选择列表出现的时候，功能按键的作用
            if (!$("#remind-list").hasClass("hide")) {
                if (ev.keyCode == 38) {
                    ev.preventDefault();
                    yunXin.setCursor(cursorPos);
                    let num = $("#remind-list").find(".memberActive").data("num") - 1;
                    if (num >= 0) {
                        $("#remind-list")
                            .find(".remind-item")
                            .eq(num)
                            .addClass("memberActive")
                            .siblings(".remind-item")
                            .removeClass("memberActive");
                        $("#remind-list").scrollTop(($(".remind-item").height() + 8) * num);
                    } else {
                        return;
                    }
                } else if (ev.keyCode == 40) {
                    ev.preventDefault();
                    yunXin.setCursor(cursorPos);
                    let num = $("#remind-list").find(".memberActive").data("num") + 1;
                    if (num <= $("#remind-list").find(".remind-item").length) {
                        $("#remind-list")
                            .find(".remind-item")
                            .eq(num)
                            .addClass("memberActive")
                            .siblings(".remind-item")
                            .removeClass("memberActive");
                        $("#remind-list").scrollTop(($(".remind-item").height() + 8) * num);
                    } else {
                        return;
                    }
                } else if (ev.keyCode == 13 || ev.keyCode == 108) {
                    // 按enter
                    ev.preventDefault();
                    let member = $("#remind-list").find(".memberActive").find("span").html();
                    if (searchKey) {
                        $("#j-messageText").val(
                            content.substring(0, cursorPos) + member + content.substring(cursorPos + searchKey.length)
                        );
                    } else {
                        $("#j-messageText").val(
                            content.substring(0, cursorPos) + member + content.substring(cursorPos)
                        );
                    }
                    let id = $(".memberActive").attr("data-id");
                    atId.push({ id: $(".memberActive").attr("data-id"), name: $(".memberActive").attr("data-name") });
                    let insetPos = cursorPos + member.length;
                    yunXin.setCursor(insetPos);
                    $("#remind-list").addClass("hide");
                    return;
                } else if (ev.keyCode == 8 || ev.keyCode == 46) {
                    //按删除键（backspace、delete）
                    if (oContent.charAt(cursorPos - 1) == "@" && !content.charAt(cursorPos - 1)) {
                        $("#remind-list").addClass("hide");
                    }
                }
            }
            //判断@列表出现
            if (!$("#j-teamInfo").hasClass("hide")) {
                let text = document.getElementById("j-messageText");
                let currentCursor;
                if (document.selection) {
                    text.focus();
                    var selectRange = document.selection.createRange();
                    selectRange.moveStart("character", -text.value.length);
                    currentCursor = selectRange.text.length;
                } else if (text.selectionStart || text.selectionStart == "0") {
                    currentCursor = target.selectionStart;
                }
                if (
                    (ev.shiftKey && ev.keyCode == 50) ||
                    (ev.shiftKey && ev.keyCode == 229 && content.charAt(currentCursor - 1) == "@")
                ) {
                    /*根据群ID获取群成员*/
                    let account = $("#j-chatEditor").data("to");
                    let team = that.cache.getTeamById(account);
                    let members = that.cache.getTeamMembers(account).members;
                    for (i = 0; i < members.length; i++) {
                        if (members[i].account == xnImId) {
                            members.splice(i, 1);
                        }
                    }
                    var array = [];
                    for (var i = 0; i < members.length; i++) {
                        if (!that.cache.getUserById(members[i].account)) {
                            array.push(members[i].account);
                        }
                    }
                    var showUI = function () {
                        memberName = [];
                        let html = "";
                        for (let i = 0; i < members.length; ++i) {
                            memberName.push({
                                id: members[i].account,
                                name:
                                    (team.serverCustom && JSON.parse(team.serverCustom).type) == "tenant"
                                        ? getRealName(members[i].account)
                                        : getNick(members[i].account),
                            });
                            let avatar = getAvatar(
                                that.cache.getUserById(members[i].account)
                                    ? that.cache.getUserById(members[i].account).avatar
                                    : ""
                            );
                            html +=
                                '<li class="remind-item" data-num = ' +
                                i +
                                " data-id = " +
                                members[i].account +
                                " data-name = " +
                                getNick(members[i].account) +
                                '><image style="width:30px;height:30px;margin-right:4px" src="' +
                                avatar +
                                '"/><span>' +
                                (team.serverCustom && JSON.parse(team.serverCustom).type == "tenant"
                                    ? getRealName(members[i].account)
                                    : getNick(members[i].account)) +
                                "</span></li>";
                        }
                        $("#remind-list ul").html(html);
                        $("#remind-list ul .remind-item:last").addClass("memberActive");
                        $("#remind-list").removeClass("hide");
                        $("#remind-list").scrollTop($("#remind-list ul").height());
                        /*获取当前光标位置*/
                        let target = document.getElementById("j-messageText");
                        if (document.selection) {
                            target.focus();
                            var selectRange = document.selection.createRange();
                            selectRange.moveStart("character", -target.value.length);
                            cursorPos = selectRange.text.length;
                        } else if (target.selectionStart || target.selectionStart == "0") {
                            cursorPos = target.selectionStart;
                        }
                        //待搜索的群成员列表定位
                        let resultContent = [];
                        for (let i = content.length; i >= 0; i--) {
                            resultContent.push(content[i]);
                        }
                        let n = -1;
                        if (resultContent.join("").indexOf("\n") != -1) {
                            n = content.length - resultContent.join("").indexOf("\n"); //最后一个换行符的位置
                        }
                        let re = new RegExp("\n", "g");
                        let rowI = content.substring(0, cursorPos).match(re) ? content.match(re).length : 0;
                        $("#contentTxtI").html(content.substring(0, cursorPos));
                        if (cursorPos >= n) {
                            $("#contentTxtII").html(content.substring(n, cursorPos));
                        } else {
                            let html = content.substring(cursorPos, n);
                            let resultHtml = [];
                            for (let i = html.length; i >= 0; i--) {
                                resultHtml.push(html[i]);
                            }
                            let m = -1;
                            if (resultContent.join("").indexOf("\n") != -1) {
                                m = html.length - resultHtml.join("").indexOf("\n"); //倒数第二个换行符的位置
                            }
                            $("#contentTxtII").html(content.substring(m, n));
                        }
                        let left =
                            $("#contentTxtII").width() % $("#j-messageText").width() == 0
                                ? $("#j-messageText").width()
                                : $("#contentTxtII").width() % $("#j-messageText").width();
                        let row = rowI + $("#contentTxtI").height() / $("#contentTxtII").height();
                        $("#remind-list").css({
                            left: left + 30,
                            top: 30 + (row - 1) * $("#contentTxtII").height() - $("#remind-list").height(),
                        });
                        oTop = 30 + (row - 1) * $("#contentTxtII").height() - $("#remind-list").height();
                        oHeight = $("#remind-list").height();
                    };
                    var getInfo = function (array) {
                        that.mysdk.getUsers(array, function (err, data) {
                            if (!err) {
                                for (var j = 0; j < data.length; j++) {
                                    that.cache.updatePersonlist(data[j]);
                                }
                                showUI();
                            } else {
                                console.log("获取用户信息失败");
                            }
                        });
                    };
                    if (array.length > 0) {
                        getInfo(array);
                    } else {
                        showUI();
                    }
                }
                if (length == 0) {
                    $("#remind-list").addClass("hide");
                }
            }
            //判断输入的换行以及发送
            if ($.trim(content).length > 0) {
                if ((ev.keyCode == 13 || ev.keyCode == 108) && ev.ctrlKey) {
                    //ctrl+enter 表示换行
                    $this.val(content + "\n");
                }
                if ((ev.keyCode == 13 || ev.keyCode == 108) && !ev.ctrlKey) {
                    //enter 表示发送
                    if ($("#remind-list").hasClass("hide")) {
                        yunXin.sendTextMessage();
                    }
                }
            }
        }, 150);
    },
    selectMember: function (e) {
        let ev = e || window.event;
        let content = $("#j-messageText").val();
        $("#remind-list").addClass("hide");
        if (searchKey) {
            $("#j-messageText").val(
                content.substring(0, cursorPos) + ev.target.innerText + content.substring(cursorPos + searchKey.length)
            );
        } else {
            $("#j-messageText").val(
                content.substring(0, cursorPos) + ev.target.innerText + content.substring(cursorPos)
            );
        }
        atId.push({ id: $(ev.target).attr("data-id"), name: $(ev.target).attr("data-name") });
        let insetPos = cursorPos + ev.target.innerText.length;
        yunXin.setCursor(insetPos);
    },
    memberHover: function (e) {
        let ev = e || window.event;
        $(ev.target).addClass("memberActive").siblings(".remind-item").removeClass("memberActive");
    },

    /**
     * 点击左边面板，打开聊天框
     */
    openChatBox: function (account, scene) {
        $(".msgSetting").remove();
        $(".right-background").addClass("hide");
        $(".chat-box").removeClass("hide");
        $("#j-chatEditor").removeClass("hide");
        $(".chat-content").css("bottom", 165);
        $("#remind-list").addClass("hide");
        var info;
        atId = [];
        this.mysdk.setCurrSession(scene, account);
        this.crtSession = scene + "-" + account;
        //根据帐号跟消息类型获取消息数据
        if (scene == "p2p") {
            if (!this.cache.getUserById(account)) {
                var that = this;
                this.mysdk.getUsers([account], function (err, data) {
                    if (!err) {
                        for (let i = 0; i < data.length; i++) {
                            that.cache.updatePersonlist(data[i]);
                        }
                        info = that.cache.getUserById(account);
                        that.setChatUI(scene, info, account);
                    } else {
                        console.log("获取用户信息失败");
                    }
                });
            } else {
                info = this.cache.getUserById(account);
                this.setChatUI(scene, info, account);
            }
        } else {
            info = this.cache.getTeamById(account);
            var that = this;
            this.mysdk.getTeamMembers(info.teamId, function (err, obj) {
                if (!err) {
                    that.cache.setTeamMembers(info.teamId, obj);
                    var arr = [];
                    for (let i = 0; i < obj.members.length; i++) {
                        if (!that.cache.getUserById(obj.members[i].account)) {
                            arr.push(obj.members[i].account);
                        }
                    }
                    if (arr.length != 0) {
                        that.mysdk.getUsers(arr, function (err, data) {
                            if (!err) {
                                for (let i = 0; i < data.length; i++) {
                                    that.cache.updatePersonlist(data[i]);
                                }
                                that.setChatUI(scene, info, account);
                            } else {
                                console.log("获取用户信息失败");
                            }
                        });
                    } else {
                        that.setChatUI(scene, info, account);
                    }
                } else {
                    alert(err.message);
                }
            });
        }
        //隐藏其他窗口
        $("#j-teamInfoContainer").addClass("hide");
        this.$devices.addClass("hide");
        this.$cloudMsgContainer.addClass("hide");
        //退群的特殊UI
        this.$rightPanel.find(".u-chat-notice").addClass("hide");
        this.$rightPanel.find(".chat-mask").addClass("hide");
        let item = JSON.parse(localStorage.getItem("sendFile"));
        if (item && item.account == account && item.scene == scene) {
            $("#j-chatContent").append(item.html).scrollTop(99999);
        }
    },
    //设置聊天面板
    setChatUI: function (scene, info, account) {
        if (scene === "p2p") {
            if (info.account == xnImId) {
                this.$nickName.text("我的手机");
                this.$chatTitle.find("img").attr("src", "images/myPhone.png");
            } else {
                let unionList = JSON.parse(localStorage.getItem("unionList"));
                this.$chatTitle.find("img").attr("src", "").attr("onerror", "this.src='images/advanced.png'");
                let isUnion = false;
                for (let i = 0; i < unionList.length; i++) {
                    if (info.account.indexOf(unionList[i].id) != -1) {
                        let name = unionList[i].nameAlt ? unionList[i].nameAlt : unionList[i].name;
                        this.$nickName.text(name);
                        this.$chatTitle
                            .find("img")
                            .attr("src", require("electron").remote.getGlobal("cdnUrl") + info.account + "/logo.jpg");
                        isUnion = true;
                        break;
                    } else {
                        continue;
                    }
                }
                if (!isUnion) {
                    this.$nickName.text(this.getNick(account));
                    this.$chatTitle.find("img").attr("src", getAvatar(info.avatar));
                }
            }
        } else {
            //群信息
            if (info) {
                if (info.avatar) {
                    this.$chatTitle.find("img").attr("src", info.avatar);
                } else {
                    this.$chatTitle.find("img").attr("src", "images/advanced.png");
                }
                this.$nickName.text(info.name);
            } else {
                //已经退出的群（不会出现）
                this.$rightPanel.find(".u-chat-notice").removeClass("hide");
                this.$rightPanel.find(".chat-mask").removeClass("hide");
                this.$chatTitle.find("img").attr("src", "images/advanced.png");
                this.$nickName.text(account);
            }
            this.$chatTitle.find("img").attr("onerror", "this.src='images/advanced.png'");
        }
        if (scene === "p2p") {
            this.$teamInfo.addClass("hide").attr({
                teamId: "",
                gtype: "",
            });
        } else {
            this.$teamInfo.removeClass("hide").data({
                teamId: account,
                gtype: info ? info.type : "normal",
            });
        }
        //会话信息
        this.$chatEditor.data({
            to: account,
            type: scene,
        });
        this.doPoint();
        // 根据或取聊天记录
        this.getHistoryMsgs(scene, account);
        //显示面板
        this.$rightPanel.removeClass("hide");
        this.$messageText.val("");
    },
    //消息操作
    msgSetting() {
        let readSettingObj = document.getElementsByClassName("readSetting");
        for (let i = 0; i < readSettingObj.length; i++) {
            readSettingObj[i].removeEventListener("click", msgListener);
            readSettingObj[i].addEventListener("click", msgListener);
        }
    },
    //删除消息
    deleteMsg() {
        yunXin.mysdk.getLocalMsgByIdClient(msgId, function (error, param) {
            if (!error) {
                yunXin.mysdk.deleteLocalMsg(param.msg, function (err, backData) {
                    if (!err) {
                        let account = yunXin.$chatEditor.data("type") + "-" + yunXin.$chatEditor.data("to");
                        let index = account.indexOf("-");
                        let msgs = yunXin.cache.getMsgs(account);
                        for (let i = 0; i < msgs.length; i++) {
                            if (backData.msg.idClient == msgs[i].idClient) {
                                yunXin.cache.deleteMsg(account, msgs[i].idClient);
                                yunXin.openChatBox(account.substring(index + 1), account.substring(0, index));
                                msgId = "";
                            }
                        }
                    }
                });
            }
        });
    },
    //转发消息
    forwardMsg: function () {
        $(".msgSetting").remove();
        $("#forward-mask").removeClass("hide");
        let selectList = [];
        let selectedList = [];
        let peopleList = yunXin.cache.getFriendslistOnShow();
        let teamList = yunXin.cache.getTeamlist();
        let html = "";
        $(".select-box .notice-close,.select-box .forward-cancle").on("click", function () {
            $("#forward-mask").addClass("hide");
            $(".candidate-box").html("");
            $(".selected-tip").html("已选择了0位联系人");
            $(".selected-box").html("");
            selectList = [];
            selectedList = [];
        });
        for (let i = 0; i < peopleList.length; i++) {
            selectList.push({
                account: peopleList[i].account,
                nick: getNick(peopleList[i].account),
                avatar: peopleList[i].avatar ? peopleList[i].avatar : "images/default-icon.png",
            });
        }
        for (let i = 0; i < teamList.length; i++) {
            selectList.push({
                account: "team-" + teamList[i].teamId,
                nick: teamList[i].name,
                avatar: teamList[i].avatar ? teamList[i].avatar : "images/advanced.png",
                error: "this.onerror=null;this.src='images/default-icon.png'",
            });
        }
        for (let i = 0; i < selectList.length; i++) {
            html +=
                '<li class="candidate-item" data-account="' +
                selectList[i].account +
                '" data-index="' +
                i +
                '"><img src="' +
                selectList[i].avatar +
                '" onerror = "' +
                selectList[i].error +
                '" style="width:35px;height:35px;"><span class="candidate-name">' +
                selectList[i].nick +
                '</span><span class="candidate-dot"><i class="glyphicon glyphicon-ok"></i></span></li>';
        }
        $(".candidate-box").html(html);
        $(".candidate-box .candidate-item").on("click", function () {
            if ($(this).children(".candidate-dot").hasClass("selected")) {
                $(this).children(".candidate-dot").removeClass("selected");
                for (let i = 0; i < selectedList.length; i++) {
                    if (selectedList[i].account == $(this).attr("data-account")) {
                        selectedList.splice(i, 1);
                    }
                }
            } else {
                $(this).children(".candidate-dot").addClass("selected");
                selectedList.push(selectList[$(this).attr("data-index")]);
            }
            let selectedHtml = "";
            for (let i = 0; i < selectedList.length; i++) {
                selectedHtml +=
                    '<li class="candidate-item" data-account="' +
                    selectedList[i].account +
                    '"><img src="' +
                    selectedList[i].avatar +
                    '" style="width:35px;height:35px;"><span class="candidate-name">' +
                    selectedList[i].nick +
                    "</span></li>";
            }
            $(".selected-tip").html("已选择了" + selectedList.length + "位联系人");
            $(".selected-box").html(selectedHtml);
        });
        $(".forward-send").on("click", function () {
            if (selectedList.length == 0) {
                return;
            }
            let forwardResult = [];
            for (let i = 0; i < selectedList.length; i++) {
                forwardResult.push({
                    scene: selectedList[i].account.indexOf("team") != -1 ? "team" : "p2p",
                    account:
                        selectedList[i].account.indexOf("team") != -1
                            ? selectedList[i].account.substring(5)
                            : selectedList[i].account,
                });
            }
            yunXin.mysdk.getLocalMsgByIdClient(msgId, function (error, param) {
                if (!error) {
                    for (let i = 0; i < forwardResult.length; i++) {
                        let msg = param.msg;
                        let scene = forwardResult[i].scene;
                        let account = forwardResult[i].account;
                        yunXin.mysdk.forwardMsg(msg, scene, account, function (err, data) {
                            if (!err) {
                                yunXin.cache.addMsgs(data);
                                $(".select-box .forward-cancle").click();
                                msgId = "";
                            }
                        });
                    }
                }
            });
        });
    },
    //收藏消息
    collectMsg: function () {
        $(".msgSetting").remove();
        yunXin.mysdk.getLocalMsgByIdClient(msgId, function (error, param) {
            if (!error) {
                let CreateCollect = new createCollect();
                CreateCollect.setunionId(xnUID);
                CreateCollect.setTime(new Date().Format("yyyy-MM-dd hh:mm:ss"));
                CreateCollect.setobjectId(param.idClient);
                CreateCollect.setobjectName($("#j-nickName").html());
                CreateCollect.setsourceId(param.msg.from);
                CreateCollect.setsourceName(param.msg.fromNick);
                CreateCollect.setsourceType("NIM_MESSAGE");
                if (param.msg.type == "text") {
                    //文本收藏
                    CreateCollect.setobjectType("TEXT");
                    CreateCollect.setobjectContent(param.msg.text);
                } else if (param.msg.type == "image") {
                    //图片收藏
                    CreateCollect.setobjectType("IMAGE");
                    CreateCollect.setobjectContent(param.msg.file.url);
                } else if (param.msg.type == "video") {
                    //视频收藏
                    CreateCollect.setobjectType("VIDEO");
                    CreateCollect.setobjectContent(param.msg.file.url);
                } else if (param.msg.type == "audio") {
                    //语音收藏
                    CreateCollect.setobjectType("AUDIO");
                    CreateCollect.setobjectContent(param.msg.file.url);
                } else if (param.msg.type == "file" && param.msg.file.url) {
                    CreateCollect.setobjectType("IMAGE");
                    CreateCollect.setobjectContent(param.msg.file.url);
                }
                xn_http_post(CreateCollect, function (data) {
                    if (data.message) {
                        alert(data.message);
                        return;
                    }
                    if (data.errors == null || data.errors.length > 0) {
                        alert(data.errors[0].message);
                    } else {
                        msgId = "";
                        alert("收藏成功");
                    }
                });
            }
        });
    },
    //图片另存为
    saveImgMsg: function () {
        let options = {
            title: "另存为...",
            defaultPath: "企信图片" + Number(new Date()) + ".jpg",
            filters: [{ name: "Images", extensions: ["jpg", "png", "gif"] }],
        };
        var request = require("request");
        var fs = require("fs");
        var { dialog } = require("electron").remote;
        dialog.showSaveDialog(options, function (address) {
            request(msgUrl).pipe(fs.createWriteStream(address));
        });
    },
    //文件另存为
    saveFileMsg: function () {
        $(".msgSetting").remove();
        let index = msgUrl.indexOf("download=");
        let name = decodeURI(msgUrl.substring(index + 9));
        let options = {
            title: "另存为...",
            defaultPath: name,
        };
        dialog.showSaveDialog(options, function (address) {
            request(msgUrl).pipe(fs.createWriteStream(address));
        });
    },
    //打开文件
    openFileMsg: function () {
        $(".msgSetting").remove();
        let index = msgUrl.indexOf("download=");
        let name = decodeURI(msgUrl.substring(index + 9));
        let fullPath = require("electron").remote.getGlobal("dirname") + "\\" + xnLoginAccount + "\\" + name;
        if (!fs.existsSync(require("electron").remote.getGlobal("dirname") + "\\" + xnLoginAccount)) {
            fs.mkdirSync(require("electron").remote.getGlobal("dirname") + "\\" + xnLoginAccount);
        }
        if (fs.existsSync(fullPath)) {
            shell.showItemInFolder(require("electron").remote.getGlobal("dirname") + "\\" + xnLoginAccount);
        } else {
            $("#fileOpen-mask").removeClass("hide");
            let openFile = request(msgUrl).pipe(fs.createWriteStream(fullPath));
            openFile.on("finish", function () {
                shell.beep();
                $("#fileOpen-mask").addClass("hide");
                shell.showItemInFolder(fullPath);
            });
        }
    },

    doChatUI: function (id) {
        let unionList = JSON.parse(localStorage.getItem("unionList"));
        let that = this;
        if (unionList != undefined && unionList != null) {
            for (let i = 0; i < unionList.length; i++) {
                if (id.indexOf(unionList[i].id) != -1) {
                    $("#j-chatEditor").addClass("hide");
                    $(".chat-content").css("bottom", 15);
                    break;
                }
            }
        }
        var temp,
            arr = [];
        let cacheMsgs = this.cache.getMsgs(id);
        let _this = this;
        for (let i = 0; i < cacheMsgs.length; i++) {
            if (!_this.cache.getUserById(cacheMsgs[i].from)) {
                arr.push(cacheMsgs[i].from);
            }
        }
        if (arr.length != 0) {
            _this.mysdk.getUsers(arr, function (err, data) {
                if (!err) {
                    for (let i = 0; i < data.length; i++) {
                        _this.cache.updatePersonlist(data[i]);
                    }
                    temp = appUI.buildChatContentUI(id, cacheMsgs, _this.cache);
                    _this.$chatContent.html(temp);
                    setTimeout(function () {
                        _this.$chatContent.scrollTop($("#j-chatContent")[0].scrollHeight + 9999);
                        _this.msgSetting();
                    }, 500);
                    //已读回执UI处理
                    _this.markMsgRead(id);
                } else {
                    console.log("获取用户信息失败");
                }
            });
        } else {
            temp = appUI.buildChatContentUI(id, cacheMsgs, this.cache);
            this.$chatContent.html(temp);
            setTimeout(function () {
                that.$chatContent.scrollTop($("#j-chatContent")[0].scrollHeight + 9999);
                yunXin.msgSetting();
            }, 500);
            //已读回执UI处理
            this.markMsgRead(id);
        }
    },
    /**
     * 获取当前会话消息
     * @return {void}
     */
    getHistoryMsgs: function (scene, account) {
        var id = scene + "-" + account;
        var sessions = this.cache.findSession(id);
        var msgs = this.cache.getMsgs(id);
        //标记已读回执
        this.sendMsgRead(account, scene);
        // if (!!sessions) {
        if (sessions.unread >= msgs.length) {
            var end = msgs.length > 0 ? msgs[0].time : false;
            this.mysdk.getLocalMsgs(id, this.getLocalMsgsDone.bind(this));
            return;
        }
        // }
        this.doChatUI(id);
    },

    getLocalMsgsDone: function (err, data) {
        if (!err) {
            this.cache.addMsgsByReverse(data.msgs);
            var id = data.sessionId;
            var array = getAllAccount(data.msgs);
            var that = this;
            this.checkUserInfo(array, function () {
                that.doChatUI(id);
            });
        } else {
            alert("获取历史消息失败");
        }
    },
    //检查用户信息有木有本地缓存 没的话就去拿拿好后在执行回调
    checkUserInfo: function (array, callback) {
        var arr = [];
        var that = this;
        for (var i = array.length - 1; i >= 0; i--) {
            if (!this.cache.getUserById(array[i])) {
                arr.push(array[i]);
            }
        }
        if (arr.length > 0) {
            this.mysdk.getUsers(arr, function (error, data) {
                if (!error) {
                    that.cache.setPersonlist(data);
                    callback();
                } else {
                    console.log("获取用户信息失败");
                }
            });
        } else {
            callback();
        }
    },
    //发送已读回执
    sendMsgRead: function (account, scene) {
        if (scene === "p2p") {
            var id = scene + "-" + account;
            var sessions = this.cache.findSession(id);
            this.mysdk.sendMsgReceipt(sessions.lastMsg, function (err, data) {
                if (err) {
                }
            });
        }
    },
    //UI上标记消息已读
    markMsgRead: function (id) {
        if (!id || this.crtSession !== id) {
            return;
        }
        var msgs = this.cache.getMsgs(id);
        for (var i = msgs.length - 1; i >= 0; i--) {
            var message = msgs[i];
            // 目前不支持群已读回执
            if (message.scene === "team") {
                return;
            }
            if (nim.isMsgRemoteRead(message)) {
                //$(".item.item-me.read").removeClass("read");
                $("#" + message.idClient).addClass("read");
                // break;
            }
        }
    },
    /**
     * 处理收到的消息
     * @param  {Object} msg
     * @return
     */
    doMsg: function (msg) {
        var that = this,
            who = msg.to === xnImId ? msg.from : msg.to,
            updateContentUI = function () {
                //如果当前消息对象的会话面板打开
                if ($("#j-chatEditor").data("to") === who) {
                    that.sendMsgRead(who, msg.scene);
                    var msgHtml = appUI.updateChatContentUI(msg, that.cache);
                    that.$chatContent.find(".no-msg").remove();
                    that.$chatContent.append(msgHtml).scrollTop(99999);
                    yunXin.msgSetting();
                }
            };
        //非群通知消息处理
        if (/text|image|file|audio|video|geo|custom|tip/i.test(msg.type)) {
            this.cache.addMsgs(msg);
            var account = msg.scene === "p2p" ? who : msg.from;
            //用户信息本地没有缓存，需存储
            if (!this.cache.getUserById(account)) {
                this.mysdk.getUser(account, function (err, data) {
                    if (!err) {
                        that.cache.updatePersonlist(data);
                        updateContentUI();
                    }
                });
            } else {
                this.buildConversations();
                updateContentUI();
            }
        } else {
            // 群消息处理
            notification.messageHandler(msg, updateContentUI);
        }
    },

    logout: function () {
        if (navigator.userAgent.indexOf("Linux") > -1 || navigator.userAgent.indexOf("Mac OS X") > -1) {
            const dialog = require("electron").remote.dialog;
            var dialogOption = {
                type: "question",
                title: "退出",
                buttons: ["确定", "取消"],
                defaultId: 0,
                message: "确定要退出" + appInfo.productName + "吗？",
                detail: "",
                cancelId: 1,
            };

            dialog.showMessageBox(dialogOption, function (e) {
                // e 是选择的目录
                if (e == 0) {
                    var xnLoginAccount = localStorage.getItem("xnLoginAccount");
                    var xnLoginPassword = localStorage.getItem("xnLoginPassword");
                    var xnLoginLength = localStorage.getItem("xnLoginLength");
                    localStorage.clear();
                    localStorage.setItem("xnLoginAccount", xnLoginAccount);
                    localStorage.setItem("xnLoginPassword", xnLoginPassword);
                    localStorage.setItem("xnLoginLength", xnLoginLength);
                    let currentWindows = BrowserWindow.getAllWindows();
                    for (let i = 0; i < currentWindows.length; i++) {
                        currentWindows[i].close();
                    }
                    require("electron").remote.app.quit();
                }
                console.log(e);
            });
        } else {
            thisBrowserWindow.setSkipTaskbar(true);
            thisBrowserWindow.hide();
        }

        // window.location.href = '/index.html';
    },
    miniApp: function () {
        require("electron").remote.BrowserWindow.getFocusedWindow().minimize();
    },

    maxApp: function () {
        if (require("electron").remote.getCurrentWindow().isMaximized()) {
            require("electron").remote.getCurrentWindow().restore();
        } else {
            require("electron").remote.getCurrentWindow().maximize();
        }
    },

    showDialog: function () {
        this.$logoutDialog.removeClass("hide");
        this.$mask.removeClass("hide");
    },

    hideDialog: function () {
        this.$logoutDialog.addClass("hide");
        this.$mask.addClass("hide");
    },
    showEmoji: function () {
        this.$emNode._$show();
    },
    // 语音播放
    playAudio: function () {
        if (!!window.Audio) {
            var node = $(this),
                btn = $(this).children(".j-play");
            node.addClass("play");
            setTimeout(function () {
                node.removeClass("play");
            }, parseInt(btn.attr("data-dur")));
            new window.Audio(btn.attr("data-src") + "?audioTrans&type=mp3").play();
        }
    },
    /**
     * 选择表情回调
     * @param  {objcet} result 点击表情/贴图返回的数据
     */
    cbShowEmoji: function (result) {
        if (!!result) {
            var scene = this.$chatEditor.data("type"),
                to = this.$chatEditor.data("to");
            // 贴图，发送自定义消息体
            if (result.type === "pinup") {
                var index = Number(result.emoji) + 1;
                content = {
                    type: 3,
                    data: {
                        catalog: result.category,
                        chartlet: result.category + "0" + (index >= 10 ? index : "0" + index),
                    },
                };
                this.mysdk.sendCustomMessage(scene, to, content, this.sendMsgDone.bind(this));
            } else {
                // 表情，内容直接加到输入框
                this.$messageText[0].value = this.$messageText[0].value + result.emoji;
            }
        }
    },
    /**
     * 多端同步好友信息处理
     * @param  {Object} data
     * @return {Void}
     */
    doSyncFriendAction: function (data) {
        var that = this,
            type = data.type;
        switch (type) {
            case "deleteFriend":
                this.cache.removeFriend(data.account);
                this.buildContacts();
                break;
            case "addFriend":
                this.cache.addFriend(data.friend);
                if (!this.cache.getUserById(data.account)) {
                    this.mysdk.getUser(account, function (err, data) {
                        if (!err) {
                            that.cache.updatePersonlist(data);
                            that.buildContacts();
                        }
                    });
                } else {
                    this.buildContacts();
                }
                break;
            case "applyFriend":
                this.cache.applyFriend(data.friend);
                if (!this.cache.getUserById(data.account)) {
                    this.mysdk.getUser(account, function (err, data) {
                        if (!err) {
                            that.cache.updatePersonlist(data);
                            that.buildContacts();
                        }
                    });
                } else {
                    this.buildContacts();
                }
                break;
            default:
                console.log(data);
                break;
        }
    },
    cloudDisk: function () {
        var controllerScope = $('div[ng-controller="PanIndexController"]').scope();
        controllerScope.doMenu(1);
    },
    tenantHome: function () {
        {
            var passportIdGetByUnionIdAndTenantIdRequest = new PassportIdGetByUnionIdAndTenantIdRequest();
            passportIdGetByUnionIdAndTenantIdRequest.setTenantId($("#unionName").attr("data-id"));
            passportIdGetByUnionIdAndTenantIdRequest.setUnionId(xnUID);
            xn_http_post(passportIdGetByUnionIdAndTenantIdRequest, function (data) {
                var authUrl = require("electron").remote.getGlobal("authUrl");
                var employeeUrl = require("electron").remote.getGlobal("employeeUrl");

                var url = (
                    authUrl +
                    "sso/autoLogin.do?token=#passportId#&returnUrl=" +
                    encodeURI(employeeUrl + "application.htm")
                ).replace("#passportId#", data.passportId);

                $("#j-tenantHome2").attr("src", url);

                var oFrm = document.getElementById("j-tenantHome2");
                oFrm.onload = oFrm.onreadystatechange = function () {
                    let menu = new Menu();
                    menu.append(new MenuItem({ label: "复制", role: "copy", visible: true }));
                    menu.append(new MenuItem({ label: "粘贴", role: "paste", visible: true }));
                    document.getElementById("j-tenantHome2").contentDocument.oncontextmenu = function (e) {
                        let ev = e || window.event;
                        ev.preventDefault();
                        menu.popup(remote.getCurrentWindow());
                    };
                    if (this.readyState && this.readyState != "complete") {
                        return;
                    } else {
                        $($("#j-tenantHome2").prop("contentWindow").document).find("a").prop("target", "_self");
                        $($("#j-tenantHome2").prop("contentWindow").document)
                            .find(".xn-header")
                            .css({ "background-color": "#282829" });
                        $($("#j-tenantHome2").prop("contentWindow").document)
                            .find(".xn-nav")
                            .css({ "background-color": "#282829" });
                        var shell = require("electron").shell;
                        $($("#j-tenantHome2").prop("contentWindow").document).on("click", "a", function (event) {
                            if (this.href.indexOf("xiniunet.com/employee/detail") >= 0) {
                                var authUrl = require("electron").remote.getGlobal("authUrl");

                                var url = (
                                    authUrl +
                                    "/sso/autoLogin.do?token=#passportId#&returnUrl=" +
                                    encodeURI(this.href)
                                ).replace("#passportId#", data.passportId);
                                event.preventDefault();
                                shell.openExternal(url);
                            } else if (this.href.indexOf("gitlab") >= 0 || this.href.indexOf("wiki") >= 0) {
                                event.preventDefault();
                                shell.openExternal(this.href);
                            }
                        });
                    }
                };
            });
        }
    },

    //撤回消息
    backoutMsg: function (id, data) {
        var msg = data ? data.msg : this.cache.findMsg(this.crtSession, id);
        var to = msg.target;
        var session = msg.sessionId;
        var opeAccount = msg.opeAccount || msg.from;
        var opeNick = getNick(opeAccount);
        if (msg.scene === "team") {
            var teamId = msg.to;
            var teamInfo = this.cache.getTeamById(teamId);
            if (teamInfo && opeAccount !== msg.from) {
                if (teamInfo.owner === opeAccount) {
                    opeNick = "群主" + opeNick;
                } else if (teamInfo.type === "advanced") {
                    opeNick = "管理员" + opeNick;
                }
            }
        }

        this.nim.sendTipMsg({
            isLocal: true,
            scene: msg.scene,
            to: to,
            tip: (xnImId === opeAccount ? "你" : opeNick) + "撤回了一条消息",
            time: msg.time,
            done: function (err, data) {
                if (!err) {
                    this.cache.backoutMsg(session, id, data);
                    if (this.crtSession === session) {
                        var msgHtml = appUI.buildChatContentUI(this.crtSession, this.cache);
                        this.$chatContent.html(msgHtml).scrollTop(99999);
                        //已读回执UI处理
                        this.markMsgRead(this.crtSession);
                    }
                } else {
                    alert("操作失败");
                }
            }.bind(this),
        });
    },
    /*通讯录*/
    /*左侧展开*/
    openMail: function () {
        $(".mailItem-title").off("click");
        $(".mailItem-title").on("click", function () {
            let selectId = $(this).parents(".mailItem").attr("id");
            if (selectId == "followBookList") {
                yunXin.getFollowFriend();
            } else if (selectId == "friendBookList") {
                yunXin.getFriends();
            } else if (selectId == "teamBookList") {
                yunXin.getTeamList();
            }
            if ($(this).children(".closeIcon").eq(0).hasClass("hide")) {
                $(this).children(".openIcon").eq(0).addClass("hide").siblings(".closeIcon").removeClass("hide");
                $(this).siblings("ul").eq(0).addClass("hide");
            } else if ($(this).children(".openIcon").eq(0).hasClass("hide")) {
                $(this).children(".closeIcon").eq(0).addClass("hide").siblings(".openIcon").removeClass("hide");
                $(this).siblings("ul").eq(0).removeClass("hide");
            }
        });
    },
    /*右侧展开*/
    openMailItem: function () {
        $(".collect-right").undelegate(".enterpriseItem", "click");
        $(".collect-right").delegate(".enterpriseItem", "click", function () {
            if ($(this).children(".closeIcon").eq(0).hasClass("hide")) {
                $(this).children(".openIcon").eq(0).addClass("hide").siblings(".closeIcon").removeClass("hide");
                $(this).removeClass("flag");
                $(this).next("ul").eq(0).addClass("hide");
            } else if ($(this).children(".openIcon").eq(0).hasClass("hide")) {
                $(this).children(".closeIcon").eq(0).addClass("hide").siblings(".openIcon").removeClass("hide");
                $(this).addClass("flag");
                $(this).next("ul").eq(0).removeClass("hide");
            }
            let id = $(this).attr("data-id");
            let tenantId = $(this).attr("data-tenantId");
            let _this = $(this);
            var branchQueryRequest = new BranchQueryRequest();
            branchQueryRequest.setParentId(id);
            branchQueryRequest.setTenantId(tenantId);
            xn_http_post(branchQueryRequest, function (data) {
                if (data.message) {
                    alert(data.message);
                    return;
                }
                if (data.errors == null || data.errors.length > 0) {
                    alert(data.errors[0].message);
                } else {
                    let branchList = data.branchList;
                    let personList = data.personList;
                    let html = "";
                    for (let i = 0; i < branchList.length; i++) {
                        let target = branchList[i];
                        html =
                            html +
                            '<div class="enterpriseItem" data-id="' +
                            target.id +
                            '" data-tenantId="' +
                            tenantId +
                            '"><img class="closeIcon" style="margin-right:10px" src="./images/mail-close.png"><img class="openIcon hide" style="margin-right:5px" src="./images/mail-open.png"><span>' +
                            target.name +
                            '</span><span style="color:#999">（' +
                            target.count +
                            '）</span></div><ul style="padding-left:20px"></ul>';
                    }
                    for (let i = 0; i < personList.length; i++) {
                        let target = personList[i];
                        let avatar = target.avatar ? target.avatar : "";
                        html =
                            html +
                            '<div class="peopleItem" data-id="' +
                            target.imId +
                            '" data-employeeid="' +
                            target.employeeId +
                            '"><img class="mailItem-avatar" style="vertical-align:middle" src="' +
                            getAvatar(avatar) +
                            '"><span>' +
                            target.name +
                            "</span></div>";
                    }
                    _this.next("ul").html(html);
                }
            });
        });
    },
    /*获取好友列表*/
    getFriends: function () {
        let friends = this.cache.getFriends();
        $("#friendBookList").find(".title-num").eq(0).html(friends.length);
        let html = "";
        for (let i = 0; i < friends.length; i++) {
            let target = this.cache.getUserById(friends[i].account);
            html =
                html +
                '<li class="mailItem-li" data-id="' +
                target.account +
                '"><img class="mailItem-avatar" src="' +
                getAvatar(target.avatar) +
                '"><span class="mailItem-name">' +
                getNick(target.account, this.cache) +
                "</span></li>";
        }
        $("#friendBookList").children("ul").eq(0).html(html);
        yunXin.selectMailItem();
    },
    /*获取群组列表*/
    getTeamList: function () {
        let teams = this.cache.getTeamlist();
        $("#teamBookList").find(".title-num").eq(0).html(teams.length);
        let html = "";
        for (let i = 0; i < teams.length; i++) {
            let target = teams[i];
            let avatar = target.avatar ? target.avatar : "./images/advanced.png";
            let errstr = "this.onerror=null;this.src='images/default-icon.png'";
            html =
                html +
                '<li class="mailItem-li" data-id="team-' +
                target.teamId +
                '"><img class="mailItem-avatar" src="' +
                avatar +
                '" onerror = "' +
                errstr +
                '"><span class="mailItem-name">' +
                target.name +
                '</span><span class="mailItem-num">' +
                target.memberNum +
                "</span></li>";
        }
        $("#teamBookList").children("ul").eq(0).html(html);
        yunXin.selectMailItem();
    },
    /*获取星标朋友*/
    getFollowFriend: function () {
        var FollowFriendGetRequest = new followFriendGetRequest();
        FollowFriendGetRequest.setUnionId(xnUID);
        xn_http_post(FollowFriendGetRequest, function (data) {
            if (data.message) {
                alert(data.message);
                return;
            }
            if (data.errors.length > 0) {
                alert(data.errors[0].message);
            } else {
                let html = "";
                $("#followBookList").find(".title-num").eq(0).html(data.result.length);
                for (let i = 0; i < data.result.length; i++) {
                    let target = yunXin.cache.getUserById(data.result[i].followImId);
                    if (target) {
                        html =
                            html +
                            '<li class="mailItem-li" data-id="' +
                            target.account +
                            '"><img class="mailItem-avatar" src="' +
                            getAvatar(target.avatar) +
                            '"><span class="mailItem-name">' +
                            getNick(target.account, yunXin.cache) +
                            "</span></li>";
                    } else {
                        yunXin.mysdk.getUser(data.result[i].followImId, function (err, data) {
                            if (!err) {
                                yunXin.cache.updatePersonlist(data);
                                let target = yunXin.cache.getUserById(data.account);
                                html =
                                    html +
                                    '<li class="mailItem-li" data-id="' +
                                    target.account +
                                    '"><img class="mailItem-avatar" src="' +
                                    getAvatar(target.avatar) +
                                    '"><span class="mailItem-name">' +
                                    getNick(target.account, yunXin.cache) +
                                    "</span></li>";
                            }
                        });
                    }
                }
                $("#followBookList").children("ul").eq(0).html(html);
                yunXin.selectMailItem();
            }
        });
    },
    /*左侧列表选择*/
    selectMailItem: function () {
        let target = document.getElementsByClassName("mailItem-li");
        for (let i = 0; i < target.length; i++) {
            target[i].removeEventListener("click", selectMailItem);
            target[i].addEventListener("click", selectMailItem);
        }
    },
    /*通讯录个人信息展示*/
    showPerson: function (id) {
        $("#personInfo-mask").removeClass("hide");
        let person = this.cache.getUserById(id);
        let alias = getNick(id, yunXin.cache);
        let gender = person.gender ? person.gender : "";
        let avatar = getAvatar(person.avatar);
        let friends = yunXin.cache.getFriends();
        let isFriend = false;
        for (let i = 0; i < friends.length; i++) {
            if (friends[i].account == id) {
                isFriend = true;
            }
        }
        let isMine = xnImId == id ? true : false;
        let genderPic = "";
        if (gender && gender == "male") {
            genderPic = '<img src="./images/person-male.png" style="vertical-align:text-bottom;margin-left:10px">';
        } else if (gender && gender == "female") {
            genderPic = '<img src="./images/person-female.png" style="vertical-align:text-bottom;margin-left:10px">';
        }
        /*通过imId查找unionId*/
        var unionFindRequest = new UnionFindRequest();
        unionFindRequest.setImIdList([id]);
        xn_http_post(unionFindRequest, function (data) {
            if (data.message) {
                $("#personInfo-mask").addClass("hide");
                alert(data.message);
                return;
            }
            if (data.errors.length > 0) {
                $("#personInfo-mask").addClass("hide");
                alert(data.errors[0].message);
            } else {
                if (data.result.length == 0) {
                    $("#personInfo-mask").addClass("hide");
                    let addFriendHtml =
                        !isFriend && !isMine
                            ? '<div id="bookAddFriend" class="addFriend" data-id="' + id + '">加好友</div>'
                            : '<div id="bookDelFriend" class="addFriend" data-id="' + id + '">解除好友</div>';
                    let aliasHtml =
                        isFriend && !isMine
                            ? '<div class="person-alias">备注名:<span id="changeAlias" data-id="' +
                              id +
                              '">' +
                              alias +
                              '</span><input type="text" class="alias-input hide"></div>'
                            : "";
                    let sendMsgHtml = !isMine ? '<div class="send-msg" data-id="' + id + '">发消息</div>' : "";
                    let html =
                        '<div id="person" class="person-information">' +
                        '<div class="person-top">' +
                        '<span class="person-name">' +
                        person.nick +
                        "</span>" +
                        genderPic +
                        aliasHtml +
                        addFriendHtml +
                        '<img src="' +
                        avatar +
                        '" class="person-avatar" style="margin-top:-90px">' +
                        "</div>" +
                        '<div class="tenant-tab"></div>' +
                        '<div class="person-middle">' +
                        "</div>" +
                        '<div class="person-bottom">' +
                        sendMsgHtml +
                        "</div>";
                    $("#personInfo-mask").addClass("hide");
                    $("#mailList .collect-right .enterprise .mailBook-content").html(html);
                    /*切换承租人*/
                    $("#person .tenant-item").on("click", function () {
                        let index = $(this).attr("data-index");
                        $(this)
                            .addClass("tenant-item-active")
                            .siblings(".tenant-item")
                            .removeClass("tenant-item-active");
                        let mobilePhone = ableUnionList[index].content.mobilePhone
                            ? ableUnionList[index].content.mobilePhone
                            : "";
                        let workEmail = ableUnionList[index].content.workEmail
                            ? ableUnionList[index].content.workEmail
                            : "";
                        let html =
                            '<div style="line-height:30px;"></div>' +
                            '<div style="line-height:30px;"><span class="person-tip">电话</span><span class="person-phone">' +
                            mobilePhone +
                            "</span></div>" +
                            '<div style="line-height:30px;"><span class="person-tip">邮箱</span><span class="person-mail">' +
                            workEmail +
                            "</span></div>";
                        $("#person .person-middle").html(html);
                    });
                    $("#person .tenant-item").eq(0).click();
                    /*发送消息*/
                    $("#person .send-msg").on("click", function () {
                        let account = $(this).attr("data-id");
                        $(".app-nav").eq(0).click();
                        yunXin.openChatBox(account, "p2p");
                    });
                    /*修改备注*/
                    $("#changeAlias").on("click", function () {
                        $(this).addClass("hide");
                        $(this).next("input").removeClass("hide").val($(this).html()).focus();
                    });
                    $(".alias-input").on("blur", function () {
                        yunXin.bookChangeAlias();
                    });
                    $(".alias-input").on("keydown", function (e) {
                        let ev = e || window.event;
                        if (ev.keyCode == 13 || ev.keyCode == 108) {
                            yunXin.bookChangeAlias();
                        }
                    });
                    yunXin.bookListFriend();
                    return;
                }
                let unionId = data.result[0].id;
                /*通过unionId查找用户基本信息*/
                var employeeProfileGetRequest = new EmployeeProfileGetRequest();
                employeeProfileGetRequest.setUnionId(unionId);
                xn_http_post(employeeProfileGetRequest, function (response) {
                    if (response.message) {
                        alert(response.message);
                        return;
                    }
                    if (response.errors.length > 0) {
                        alert(response.errors[0].message);
                    } else {
                        let userUnionId = [];
                        let unionList = JSON.parse(localStorage.getItem("unionList"));
                        for (let i = 0; i < unionList.length; i++) {
                            userUnionId.push(unionList[i].id);
                        }
                        let canUnionList = [];
                        for (let i = 0; i < response.result.length; i++) {
                            if (userUnionId.indexOf(response.result[i].tenantId) != -1) {
                                let name = unionList[userUnionId.indexOf(response.result[i].tenantId)].nameAlt
                                    ? unionList[userUnionId.indexOf(response.result[i].tenantId)].nameAlt
                                    : unionList[userUnionId.indexOf(response.result[i].tenantId)].name;
                                canUnionList.push({ name: name, content: response.result[i] });
                            }
                        }
                        let ableUnionList = [];
                        for (let i = 0; i < canUnionList.length; i++) {
                            if (userUnionId.indexOf(canUnionList[i].content.tenantId) != -1) {
                                ableUnionList.push(canUnionList[i]);
                            }
                        }
                        let tabHtml = "";
                        for (let i = 0; i < ableUnionList.length; i++) {
                            tabHtml +=
                                '<div class="tenant-item" data-index="' + i + '">' + ableUnionList[i].name + "</div>";
                        }
                        let addFriendHtml =
                            !isFriend && !isMine
                                ? '<div id="bookAddFriend" class="addFriend" data-id="' + id + '">加好友</div>'
                                : '<div id="bookDelFriend" class="addFriend" data-id="' + id + '">解除好友</div>';
                        let aliasHtml =
                            isFriend && !isMine
                                ? '<div class="person-alias">备注名:<span id="changeAlias" data-id="' +
                                  id +
                                  '">' +
                                  alias +
                                  '</span><input type="text" class="alias-input hide"></div>'
                                : "";
                        let sendMsgHtml = !isMine ? '<div class="send-msg" data-id="' + id + '">发消息</div>' : "";
                        let html =
                            '<div id="person" class="person-information">' +
                            '<div class="person-top">' +
                            '<span class="person-name">' +
                            person.nick +
                            "</span>" +
                            genderPic +
                            aliasHtml +
                            addFriendHtml +
                            '<img src="' +
                            avatar +
                            '" class="person-avatar" style="margin-top:-90px">' +
                            "</div>" +
                            '<div class="tenant-tab">' +
                            tabHtml +
                            "</div>" +
                            '<div class="person-middle">' +
                            "</div>" +
                            '<div class="person-bottom">' +
                            sendMsgHtml +
                            "</div>";
                        $("#personInfo-mask").addClass("hide");
                        $("#mailList .collect-right .enterprise .mailBook-content").html(html);
                        /*切换承租人*/
                        $("#person .tenant-item").on("click", function () {
                            let index = $(this).attr("data-index");
                            $(this)
                                .addClass("tenant-item-active")
                                .siblings(".tenant-item")
                                .removeClass("tenant-item-active");
                            let mobilePhone = ableUnionList[index].content.mobilePhone
                                ? ableUnionList[index].content.mobilePhone
                                : "";
                            let workEmail = ableUnionList[index].content.workEmail
                                ? ableUnionList[index].content.workEmail
                                : "";
                            let html =
                                '<div style="line-height:30px;"></div>' +
                                '<div style="line-height:30px;"><span class="person-tip">电话</span><span class="person-phone">' +
                                mobilePhone +
                                "</span></div>" +
                                '<div style="line-height:30px;"><span class="person-tip">邮箱</span><span class="person-mail">' +
                                workEmail +
                                "</span></div>";
                            $("#person .person-middle").html(html);
                        });
                        $("#person .tenant-item").eq(0).click();
                        /*发送消息*/
                        $("#person .send-msg").on("click", function () {
                            let account = $(this).attr("data-id");
                            $(".app-nav").eq(0).click();
                            yunXin.openChatBox(account, "p2p");
                        });
                        /*修改备注*/
                        $("#changeAlias").on("click", function () {
                            $(this).addClass("hide");
                            $(this).next("input").removeClass("hide").val($(this).html()).focus();
                        });
                        $(".alias-input").on("blur", function () {
                            yunXin.bookChangeAlias();
                        });
                        $(".alias-input").on("keydown", function (e) {
                            let ev = e || window.event;
                            if (ev.keyCode == 13 || ev.keyCode == 108) {
                                yunXin.bookChangeAlias();
                            }
                        });
                        yunXin.bookListFriend();
                    }
                });
            }
        });
    },
    /*群组信息展示*/
    showTeam: function (id) {
        let teamInfo = yunXin.cache.getTeamById(id.substring(5));
        let avatar = teamInfo.avatar ? teamInfo.avatar : "./images/advanced.png";
        let name = teamInfo.name;
        let errstr = "this.onerror=null;this.src='images/default-icon.png'";
        let html =
            '<div id="team" class="team-information"><div style="height:230px;display:flex;"><img class="team-avatar" src="' +
            avatar +
            '" onerror = "' +
            errstr +
            '"></div><div class="team-name">' +
            name +
            '</div><div class="person-bottom" style="margin-top:50px"><div class="send-msg" data-id="' +
            id.substring(5) +
            '">进入群聊</div></div></div>';
        $(".mailBook-content").html(html);
        $("#team .send-msg").on("click", function () {
            let account = $(this).attr("data-id");
            $(".app-nav").eq(0).click();
            yunXin.openChatBox(account, "team");
        });
    },
    /*企业通讯录个人信息展示*/
    showEnterprise: function () {
        $(".mailBook-content").undelegate(".peopleItem", "click");
        $(".mailBook-content").delegate(".peopleItem", "click", function () {
            let id = $(this).attr("data-id");
            let employeeId = $(this).attr("data-employeeid");
            if (employeeId == "undefined") {
                alert("暂不支持非企业用户信息查看");
                return;
            }
            $("#personInfo-mask").removeClass("hide");
            const originalHtml = $(".mailBook-content").html();
            const originalName = $(".enterprise .collect-name").html();
            let person = yunXin.cache.getUserById(id);
            let friends = yunXin.cache.getFriends();
            let isFriend = false;
            for (let i = 0; i < friends.length; i++) {
                if (friends[i].account == id) {
                    isFriend = true;
                }
            }
            let isMine = xnImId == id ? true : false;
            let avatar = getAvatar(person.avatar);
            let tenantId = $(".book-active").eq(0).attr("data-id").substring(7);
            var employeeDetailGetRequest = new EmployeeDetailGetRequest();
            employeeDetailGetRequest.setTenantId(tenantId);
            employeeDetailGetRequest.setId(employeeId);
            xn_http_post(employeeDetailGetRequest, function (data) {
                if (data.message) {
                    $("#personInfo-mask").addClass("hide");
                    alert(data.message);
                    return;
                }
                if (data.errors.length > 0) {
                    $("#personInfo-mask").addClass("hide");
                    alert(data.errors[0].message);
                } else {
                    let genderPic = "";
                    if (data.employeeDetail.sex && data.employeeDetail.sex == "M") {
                        genderPic = '<img src="./images/person-male.png" style="vertical-align:text-bottom">';
                    } else if (data.employeeDetail.sex && data.employeeDetail.sex == "W") {
                        genderPic = '<img src="./images/person-female.png" style="vertical-align:text-bottom">';
                    }
                    let addFriendHtml = !isMine
                        ? !isFriend
                            ? '<div id="bookAddFriend" class="addFriend" data-id="' + id + '">加好友</div>'
                            : '<div id="bookDelFriend" class="addFriend" data-id="' + id + '">解除好友</div>'
                        : '<div style="height:30px;"></div>';
                    let sendMsgHtml = !isMine ? '<div class="send-msg" data-id="' + id + '">发消息</div>' : "";
                    let localHtml =
                        '<div id="person" class="person-information">' +
                        '<div class="person-top">' +
                        '<span class="person-name">' +
                        data.employeeDetail.lastName +
                        data.employeeDetail.firstName +
                        "</span>" +
                        genderPic +
                        addFriendHtml +
                        '<img src="' +
                        avatar +
                        '" class="person-avatar">' +
                        '</div><div class="person-middle">' +
                        "</div>" +
                        '<div class="person-bottom">' +
                        sendMsgHtml +
                        "</div>";
                    $("#personInfo-mask").addClass("hide");
                    $(".enterprise .collect-name").html(
                        '<span class="active-name">' +
                            originalName +
                            '</span><img style="margin:0 10px;vertical-align:baseline" src="./images/mail-close.png"><span>' +
                            data.position.organizationName +
                            "</span>"
                    );
                    $("#mailList .collect-right .enterprise .mailBook-content")
                        .html(localHtml)
                        .css("background-color", "#fff");
                    let mobilePhone = data.employeeDetail.mobilePhone ? data.employeeDetail.mobilePhone : "";
                    let workEmail = data.employeeDetail.workEmail ? data.employeeDetail.workEmail : "";
                    let organizationName = data.position.organizationName ? data.position.organizationName : "";
                    let jobName = data.position.jobName ? data.position.jobName : "";
                    let html =
                        '<div style="line-height:30px;"></div>' +
                        '<div style="line-height:30px;"><span class="person-tip">电话</span><span class="person-phone">' +
                        mobilePhone +
                        "</span></div>" +
                        '<div style="line-height:30px;"><span class="person-tip">邮箱</span><span class="person-mail">' +
                        workEmail +
                        "</span></div>" +
                        '<div style="line-height:30px;"><span class="person-tip">部门</span><span class="person-department">' +
                        organizationName +
                        "</span></div>" +
                        '<div style="line-height:30px;"><span class="person-tip">职位</span><span>' +
                        jobName +
                        "</span></div>";
                    $("#person .person-middle").html(html);
                    /*发送消息*/
                    $("#person .send-msg").on("click", function () {
                        let account = $(this).attr("data-id");
                        $(".app-nav").eq(0).click();
                        yunXin.openChatBox(account, "p2p");
                    });
                    /*返回*/
                    $(".enterprise .collect-name .active-name").on("click", function () {
                        $(".enterprise .collect-name").html(originalName);
                        $(".mailBook-content").html(originalHtml);
                    });
                    yunXin.bookListFriend();
                }
            });
        });
    },
    /*添加或删除朋友*/
    bookListFriend: function () {
        $("#bookAddFriend").off("click");
        $("#bookDelFriend").off("click");

        $("#bookAddFriend").on("click", function () {
            let id = $(this).attr("data-id");
            yunXin.mysdk.applyFriend(id, function (error, params) {
                if (!error) {
                    alert("消息发送成功！");
                }
            });
        });
        $("#bookDelFriend").on("click", function () {
            let id = $(this).attr("data-id");
            let that = this;
            if (window.confirm("确定要删除好友？")) {
                yunXin.mysdk.deleteFriend(id, function (error, params) {
                    if (!error) {
                        alert("删除好友成功！");
                        yunXin.cache.removeFriend(params.account);
                        $(".app-nav").eq(1).click();
                        if ($(".enterprise .collect-name").html() == "") {
                            $(".collect-right").addClass("hide");
                        } else {
                            $(".collect-name .active-name").eq(0).click();
                        }
                    }
                });
            }
        });
    },
    /*修改昵称*/
    bookChangeAlias: function () {
        if ($(".alias-input").val().trim() != $("#changeAlias").html()) {
            let account = $("#changeAlias").attr("data-id");
            let alias = $(".alias-input").val().trim().substring(0, 16);
            yunXin.mysdk.updateFriend(account, alias, function (error, param) {
                if (!error) {
                    $("#changeAlias").html(param.alias).removeClass("hide").next("input").addClass("hide");
                    yunXin.cache.updateFriendAlias(param.account, param.alias);
                    $(".app-nav").eq(1).click();
                    yunXin.buildConversations();
                }
            });
        } else {
            $("#changeAlias").removeClass("hide").next("input").addClass("hide");
            $(".app-nav").eq(1).click();
            yunXin.buildConversations();
        }
    },
};

yunXin.init();

//非当前区域点击隐藏
var count = 0;

var getPar = function (tar) {
    if (tar.className == "search-name-div") {
        count++;
    }
    if (tar.parentNode) {
        getPar(tar.parentNode);
    }
};

$(document).on("click", "a", function (event) {
    if (this.href.indexOf("http://") >= 0 || this.href.indexOf("https://") >= 0) {
        var shell = require("electron").shell;
        event.preventDefault();
        var that = this;
        if (this.href.indexOf("xiniunet.com/mobileContent/articleDetail?id=") >= 0) {
            var articleId = this.href.substr(this.href.indexOf("articleDetail?id=") + "articleDetail?id=".length);
            var passportIdGetByUnionIdAndTenantIdRequest = new PassportIdGetByUnionIdAndTenantIdRequest();
            passportIdGetByUnionIdAndTenantIdRequest.setTenantId(that.getAttribute("data-id"));
            passportIdGetByUnionIdAndTenantIdRequest.setUnionId(xnUID);
            xn_http_post(passportIdGetByUnionIdAndTenantIdRequest, function (data) {
                var siteUrl = require("electron").remote.getGlobal("siteUrl");
                var authUrl = require("electron").remote.getGlobal("authUrl");

                var articleUrl = (siteUrl + "content/index/article.htm?id=#articleId#").replace(
                    "#articleId#",
                    articleId
                );
                var url = (authUrl + "sso/autoLogin.do?token=#passportId#&returnUrl=" + escape(articleUrl)).replace(
                    "#passportId#",
                    data.passportId
                );

                shell.openExternal(url);
            });
        } else if (this.href.indexOf("download") >= 0) {
            shell.openExternal(this.href);
        } else if (this.href.indexOf("imageView") >= 0) {
            if (localStorage.getItem("imgList")) {
                let currentWindows = BrowserWindow.getAllWindows();
                for (let i = 0; i < currentWindows.length; i++) {
                    if (currentWindows[i].getTitle() == "图片查看器") {
                        currentWindows[i].close();
                    }
                }
            }
            let arr = [];
            if (!$(".cloud-msg-container").hasClass("hide")) {
                arr = $(this).parents(".info-content").find(".cnt").children("a");
            } else {
                arr = $(this).parents(".chat-content").find(".cnt").children("a");
            }
            let hrefArr = [];
            for (let i = 0; i < arr.length; i++) {
                if (arr[i].href.indexOf("imageView") != -1) {
                    hrefArr.push(arr[i].getAttribute("href"));
                }
            }
            localStorage.setItem("imgList", JSON.stringify(hrefArr));
            localStorage.setItem("currentImg", this.href);
            let width = this.children[0].naturalWidth;
            let height = this.children[0].naturalHeight + 90;
            $("#imgOpen-mask").removeClass("hide");
            var imgWindow = new BrowserWindow({
                frame: false,
                center: true,
                resizable: true,
                width: width,
                height: height,
                minWidth: 330,
                minHeight: 420,
                useContentSize: true,
                show: false,
                webPreferences: {
                    webSecurity: false,
                    allowDisplayingInsecureContent: true,
                    allowRunningInsecureContent: true,
                },
            });
            imgWindow.loadURL("file://" + remote.getGlobal("dirname") + "/xnChat/page/imgList.html");
            imgWindow.setMenuBarVisibility(false);
            imgWindow.center();
            imgWindow.once("ready-to-show", () => {
                $("#imgOpen-mask").addClass("hide");
                imgWindow.show();
            });
        } else if ($.trim(this.innerHTML) == "下载") {
            shell.openExternal(this.href);
        } else {
            shell.openExternal(this.href);
        }
    }
});

//非当前区域点击隐藏承租人选项
var count1 = 0;

var getPar1 = function (tar) {
    if (tar.className == "logo-div") {
        count1++;
    }
    if (tar.parentNode) {
        getPar1(tar.parentNode);
    }
};

$("body").on("click", function (e) {
    count1 = 0;
    getPar1(e.target);
    if (count1 == 0) {
        $(".more-content").addClass("xn-hidden");
    }
});

var cutwords = function (input, num) {
    var cutNum = num || 2;
    if (input.length > cutNum) {
        return input.substr(input.length - cutNum, cutNum);
    } else {
        return input;
    }
};

//消息添加监听事件
function msgListener(e) {
    e.stopPropagation();
    let parentBox = $(e.target.parentNode);
    msgId = parentBox.attr("data-id");
    if (parentBox.find(".msgSetting").length == 0) {
        $(".msgSetting").remove();
        let content = "";
        if (parentBox.find("a").length != 0 && parentBox.find("a").eq(0).hasClass("download-file")) {
            msgUrl = parentBox.find("a").eq(0).attr("href");
            content =
                '<div class="msgSetting">' +
                '<div class="settingItem" id="forwardMsg" onclick="yunXin.forwardMsg()">转发</div>' +
                '<div class="settingItem" id="saveFile" onClick="yunXin.saveFileMsg()">另存为</div>' +
                '<div class="settingItem" id="openFile" onClick="yunXin.openFileMsg()">打开</div>' +
                '<div class="settingItem" id="deleteMsg" onclick="yunXin.deleteMsg()">删除</div>' +
                "</div>";
        } else if (parentBox.find("a").length != 0 && parentBox.find("a").eq(0).hasClass("download-img")) {
            msgUrl = parentBox.find("a").eq(0).attr("href");
            content =
                '<div class="msgSetting">' +
                '<div class="settingItem" id="forwardMsg" onclick="yunXin.forwardMsg()">转发</div>' +
                '<div class="settingItem" id="collectMsg" onclick="yunXin.collectMsg()">收藏</div>' +
                '<div class="settingItem" id="saveFile" onClick="yunXin.saveImgMsg()">另存为</div>' +
                '<div class="settingItem" id="deleteMsg" onclick="yunXin.deleteMsg()">删除</div>' +
                "</div>";
        } else {
            content =
                '<div class="msgSetting">' +
                '<div class="settingItem" id="forwardMsg" onclick="yunXin.forwardMsg()">转发</div>' +
                '<div class="settingItem" id="collectMsg" onclick="yunXin.collectMsg()">收藏</div>' +
                '<div class="settingItem" id="deleteMsg" onclick="yunXin.deleteMsg()">删除</div>' +
                "</div>";
        }
        parentBox.append(content);
    } else {
        $(".msgSetting").remove();
    }
}

//通讯录左侧列表点击监听事件
function selectMailItem(e) {
    $(".right-background").addClass("hide");
    $(".mailItem-li").removeClass("book-active");
    let target = null;
    if ($(e.target).hasClass("mailItem-li")) {
        target = $(e.target);
    } else {
        target = $(e.target).parents(".mailItem-li");
    }
    let id = target.attr("data-id");
    target.addClass("book-active");
    $("#mailList .collect-right").removeClass("hide");
    $("#mailList .collect-right .enterprise .mailBook-content").html("");
    /*选择企业*/
    if (id.indexOf("tenant") != -1) {
        $("#personInfo-mask").removeClass("hide");
        $("#mailList .collect-right .enterprise .collect-name")
            .html(target.find(".mailItem-name").eq(0).html())
            .css("border-bottom", "1px solid #e7e7e7")
            .siblings(".mailBook-content")
            .css("background-color", "#f3f3f3");
        let account = id.substring(7);
        var branchQueryRequest = new BranchQueryRequest();
        branchQueryRequest.setParentId("-1");
        branchQueryRequest.setTenantId(account);
        xn_http_post(branchQueryRequest, function (data) {
            if (data.message) {
                $("#personInfo-mask").addClass("hide");
                alert(data.message);
                return;
            }
            if (data.errors == null || data.errors.length > 0) {
                $("#personInfo-mask").addClass("hide");
                alert(data.errors[0].message);
            } else {
                let branchList = data.branchList;
                let personList = data.personList;
                let html = "";
                for (let i = 0; i < branchList.length; i++) {
                    let target = branchList[i];
                    html =
                        html +
                        '<div class="enterpriseItem" data-id="' +
                        target.id +
                        '" data-tenantId="' +
                        account +
                        '"><img class="closeIcon" style="margin-right:10px" src="./images/mail-close.png"><img class="openIcon hide" style="margin-right:5px" src="./images/mail-open.png"><span class="depart-name">' +
                        target.name +
                        '</span><span style="color:#999">（' +
                        target.count +
                        '）</span></div><ul style="padding-left:20px"></ul>';
                }
                for (let i = 0; i < personList.length; i++) {
                    let target = personList[i];
                    let avatar = target.avatar ? target.avatar : "";
                    html =
                        html +
                        '<div class="peopleItem" data-id="' +
                        target.imId +
                        '" data-employeeid="' +
                        target.employeeId +
                        '"><img class="mailItem-avatar" style="vertical-align:middle" src="' +
                        getAvatar(avatar) +
                        '"><span>' +
                        target.name +
                        "</span></div>";
                }
                $("#mailList .collect-right .enterprise .mailBook-content").html(html);
                $("#personInfo-mask").addClass("hide");
                yunXin.openMailItem();
                yunXin.showEnterprise();
            }
        });
    } else {
        $("#mailList .collect-right .enterprise .collect-name")
            .html("")
            .css("border-bottom", "none")
            .siblings(".mailBook-content")
            .css("background-color", "#fff");
        if (id.indexOf("team") == -1) {
            yunXin.showPerson(id);
        } else {
            yunXin.showTeam(id);
        }
    }
}

//tab
$(".xn-app-nav .app-nav").on("click", function () {
    $("#j-teamInfoContainer").addClass("hide");
    $(this).addClass("app-nav-active").siblings().removeClass("app-nav-active");
    var index = $(this).attr("data-index");
    if (index) {
        if (index == 2) {
            $("#con-left").addClass("xn-hidden");
            $("#j-rightPanel").addClass("xn-hidden");
            $("#j-devices").addClass("xn-hidden");
            $("#j-file").addClass("xn-hidden");
            $("#j-tenantHome").removeClass("xn-hidden");
            $("#xnApplication").addClass("xn-hidden");
            $("#xnHeaderXntalkWin").addClass("operating-win-layout-active");
            $("#j-cloudMsgContainer").addClass("hide");
            yunXin.tenantHome();
            $(".right-background").addClass("hide");
            let size = require("electron").remote.getCurrentWindow().getSize();
            if (Number(size[0]) < 1280 || Number(size[1] < 800)) {
                require("electron").remote.getCurrentWindow().setSize(1280, 800);
            }
            $("#Collection").addClass("hide");
            $("#mailList").addClass("hide");
        } else {
            let size = require("electron").remote.getCurrentWindow().getSize();
            if (Number(size[0]) <= 1280 || Number(size[1] <= 800)) {
                require("electron").remote.getCurrentWindow().setSize(1100, 735);
            }
            $("#j-cloudMsgContainer").addClass("hide");
            if (index == 1) {
                $("#con-left").removeClass("xn-hidden");
                $("#j-rightPanel").removeClass("xn-hidden");
                $("#j-devices").removeClass("xn-hidden");
                $("#j-file").addClass("xn-hidden");
                $("#no-message-con").addClass("xn-hidden");
                $("#j-tenantHome").addClass("xn-hidden");
                $("#j-community").addClass("xn-hidden");
                $("#xnApplication").addClass("xn-hidden");
                $("#xnHeaderXntalkWin").removeClass("operating-win-layout-active");
                $("#Collection").addClass("hide");
                $("#mailList").addClass("hide");
                if ($(".panel_item").hasClass("active")) {
                    $(".right-background").addClass("hide");
                } else {
                    $(".right-background").removeClass("hide");
                }
            } else if (index == 3) {
                $("#con-left").addClass("xn-hidden");
                $("#j-rightPanel").addClass("xn-hidden");
                $("#j-devices").addClass("xn-hidden");
                $("#j-file").addClass("xn-hidden");
                $("#j-tenantHome").addClass("xn-hidden");
                $("#j-community").addClass("xn-hidden");
                $("#no-message-con").addClass("xn-hidden");
                $("#xnApplication").removeClass("xn-hidden");
                $("#xnHeaderXntalkWin").removeClass("operating-win-layout-active");
                $("#Collection").addClass("hide");
                $("#mailList").addClass("hide");
                $(".right-background").addClass("hide");
            } else if (index == 4) {
                $("#con-left").addClass("xn-hidden");
                $("#j-rightPanel").addClass("xn-hidden");
                $("#j-devices").addClass("xn-hidden");
                $("#j-file").addClass("xn-hidden");
                $("#j-tenantHome").addClass("xn-hidden");
                $("#j-community").addClass("xn-hidden");
                $("#no-message-con").addClass("xn-hidden");
                $("#xnApplication").addClass("xn-hidden");
                $("#xnHeaderXntalkWin").removeClass("operating-win-layout-active");
                $("#Collection").removeClass("hide");
                $("#mailList").addClass("hide");
                $(".right-background").addClass("hide");
            } else if (index == 5) {
                $("#con-left").addClass("xn-hidden");
                $("#j-rightPanel").addClass("xn-hidden");
                $("#j-devices").addClass("xn-hidden");
                $("#j-file").removeClass("xn-hidden");
                $("#j-tenantHome").addClass("xn-hidden");
                $("#j-community").addClass("xn-hidden");
                $("#xnApplication").addClass("xn-hidden");
                $("#Collection").addClass("hide");
                $("#mailList").addClass("hide");
                $(".right-background").addClass("hide");
                //头部信息切换颜色
                $("#xnHeaderXntalkWin").removeClass("operating-win-layout-active");
                yunXin.cloudDisk();
            } else if (index == 6) {
                $("#con-left").addClass("xn-hidden");
                $("#j-rightPanel").addClass("xn-hidden");
                $("#j-devices").addClass("xn-hidden");
                $("#j-file").addClass("xn-hidden");
                $("#j-tenantHome").addClass("xn-hidden");
                $("#j-community").addClass("xn-hidden");
                $("#no-message-con").addClass("xn-hidden");
                $("#xnApplication").addClass("xn-hidden");
                $("#xnHeaderXntalkWin").removeClass("operating-win-layout-active");
                $("#Collection").addClass("hide");
                $("#mailList").removeClass("hide");
                $(".right-background").addClass("hide");
                yunXin.openMail();
                yunXin.getFriends();
                yunXin.getTeamList();
                yunXin.getFollowFriend();
            }
        }
    } else {
        $("#con-left").addClass("xn-hidden");
        $("#j-rightPanel").addClass("xn-hidden");
        $("#j-devices").addClass("xn-hidden");
        $("#j-file").addClass("xn-hidden");
        $("#j-tenantHome").addClass("xn-hidden");
        $("#no-message-con").removeClass("xn-hidden");
        $("#xnApplication").addClass("xn-hidden");
        $("#xnHeaderXntalkWin").removeClass("operating-win-layout-active");
    }
});

document.getElementById("j-messageText").addEventListener("contextmenu", function (e) {
    let ev = e || window.event;
    ev.preventDefault();
    let menu = new Menu();
    menu.append(new MenuItem({ label: "复制", role: "copy", visible: true }));
    menu.append(new MenuItem({ label: "粘贴", role: "paste", visible: true }));
    menu.popup(remote.getCurrentWindow());
});

(function () {
    $("#j-messageText").on("focus", function () {
        $("#j-chatEditor").addClass("chat-editor-active");
    });
    $("#j-chatEditor").on("click", function (event) {
        event.preventDefault();
        event.stopPropagation();
    });
    var documentClickBind = function (event) {
        if (event.target !== $("#j-chatEditor")) {
            $("#j-chatEditor").removeClass("chat-editor-active");
        }
        if (!$(".union-ul").hasClass("xn-hidden")) {
            $(".union-ul").addClass("xn-hidden");
        }
    };
    $(document).on("click", documentClickBind);
})();

//绘制应用
function drawApplication(tenantId) {
    var getApplicationAllListByUserId = new GetApplicationAllList();
    getApplicationAllListByUserId.setUnionId(xnUID);
    getApplicationAllListByUserId.setTenantId(tenantId);
    /*    var typeList=["MOBILE_WEB","XN_SMALL_PROGRAM"];
    getApplicationAllListByUserId.setTypeList(typeList);*/
    getApplicationAllListByUserId.setType("PC_SMALL_PROGRAM");
    xn_http_post(getApplicationAllListByUserId, function (data) {
        debugger;
        console.log(data);
        if (data.errors == null || data.errors.length > 0) {
            alert(data.errors[0].message);
        } else {
            drawDome(data.result || []);
        }
    });

    function drawDome(appList) {
        var drawDom = "";

        for (var i = 0; i < appList.length; i++) {
            var item = appList[i];
            var imgoss = "?x-oss-process=image/resize,m_fixed,w_80,h_80";
            drawDom +=
                '<div class="appApplication"  data-application="' +
                item.applicationCode +
                '" data-url="' +
                item.url +
                '" >' +
                '<div class="application-img" style="background-image:url(' +
                item.iconUrl +
                imgoss +
                ') "></div>' +
                '<div class="application-text">' +
                item.applicationName +
                "</div>" +
                '<div class="application-loading"><div class="application-loading-text">更新中...</div></div>' +
                "</div>";
        }
        $("#applicationList").html(drawDom);
    }
}

$("#xnApplication").on("click", ".application-refresh", function () {
    var tenantId = $("#unionList").find(".select-union .logo-name").attr("data-id");
    $("#applicationList").html("");
    drawApplication(tenantId);
});

/*切换承租人操作事件*/
function tabInitUnion(tenantId) {
    //重新获取切换小程序应用
    drawApplication(tenantId);
}

/*切换承租人*/
$(".union-ul").on("click", "li", function () {
    var tenantId = $(this).find(".logo-name").attr("data-id");
    console.log("tenantId", tenantId);
    tabInitUnion(tenantId);
});

var initApp = function () {
    "use strict";

    var ref = [
        // "createTenantGroupModule",
        "xn.directive.common",
        "xn.filter.common",
        "xn.service.common",
        "xn.directive.navigation",
        "xn.my.filter",
        "xn.my.pan",
        "xn.my.list",
        "ui.bootstrap",
        "xn.directive.form",
        "xn.personCard",
        "xn.cloudFileSelect",
        "xn.directive.location",
        "xn.addFriend",
        "xn.groupMemberAdd",
        "xn.directive.select",
        "xn.sendFile",
        "xn.createTenantGroup",
        "xn.contactSelect",
        "xn.bookSelect",
        "xn.atGroupMember",
    ];
    // var module = angular.module("xn", ref);
    var myApp = angular.module("xn", ref);
    myApp.value("xnConfig", {
        env: require("electron").remote.getGlobal("env"),
        platform: require("electron").remote.getGlobal("platform"),
        appInfo: JSON.parse(require("electron").remote.getGlobal("appInfo")),
    });

    myApp.controller("BodyController", [
        "$scope",
        "xnConfig",
        function ($scope, xnConfig) {
            $("#j-messageText").on("paste", contentHandler);
            $scope.global = {
                platform: xnConfig.platform, //系统环境xnConfig.platform
                showInfo: false,
                appInfo: xnConfig.appInfo,
            };

            //关于我们及更多设置
            $scope.showInfo = function (active) {
                $scope.global.showInfo = active;
                if (active) {
                    $(".xn-info-pop").removeClass("hide");
                } else {
                    $(".xn-info-pop").addClass("hide");
                }
                if (!$("#j-rightPanel").hasClass("hide")) {
                    return;
                }
                if (active && !$(".right-background").hasClass("hide")) {
                    $(".right-background").addClass("hide");
                } else if (!active && $("#j-rightPanel").hasClass("hide")) {
                    $(".right-background").removeClass("hide");
                }
            };

            function contentHandler(e) {
                var fs = require("fs");
                if (clipboard.readImage() && !clipboard.readImage().isEmpty()) {
                    var controllerScope = $('div[ng-controller="sendFileController"]').scope();
                    controllerScope.nativeImage = clipboard.readImage();
                    var buffer = controllerScope.nativeImage.toJPEG(80);
                    controllerScope.$apply(function () {
                        controllerScope.dataBase64 = controllerScope.nativeImage.toDataURL();
                        $(".mainCommon_css4").removeClass("hide");
                        controllerScope.eleSendFileIsShow = true;
                        controllerScope.setFile("粘贴图片.jpg", buffer.length);
                    });
                }
            }

            $scope.screenShot = function () {
                if (navigator.userAgent.indexOf("Linux") > -1 || navigator.userAgent.indexOf("Mac OS X") > -1) {
                    var electron = require("electron");
                    var Application = electron.remote.app;
                    var AppPath = remote.getGlobal("dirname") + "/xnChat/images/";
                    var screenshot = require("electron").remote.require("desktop-screenshot");
                    console.log(__dirname);
                    screenshot(AppPath + "screenshot.png", function (error, complete) {
                        if (error) console.log("Screenshot failed", error);
                        else {
                            var electron = require("electron"); // 控制应用生命周期的模块。
                            var BrowserWindow = electron.remote.BrowserWindow; // 创建原生浏览器窗口的模块
                            var size = require("electron").screen.getPrimaryDisplay().size;
                            var mainWindow = new BrowserWindow({
                                fullscreen: true,
                                alwaysOnTop: false, //transparent:true,thickFrame:false,  frame: false,  x:0, y:0, width:size.width, height:size.height,
                                webPreferences: {
                                    webSecurity: false,
                                    allowDisplayingInsecureContent: true,
                                    allowRunningInsecureContent: true,
                                },
                            });

                            mainWindow.setMenuBarVisibility(false);

                            if (require("electron").remote.getGlobal("isDebug") == true) {
                                mainWindow.openDevTools();
                            }
                            mainWindow.class = "screenShot";
                            console.log(__dirname);
                            mainWindow.loadURL(
                                "file://" + remote.getGlobal("dirname") + "/xnChat/page/screenShot.html"
                            );

                            mainWindow.on("closed", function () {
                                var clipboard = require("electron").clipboard;
                                var fs = require("fs");
                                if (clipboard.readImage() && !clipboard.readImage().isEmpty()) {
                                    var controllerScope = $('div[ng-controller="sendFileController"]').scope();
                                    controllerScope.nativeImage = clipboard.readImage();
                                    var buffer = controllerScope.nativeImage.toJPEG(80);
                                    controllerScope.setFile("粘贴图片.jpg", buffer.length);

                                    controllerScope.$apply(function () {
                                        controllerScope.dataBase64 = controllerScope.nativeImage.toDataURL();
                                        $(".mainCommon_css4").removeClass("hide");
                                        controllerScope.eleSendFileIsShow = true;
                                    });
                                }
                            });
                        }
                    });
                } else if (navigator.userAgent.indexOf("Window") > -1) {
                    clipboard.clear();
                    var exec = require("child_process").execFile;
                    var fun = function () {
                        exec(remote.getGlobal("dirname") + "/win.exe", function (error, stdout, stderr) {
                            if (error && (error.code == 27 || error.code == 112)) {
                                return;
                            }
                            var fs = require("fs");
                            if (clipboard.readImage() && !clipboard.readImage().isEmpty()) {
                                var controllerScope = $('div[ng-controller="sendFileController"]').scope();
                                controllerScope.nativeImage = clipboard.readImage();
                                var buffer = controllerScope.nativeImage.toJPEG(80);
                                controllerScope.setFile("粘贴图片.jpg", buffer.length);
                                controllerScope.$apply(function () {
                                    controllerScope.dataBase64 = controllerScope.nativeImage.toDataURL();
                                    $(".mainCommon_css4").removeClass("hide");
                                    controllerScope.eleSendFileIsShow = true;
                                });
                            }
                        });
                    };
                    fun();
                }
            };

            $scope.tabNav = function (name, router) {
                window.location.href =
                    "file://" + remote.getGlobal("dirname") + "/" + name + "/page/main.html#/" + router;
            };
        },
    ]);
    myApp.directive("createTenantGroup", function () {
        return {
            restrict: "EAC",
            templateUrl: "createTenantGroup.html",
            replace: true,
        };
    });

    myApp.directive("contactSelect", function () {
        return {
            restrict: "EAC",
            templateUrl: "contactSelect.html",
            replace: true,
            scope: true,
        };
    });

    myApp.directive("bookSelect", function () {
        return {
            restrict: "EAC",
            templateUrl: "bookSelect.html",
            replace: true,
            scope: true,
        };
    });

    myApp.directive("atGroupMember", function () {
        return {
            restrict: "EAC",
            templateUrl: "atGroupMember.html",
            replace: true,
        };
    });
};
