/**
 * Created by YQ on 2016/8/4.
 */

(function () {
    var personCardController = function ($rootScope, $scope, $http, $q, $location, $filter, myApp) {
        var qrcode = new QRCode(document.getElementById("qrcodeImg"), {
            text: "https://auth.xiniunet.com/app",
            width: 130,
            height: 130,
        });
        var xnUID = localStorage.getItem("uid");

        $scope.isSelf = false;
        $scope.vm = [];
        $scope.vm.name = "";
        $scope.vm.sex = "--";
        $scope.vm.birthDate = "";
        $scope.vm.provinceName = "-";
        $scope.vm.cityName = "-";
        $scope.tenants = [];
        $scope.personCardQrcodeShow = false;

        $scope.vm.nick = "--";
        $scope.closePersonCard = function () {
            $("#j-mask").addClass("hide");
            $("#div_personCard").addClass("hide");
        };

        $scope.personCardQrcodeShowClick = function () {
            qrcode.makeCode("xn_union_qrcode_" + $scope.imId);
            $scope.personCardQrcodeShow = !$scope.personCardQrcodeShow;
        };
        /*添加好友*/
        $scope.personCardAdd = function () {
            var user = $scope.user;
            var account = user.account;
            var unionId = user.unionId;
            myApp.yunXin.addFriendInBox(account, unionId);
            $scope.closePersonCard();
        };
        /*删除好友*/
        $scope.personCardRemove = function () {
            var user = $scope.user;
            var account = user.account;
            myApp.yunXin.removeFriend(account);
            $scope.closePersonCard();
        };
        /*编辑个人信息*/
        $scope.personCardUpdateClick = function () {
            var newNick = $scope.vm.nickNew.replace(/^\s+|\s+$/g, "");
            if (!newNick) {
                alert("昵称不能为空");
                return false;
            }
            if (newNick && newNick != $scope.vm.nick) {
                var uionUpdateNickNameRequest = new UnionUpdateNickNameRequest();
                uionUpdateNickNameRequest.setNickName(newNick);
                xn_http_post(uionUpdateNickNameRequest, function (data) {});
                $scope.vm.nick = newNick;
            }
            var birthDate =
                $("#personCardYead  option:selected").text().trim() +
                "-" +
                $("#personCardMonth  option:selected").text().trim() +
                "-" +
                $("#personCardDay  option:selected").text().trim();
            if (birthDate != $scope.vm.birthDate) {
                var unionUpdateBirthDateRequest = new UnionUpdateBirthDateRequest();
                unionUpdateBirthDateRequest.setBirthDate(birthDate);
                xn_http_post(unionUpdateBirthDateRequest, function (data) {
                    console.log(data);
                });
                $scope.vm.birthDate = birthDate;
            }
            if ($scope.vm.sexNew != undefined && $scope.vm.sexNew != null && $scope.vm.sex != $scope.vm.sexNew) {
                var unionUpdateGenderRequest = new UnionUpdateGenderRequest();
                if ($scope.vm.sexNew == "男") {
                    unionUpdateGenderRequest.setGender("M");
                } else if ($scope.vm.sexNew == "女") {
                    unionUpdateGenderRequest.setGender("W");
                }
                xn_http_post(unionUpdateGenderRequest, function (data) {
                    console.log(data);
                });
                $scope.vm.sex = $scope.vm.sexNew;
            }
            if (
                $scope.vm.provinceId != $("#selectProv  option:selected").val() ||
                $scope.vm.cityId != $("#selectCity  option:selected").val()
            ) {
                let provinceId = "";
                let provinceName = "";
                let cityId = "";
                let cityName = "";
                if ($("#selectProv  option:selected").text() != "请选择省份") {
                    provinceId = $("#selectProv  option:selected").val();
                    provinceName = $("#selectProv  option:selected").text();
                } else {
                    provinceId = "";
                    provinceName = "";
                }
                if ($("#selectCity  option:selected").text() != "请选择市") {
                    cityId = $("#selectCity  option:selected").val();
                    cityName = $("#selectCity  option:selected").text();
                } else {
                    cityId = "";
                    cityName = "";
                }
                console.log(provinceId, provinceName, cityId, cityName, "-----------");
                var unionUpdateAreaRequest = new UnionUpdateAreaRequest();
                unionUpdateAreaRequest.setCityId(cityId || null);
                unionUpdateAreaRequest.setProvinceId(provinceId || null);
                unionUpdateAreaRequest.setCityName(cityName);
                unionUpdateAreaRequest.setProvinceName(provinceName);
                xn_http_post(unionUpdateAreaRequest, function (data) {
                    console.log(data, "++++++++++++++++++++++");
                });
                $scope.vm.provinceId = provinceId;
                $scope.vm.provinceName = provinceName;
                $scope.vm.cityId = cityId;
                $scope.vm.cityName = cityName;
            }
            $scope.personCard.edit = false;
        };
        /*编辑*/
        $scope.personCardEdit = function () {
            if ($scope.vm.provinceName == "") {
                $("#selectProv  option:selected").text("请选择省份");
                $("#selectProv  option:selected").val("");
            } else {
                $("#selectProv  option:selected").text($scope.vm.provinceName);
                $("#selectProv  option:selected").val($scope.vm.provinceId);
            }
            if ($scope.vm.cityName == "") {
                $("#selectCity  option:selected").text("请选择市");
                $("#selectCity  option:selected").val("");
            } else {
                $("#selectCity  option:selected").text($scope.vm.cityName);
                $("#selectCity  option:selected").val($scope.vm.cityId);
            }
            $("#personCardYead  option:selected").text(new Date($scope.vm.birthDate).getFullYear());
            $("#personCardMonth  option:selected").text(new Date($scope.vm.birthDate).getMonth() + 1);
            $("#personCardDay  option:selected").text(new Date($scope.vm.birthDate).getDate());
            $scope.personCard.edit = true;
        };
        /*取消保存*/
        $scope.personCardCancle = function () {
            $scope.vm.nickNew = $scope.vm.nick;
            $scope.vm.sexNew = $scope.vm.sex;
            $("#selectProv  option:selected").val("");
            $("#selectCity  option:selected").val("");
            $("#selectProv  option:selected").text("");
            $("#selectCity  option:selected").text("");
            $("#personCardYead  option:selected").text("");
            $("#personCardMonth  option:selected").text("");
            $("#personCardDay  option:selected").text("");
            $scope.personCard.edit = false;
        };
        $scope.sendMsg = function () {
            let account = $scope.user.account;
            $scope.closePersonCard();
            yunXin.openChatBox(account, "p2p");
        };
        $rootScope.showPersonCard = function (userInfo) {
            $scope.vm.provinceName = "-";
            $scope.vm.cityName = "-";
            $scope.personCardQrcodeShow = false;
            $scope.vm = {};
            $scope.user = {};
            $scope.tenants = [];

            var personUnionId = "0";

            if (userInfo == null) {
                personUnionId = localStorage.getItem("imId");
                $scope.user = myApp.yunXin.cache.getUserById(personUnionId);
                $scope.isSelf = true;
                $scope.user.unionId = xnUID;
                setPersonCard();
            } else {
                $scope.user = userInfo;
                $scope.isSelf = false;
                var unionFindRequest = new UnionFindRequest();
                unionFindRequest.setImIdList([$scope.user.account]);
                xn_http_post(unionFindRequest, function (data) {
                    $scope.user.unionId = data.result[0].id;
                    setPersonCard();
                });
            }

            $scope.personCard.edit = false;
            $scope.head = getAvatar($scope.user.avatar);
            $scope.$apply(function () {
                $scope.user = userInfo;
            });
            setTimeout(function () {
                // 显示人员信息弹窗
                $("#j-mask").removeClass("hide");
                $("#div_personCard").removeClass("hide");
            }, 100);

            function setPersonCard() {
                $scope.vm = {};
                /*通过unionId查找用户基本信息*/
                var unionGetRequest = new UnionGetRequest();
                unionGetRequest.setId($scope.user.unionId);
                xn_http_post(unionGetRequest, function (data) {
                    $scope.$apply(function () {
                        var union = data.union;
                        console.log(union, "union++++++++++++++++++");
                        if (union.gender) {
                            if (union.gender == "W") {
                                $scope.vm.sex = "女";
                            } else if (union.gender == "M") {
                                $scope.vm.sex = "男";
                            } else {
                                $scope.vm.sex = "";
                            }
                        }
                        $scope.vm.name = getRealName($scope.user.account, yunXin.cache);
                        if (union.nickName != null && union.nickName != undefined) {
                            $scope.vm.nick = union.nickName;
                        }
                        if (union.birthDate != null && union.birthDate != undefined) {
                            $scope.vm.birthDate = $filter("date")(new Date(union.birthDate), "yyyy-MM-dd"); // $filter('dateFormat')(new Date(union.birthDate));

                            var index = new Date(Date.parse($scope.vm.birthDate)).getFullYear();
                            $("#personCardYead  option[value='###']".replace("###", index)).attr("selected", true);

                            index = new Date(Date.parse($scope.vm.birthDate)).getMonth();

                            $("#personCardMonth  option[value='###'] ".replace("###", index + 1)).attr(
                                "selected",
                                true
                            );
                            index = new Date(Date.parse($scope.vm.birthDate)).getDate();
                            $("#personCardDay  option[value='###'] ".replace("###", index)).attr("selected", true);
                        }

                        if (!!union.provinceId && !!union.provinceName) {
                            $scope.vm.provinceId = union.provinceId;
                            $scope.vm.provinceName = union.provinceName;
                            $("#selectProv").val(union.provinceId);
                            $("#selectProv").trigger("change");
                        } else {
                            $scope.vm.provinceId = "";
                            $scope.vm.provinceName = "";
                            $("#selectProv").val("");
                            $("#selectProv").trigger("change");
                        }
                        if (!!union.cityId && !!union.cityName) {
                            $scope.vm.cityId = union.cityId;
                            $scope.vm.cityName = union.cityName;
                            $("#selectCity").val(union.cityId);
                            $("#selectCity").trigger("change");
                        } else {
                            $scope.vm.cityId = "";
                            $scope.vm.cityName = "";
                            $("#selectCity").val("");
                            $("#selectCity").trigger("change");
                        }
                    });
                });
                /*通过unionId查找用户所有承租人信息*/
                var employeeProfileGetRequest = new EmployeeProfileGetRequest();
                employeeProfileGetRequest.setUnionId($scope.user.unionId);
                xn_http_post(employeeProfileGetRequest, function (response) {
                    if (response.message) {
                        alert(response.message);
                        return;
                    }
                    if (response.errors.length > 0) {
                        alert(response.errors[0].message);
                    } else {
                        let userUnionId = [];
                        let unionList = JSON.parse(localStorage.getItem("unionList"));
                        for (let i = 0; i < unionList.length; i++) {
                            userUnionId.push(unionList[i].id);
                        }
                        let canUnionList = [];
                        for (let i = 0; i < response.result.length; i++) {
                            if (userUnionId.indexOf(response.result[i].tenantId) != -1) {
                                let name = unionList[userUnionId.indexOf(response.result[i].tenantId)].nameAlt
                                    ? unionList[userUnionId.indexOf(response.result[i].tenantId)].nameAlt
                                    : unionList[userUnionId.indexOf(response.result[i].tenantId)].name;
                                canUnionList.push({
                                    name: name,
                                    content: response.result[i],
                                });
                            }
                        }
                        for (let i = 0; i < canUnionList.length; i++) {
                            if (userUnionId.indexOf(canUnionList[i].content.tenantId) != -1) {
                                $scope.tenants.push(canUnionList[i]);
                            }
                        }
                    }
                    $scope.$apply(function () {
                        $scope.user = $scope.user;
                        $scope.tenants = $scope.tenants;
                    });
                });
            }
        };
    };
    var myApp = angular.module("xn.personCard", []);
    myApp.service("myApp", function () {
        this.yunXin = yunXin;
    });
    myApp.config([
        "$locationProvider",
        function ($locationProvider) {
            $locationProvider.html5Mode(true);
        },
    ]);
    myApp.controller("personCardController", [
        "$rootScope",
        "$scope",
        "$http",
        "$q",
        "$location",
        "$filter",
        "myApp",
        personCardController,
    ]);
})();
