/**
 * 群组功能
 * @type {Object}
 */

var xnImId = localStorage.getItem("imId");
var teamId;
var teamInfo;

var myTeam = {
	init: function(cache,sdk) {
		this.cache = cache;
		this.sdk = sdk;
		this.addEvent();
	},
	addEvent: function() {
        $('#j-teamInfo').on('click', this.showTeamInfo.bind(this));
        $('.team-info-item').on('click', this.removeHover.bind(this));
		$('#j-userList').delegate('.hover','click', this.removeUser.bind(this));
		$('#j-userList').delegate('.avaPic','click', this.showUser.bind(this));
		$('#j-userList').delegate('#delete-teamMember','click', this.deleteTeamMemeber.bind(this));
        $('#j-userList').delegate('#add-teamMember', 'click', this.showUserList.bind(this,1));
		$('.team-member-addmore').on('click',this.expandList.bind(this));
		$('.switch').on('click',this.swithChange.bind(this));
		$('.team-name').on('click', this.editTeamName.bind(this));
		$('.team-nickName').on('click', this.editNickName.bind(this));
		$('.team-name,.team-notice,.team-nickName').on('mouseover', this.showEdit.bind(this));
		$('.team-name,.team-notice,.team-nickName').on('mouseout', this.hideEdit.bind(this));
		$('.changeName').on('blur', this.changeTeamName.bind(this));
		$('.changeNickName').on('blur', this.changeNickName.bind(this));
        $('.changeName,.changeNickName').on('keydown',this.editDone.bind(this));
        $('.team-notice').on('click',this.editNotice.bind(this));
        $('.notice-close').on('click',this.noticeClose.bind(this));
        $('.notice-send').on('click',this.noticeSend.bind(this));
        $('.delete-team').on('click',this.deleteTeam.bind(this));
	},

    /*显示群信息*/
    showTeamInfo: function(e) {
        let ev = e || window.event;
        ev.stopPropagation();
        var that = this;
        var right = $('.team-introduce').css('right') == '0px' ? -260:0;
        let topList = localStorage.getItem('currentTop')?JSON.parse(localStorage.getItem('currentTop')):[];
        $('.team-introduce').animate({right:right});
        // 获取群成员
        teamId = $('#j-teamInfo').data('teamId');
        teamInfo = that.cache.getTeamById(teamId);
        if(!teamInfo){
            return;
        }
        /*是否屏蔽群消息*/
        this.sdk.notifyForNewTeamMsg({
            teamIds:[teamId],
            done:function(error,params){
                if(!params[teamId]){
                    $('.switch-dot').eq(0).animate({left:25},200);
                    $('.switch').eq(0).css('background-color','#39f');
                }else{
                    $('.switch-dot').eq(0).animate({left:5},200);
                    $('.switch').eq(0).css('background-color','#cbcbcb');
                }
            }
        });
        /*是否置顶*/
        if(topList.indexOf(teamId) != -1){
            $('.switch-dot').eq(1).animate({left:25},200);
            $('.switch').eq(1).css('background-color','#39f');
        }else{
            $('.switch-dot').eq(0).animate({left:5},200);
            $('.switch').eq(0).css('background-color','#cbcbcb');
        }

        var type = teamInfo.type,
            teamName = teamInfo.name,
            announcement = teamInfo.announcement ? JSON.parse(teamInfo.announcement)[0].content:"暂无群公告",
            isTenant = teamInfo.serverCustom && JSON.parse(teamInfo.serverCustom).type == "tenant" ? true:false, //是否是企业群
            owner = teamInfo.owner,
            html = '',
            $userList = $('#j-userList'),
            members = that.cache.getTeamMembers(teamId).members;
        $('.team-name').attr('data-id',teamId).html(teamName);
        $('.team-notice').html(announcement);
        // //高级群
        var showMember = function () {
            let  array = [];
            for (let i = 0; i < members.length; i++) {
                let name = '';
                if(members[i].account == xnImId){  //显示我在群里的昵称
                    if(isTenant){
                        name = getRealName(members[i].account);
                    }else{
                        name = members[i].nickInTeam ? members[i].nickInTeam:getNick(members[i].account)
                    }
                    $('.team-nickName').html(name);
                }
                if (!that.cache.getUserById(members[i].account)) {
                    array.push(members[i].account)
                }
            }
            if (array.length > 0) {
                getInfo(array)
            } else {
                showUI()
            }
        };
        var showUI = function () {
            that.sortTeamMembers(members);
            if(members.length >15){
                $('.team-member-addmore').removeClass('hide');
            }else{
                $('.team-member-addmore').addClass('hide');
            }
            if (owner == xnImId) { // 当前用户是群主
                html += '<li class="first" id="add-teamMember" data-team-type="' + type + '" data-team-id="' + teamId + '"><i class="icon icon-plus" style="margin-left:3px;margin-right:0"></i><p class="team-member-name">添加</p></li><li id="delete-teamMember" class="first">一<p class="team-member-name">删除</p></li>'
            }
            for (var i = 0, l = members.length; i < l; ++i) {
                var member = members[i],
                    account = member.account,
                    avatar = getAvatar(that.cache.getUserById(account) ? that.cache.getUserById(account).avatar : ""),
                    nick = isTenant ? getRealName(account):getNick(account);
                html += '<li data-nick="' + nick + '" data-team-name="' + teamName + '" data-account="' + account + '" data-team-id="' + teamId + '"><a href="javascript:"><img data-nick="' + nick + '" data-team-name="' + teamName + '" data-account="' + account + '" data-team-id="' + teamId + '" class="avaPic" style="width:36px;height:36px;margin-left:7px;border-radius:3px" src="' + avatar + '"/>'
                if (member.type === 'owner') {
                    html += '<i class="icon radius-circle icon-user"></i>'
                } else {
                    html += '<span class="hover hide" data-nick="' + nick + '" data-team-name="' + teamName + '" data-account="' + account + '" data-team-id="' + teamId + '">移除</span>'
                }
                html += '</a><p class="team-member-name">' + nick + '</p></li>'
            }
            $userList.html(html);
        };
        var getInfo = function (array) {
            that.sdk.getUsers(array, function (err, data) {
                if (!err) {
                    for (var j = 0; j < data.length; j++) {
                        that.cache.updatePersonlist(data[j])
                    }
                    showUI()
                } else {
                    console.log("获取用户信息失败");
                }
            })
        };
        that.getTeamMembers(teamId, showMember);
    },
	/*修改群名称*/
	editTeamName: function() {
		if (teamInfo.owner == xnImId) {
			let content = $('.team-name').html();
			$('.changeName').removeClass('hide').val(content).focus();
			$('.team-name').addClass('hide');
		}
	},
    changeTeamName:function(){
		let changeName = true;
        if (teamInfo.owner == xnImId) {
            if ($('.changeName').val() === '') {
                alert('群名称不能为空')
            } else {
                let content = $('.changeName').val();
                if(content == $('.team-name').html()){
                    $('.changeName').addClass('hide');
                    $('.team-name').removeClass('hide');
                    return;
                }
                this.sdk.updateTeam({
                    teamId:$('.team-name').attr('data-id'),
                    name:content,
                    done: function (error, params) {
                        if (!error) {
                            let name = params.name;
                            $('.changeName').addClass('hide');
                            $('.team-name').html(name).removeClass('hide');
                        } else {
                            $('.changeName').val('').addClass('hide');
                            alert('群名称修改失败')
                        }
                    }
                })
            }
        }
    },
	/*修改用户昵称*/
	editNickName:function(e){
        let ev = e || window.event;
        if($(ev.target).siblings('.edit-icon').hasClass('hide')){
            return;
        }
        let content = $('.team-nickName').html();
        $('.team-nickName').addClass('hide');
        $('.changeNickName').removeClass('hide').val(content).focus();
	},
    changeNickName:function(){
        let content = $('.changeNickName').val();
        if(content == $('.team-nickName').html()){
            $('.team-nickName').removeClass('hide')
            $('.changeNickName').addClass('hide');
            return;
        }
        this.sdk.updateInfoInTeam({
            teamId:$('.team-name').attr('data-id'),
            nickInTeam:content,
            done: function (error, params) {
                if (!error) {
                    let name = params.nickInTeam;
                    $('.team-nickName').html(name).removeClass('hide');
                    $('.changeNickName').addClass('hide');
                } else {
                    $('.changeNickName').val('').addClass('hide');
                    alert('昵称修改失败')
                }
            }
        })
    },
	/*显示修改与否*/
    showEdit:function(e){
		let ev = e || window.event;
        // let teamId = $('.team-name').attr('data-id');
        // let teamInfo = this.cache.getTeamById(teamId);
		if($(ev.target).siblings('img') && teamInfo.announcement || teamInfo.owner == xnImId){
            $(ev.target).siblings('img').removeClass('hide');
		}
        if($(ev.target).hasClass('team-nickName') && teamInfo.serverCustom && JSON.parse(teamInfo.serverCustom).type == "tenant"){
            return;
        }
		if($(ev.target).hasClass('team-nickName') || teamInfo.owner == xnImId){
			if($(ev.target).siblings('.edit-icon')){
                $(ev.target).siblings('.edit-icon').removeClass('hide');
			}
		}
	},
    hideEdit:function(e){
        let ev = e || window.event;
        if($(ev.target).siblings('img')){
            $(ev.target).siblings('img').addClass('hide');
		}
        if($(ev.target).hasClass('team-nickName') || teamInfo.owner == xnImId){
            if($(ev.target).siblings('.edit-icon')){
                $(ev.target).siblings('.edit-icon').addClass('hide');
            }
        }
    },
	/*修改完成*/
    editDone:function(e){
		let ev = e || window.event;
		if(ev.keyCode == 13 || ev.keyCode == 108){
			if($(ev.target).hasClass('changeName')){
				this.changeTeamName();
			}else if($(ev.target).hasClass('changeNickName')){
                this.changeNickName();
			}
		}
	},
	/*处理通告（@所有人）*/
    editNotice:function(){
        let members = this.cache.getTeamMembers(teamId).members;
        let author;
        if(teamInfo.announcement){
            let announcement = JSON.parse(teamInfo.announcement);
            let authorId = teamInfo.owner;
            for(let i=0;i<members.length;i++){
                if(members[i].account.indexOf(authorId) != -1){
                    author = members[i];
                }
            }
            let avatar = getAvatar(this.cache.getUserById(author.account) ? this.cache.getUserById(author.account).avatar : "");
            let nick = author.nickInTeam ? author.nickInTeam : teamInfo.serverCustom && JSON.parse(teamInfo.serverCustom).type == "tenant" ? getRealName(author.account):getNick(author.account);
            if((Number(announcement[0].time) + '0').length == 14){
                let time = transTime(Number(announcement[0].time+'000'));
                $('.notice-time').html(time);
			}else if((Number(announcement[0].time) + '0').length == 11){
                let time = new Date(Number(announcement[0].time)*1000);
                let Y = time.getFullYear() + '-';
                let M = (time.getMonth()+1 < 10 ? '0'+(time.getMonth()+1) : time.getMonth()+1) + '-';
                let D = time.getDate() < 10 ? '0'+ time.getDate() + ' ':time.getDate() + ' ';
                let h = time.getHours() + ':';
                let m = time.getMinutes() < 10 ? '0'+time.getMinutes():time.getMinutes();
                $('.notice-time').html(Y+M+D+h+m);
			}else{
            	return;
			}
            $('.notice-avtar').attr('src',avatar);
            $('.notice-author').html(nick);
            if(teamInfo.owner == xnImId){
                $('.notice-text').removeAttr('readonly').val(announcement[0].content);
                $('.notice-send').removeClass('hide');
                $('#notice-mask').removeClass('hide');
                $('.cannot-edit').addClass('hide');
            }else{
                $('.notice-text').attr('readonly',true).val(announcement[0].content);
                $('.notice-send').addClass('hide');
                $('#notice-mask').removeClass('hide');
                $('.cannot-edit').removeClass('hide');
            }
		}else if(teamInfo.owner == xnImId){
        	let content = '';
        	let time = '';
        	if(teamInfo.announcement){
                let announcement = JSON.parse(teamInfo.announcement);
                content = announcement[0].content;
                time = transTime(announcement[0].time);
			}
            for(let i=0;i<members.length;i++){
                if(members[i].account.indexOf(xnImId) != -1){
                    author = members[i];
                }
            }
            let avatar = getAvatar(this.cache.getUserById(author.account) ? this.cache.getUserById(author.account).avatar : "");
            let nick = author.nickInTeam ? author.nickInTeam : teamInfo.serverCustom && JSON.parse(teamInfo.serverCustom).type == "tenant" ? getRealName(author.account):getNick(author.account);
            $('.notice-avtar').attr('src',avatar);
            $('.notice-author').html(nick);
            $('.notice-time').html(time);
            $('.notice-text').removeAttr('readonly').val(content);
            $('.notice-send').removeClass('hide');
            $('#notice-mask').removeClass('hide');
            $('.cannot-edit').addClass('hide');
		}
	},
	noticeSend:function(){
        let dialog = require('electron').remote.dialog;
        let that = this;
        let teamId = $('.team-name').attr('data-id');
        let members = this.cache.getTeamMembers(teamId).members;
        let membersId = [];
        for(let i=0;i<members.length;i++){
        	membersId.push(members[i].account);
		}
        let dialogOption = {
            type: 'question',
            title: '群公告',
            buttons: ['确定', '取消'],
            defaultId: 0,
            message: '该公告会发送全体群成员，是否发布？',
            detail: '',
            cancelId: 1
        };
        dialog.showMessageBox(dialogOption, function (e) {
            if(e == 0){
                let announcement = JSON.stringify([{"content":$('.notice-text').val(),"creator":xnImId,"time":String(new Date().getTime()).substring(0,10)}]);
                that.sdk.updateTeam({
                    teamId:teamId,
                    announcement:announcement,
					done:function(error,params){
                        if (!error) {
							let announcement = JSON.parse(params.announcement);
							let scene = 'team';
							let to = teamId;
							let text = '@所有人  '+announcement[0].content;
							let custom = {
                                type:'@'
							};
							let apns = {
                                accounts:membersId,
                                content:localStorage.getItem("nickName")+'在群里@了你',
                                forcePush:true,
							};
                            that.sdk.sendPushMessage(scene,to,text,custom,apns,yunXin.sendMsgDone.bind(that));
                            $('.team-introduce').animate({'right':-260},200);
                            $('#notice-mask').addClass('hide');
                        } else {
                            alert('发送失败！')
                        }
					}
				})
			}
		})
	},
	noticeClose:function(){
        $('.notice-send').addClass('hide');
        $('#notice-mask').addClass('hide');
	},
	/*删除并退出*/
    deleteTeam:function(){
        let dialog = require('electron').remote.dialog;
        let that = this;
        let dialogOption = {
            type: 'question',
            title: '删除并退出',
            buttons: ['确定', '取消'],
            defaultId: 0,
            message: '确定删除并退出群？',
            detail: '',
            cancelId: 1
        };
        dialog.showMessageBox(dialogOption, function (e) {
            if(e == 0){
            	if(teamInfo.owner == xnImId){
                    that.sdk.dismissTeam({
                        teamId:$('.team-name').attr('data-id'),
                        done:function(error,param){
                        	if(!error){
                                $('.chat-box').addClass('hide');
                                $('.right-background').removeClass('hide');
                                $('.team-introduce').animate({'right':-260},200);
                                yunXin.buildConversations();
							}
                        }
                    })
				}else{
                    that.sdk.leaveTeam({
                        teamId:$('.team-name').attr('data-id'),
                        done:function(error,param){
                            if(!error){
                                $('.chat-box').addClass('hide');
                                $('.right-background').removeClass('hide');
                                $('.team-introduce').animate({'right':-260},200);
                                yunXin.buildConversations();
                            }
                        }
                    })
				}
			}
		})
	},
	/*展开所有人*/
    expandList:function(){
		if($('.team-member-list').attr('style')){
            $('.team-member-list').removeAttr('style');
            $('.team-member-addmore').html('收起群成员');
		}else{
            $('.team-member-list').attr('style','max-height:260px');
            $('.team-member-addmore').html('查看更多群成员');
		}
	},
	/*按钮选择群功能处理*/
    swithChange:function(e){
    	let ev = e || window.event;
    	let index = $(ev.target).attr('data-num');
    	// let teamId = $('.team-name').attr('data-id');
    	// let teamInfo = this.cache.getTeamById(teamId);
    	if(index == 0){
    		if($('.switch-dot').eq(index).css('left') == '5px'){
				this.sdk.updateInfoInTeam({
					teamId:teamId,
                    muteTeam:true,
                    muteNotiType:1,
					done:function(error,params){
						if(error){
							alert('修改失败！')
						}
					}
				})
			}else{
                this.sdk.updateInfoInTeam({
                    teamId:teamId,
                    muteTeam:false,
                    muteNotiType:0,
                    done:function(error,params){
                        if(error){
                            alert('修改失败！')
                        }
                    }
                })
			}
		}else if(index == 1){
    		let currentTop = localStorage.getItem('currentTop')?JSON.parse(localStorage.getItem('currentTop')):[];
            if($('.switch-dot').eq(index).css('left') == '5px'){
                currentTop.push($('#j-userList .first').attr('data-team-id'));
                localStorage.removeItem("currentTop");
				localStorage.setItem('currentTop',JSON.stringify(currentTop));
				yunXin.buildConversations();
            }else{
				for(let i=0;i<currentTop.length;i++){
					if(currentTop[i] == $('#j-userList .first').attr('data-team-id')){
						currentTop.splice(i,1);
					}
				}
                localStorage.removeItem("currentTop");
                localStorage.setItem('currentTop',JSON.stringify(currentTop));
                yunXin.buildConversations();
            }
		}
    	let left = $('.switch-dot').eq(index).css('left') == '5px' ? 25:5;
    	let color = $('.switch-dot').eq(index).css('left') == '5px' ? '#39f':'#cbcbcb';
        $('.switch-dot').eq(index).animate({left:left},200);
        $('.switch').eq(index).css('background-color',color);
	},

	/*主动去拿群列表*/
    getTeamMembers:function (id, callback) {
        if (!(callback instanceof Function)) {
            callback = function () {}
        }
        var that = this
        this.sdk.getTeamMembers(id, function (err, obj) {
            if (!err) {
                that.cache.setTeamMembers(id, obj)
                callback()
            } else {
                alert(err.message)
            }
        })
    },
    sortTeamMembers:function (members) {
        if (!members || !members.length) return;
        members.sort(function (x, y) {
            if (x.type === "owner") {
                return -1
            } else if (y.type === "owner") {
                return 1
            } else if (x.type === "manager") {
                return -1
            } else if (y.type === "manager") {
                return 1
            } else {
                return 0
            }
        })
    },

    showUser:function(e){
        var controllerScope = $('div[ng-controller="personCardController"]').scope();  // Get controller's scope
        controllerScope.isBuddy = this.cache.isFriend($(e.target).attr('data-account'));
        let user = this.cache.getUserById($(e.target).attr('data-account'));
        controllerScope.imId = $(e.target).attr('data-account');
        controllerScope.showPersonCard(user);
    },

    removeHover:function(){
	    if(!$('.team-member-list .hover').hasClass('hide')){
            $('.team-member-list .hover').addClass('hide')
        }
    },

    deleteTeamMemeber:function(){
        if($('.team-member-list .hover').hasClass('hide')){
            $('.team-member-list .hover').removeClass('hide')
        }else{
            $('.team-member-list .hover').addClass('hide')
        }
    },

	removeUser: function(event) {	// 移除成员
		var ev = event || window.event,
			$target = $(ev.target),
			uid = $target.attr('data-account'),
			teamId = $target.data('team-id');
		this.sdk.removeTeamMembers({
			teamId: teamId,
			accounts: [uid],
			done: function(error, params) {
				if (error) {
					alert('移除成员失败');
				}else{
                    yunXin.buildConversations();
					$target.parents('li').remove();
                    $('#j-teamInfo').click();
				}
			}
		});
	},

    showUserList: function(type,teamType) {
        $('.team-introduce').animate({right:-260});
        if(type == 1)
        {
            var controllerScope = $('div[ng-controller="groupMemberAddController"]').scope();
            controllerScope.teamId =  $('#j-userList .first').data('team-id').toString();
            controllerScope.$apply(function () {
                controllerScope.eleCloudFileSelectisShow = true;
            });
            return;
        }
        var that = this;
        this.teamType = teamType;
        this.$createTeamContainer.load('./create-team.html', function() {
            $("#j-devices").addClass('hide');
            that.$createTeamContainer.removeClass('hide');
            that.$mask.removeClass('hide');
            var $addIcon = $('#j-userList .first'),
                $addUserUl = $('#j-addUserList ul'),
                list = that.cache.getFriendslistOnShow(),
                tmp = '',
                teamId = '',
                members = [];
            // 好友列表
            for (var i = 0, l = list.length; i < l; ++i) {
                if (list[i].uid !== xnImId) { // 除自己以外
                    tmp += appUI.buildTeamMemberList(list[i]);
                }
            }
            $addUserUl.html(tmp);
            if (type !== 0) {
                teamId = $addIcon.data('team-id');
                that.sdk.getTeamMembers({
                    teamId: teamId,
                    done: function(error, obj) {
                        //给已经在群的好友标记
                        members = error ? getMembersById(teamId) : obj.members; // 群成员列表
                        for (var i = 0, l = members.length; i < l; ++i) {
                            var uid = members[i].account || members[i].uid;
                            $addUserUl.find('[data-uid="' + uid + '"] i').addClass('cur2');
                        }
                    }
                });
                //用来区分是否创群
                that.addTag = true;
            } else {
                //不是创建群
                that.addTag = false;
            }

        });
    },
};

$(document).on('click',function(){
	$('.team-introduce').animate({'right':-260},200);
});
$('#j-chatEditor').on('click',function(){
    $('.team-introduce').animate({'right':-260},200);
});
$('.groupMemberAdd_css1,.team-introduce,#notice-mask').on('click',function(e){
    let ev = e || window.event;
    ev.stopPropagation();
});
