var xnImId = localStorage.getItem("imId");
var appUI = {
    /**
     * 当前会话聊天面板UI
     */
    buildChatContentUI:function(id,cacheMsg,cache){
    	var msgHtml = "",
            times = [],
            msgs = [];
    	for(let i=0;i<cacheMsg.length;i++){
            if(times.indexOf(cacheMsg[i].time) == -1){
                times.push(cacheMsg[i].time);
                msgs.push(cacheMsg[i]);
            }else{
                continue;
            }
        }
            if(msgs.length===0){
                msgHtml = '<div class="no-msg tc"><span class="radius5px">暂无消息</span></div>';
            }else{
                for (var i = 0, l = msgs.length; i < l; ++i) {
                    var message = msgs[i],
                        user = cache.getUserById(message.from),
                        content = message.content? JSON.parse(message.content):null;
                    if(message.type == 'custom' && content && content.type == 8){
                        continue;
                    }
                    //消息时间显示
                    if(i == 0){
                        msgHtml += this.makeTimeTag(transTime(message.time));
                    }else{
                        if(message.time-msgs[i-1].time>5*60*1000){
                            msgHtml += this.makeTimeTag(transTime(message.time));
                        }
                    }
                    msgHtml += this.makeChatContent(message,user, cache);
                }
            }
        return msgHtml;
    },

    /**
     * 更新当前会话聊天面板UI
     */
    updateChatContentUI:function(msg,cache){
	 	var lastItem =$("#j-chatContent .item").last(),
        	msgHtml="",
        	user =cache.getUserById(msg.from);
        if(user == undefined || user == null || !user){
            yunXin.mysdk.getUsers([msg.from], function(err, data){
                if (!err) {
                    for (var j = 0; j < data.length; j++) {
                        cache.updatePersonlist(data[j])
                    }
                    user = cache.getUserById(msg.from);
                    if(lastItem.length==0){
                        msgHtml += this.makeTimeTag(transTime(msg.time));
                    }else{
                        if(msg.time-parseInt(lastItem.attr('data-time'))>5*60*1000){
                            msgHtml += this.makeTimeTag(transTime(msg.time));
                        }
                    }
                    msgHtml += this.makeChatContent(msg,user, cache);
                    return msgHtml;
                } else {
                    console.log("获取用户信息失败");
                }
            })
        }else{
            if(lastItem.length==0){
                msgHtml += this.makeTimeTag(transTime(msg.time));
            }else{
                if(msg.time-parseInt(lastItem.attr('data-time'))>5*60*1000){
                    msgHtml += this.makeTimeTag(transTime(msg.time));
                }
            }
            msgHtml += this.makeChatContent(msg,user, cache);
            return msgHtml;
        }
    },

    /**
     * 通用消息内容UI
     */
    makeChatContent:function(message,user, cache){
    	var msgHtml;
    	var teamInfo = '';
    	if(message.scene == 'team'){
            teamInfo = cache.getTeamById(message.sessionId.substring(message.sessionId.indexOf('-')+1));
        }
    	//通知类消息
		if (message.attach && message.attach.type) {
                var notificationText = transNotification(message);
                msgHtml =  '<p class="u-notice tc item" data-time="'+ message.time +'" data-id="'+ message.idClient +'" data-idServer="'+ message.idServer +'"><span class="radius5px">'+notificationText+'</span></p>';
        }else{
            //聊天消息
            let unionList = JSON.parse(localStorage.getItem('unionList'));
            /*判断是否是承租人消息*/
            for(let i=0;i<unionList.length;i++){
                if(user.account && user.account.indexOf(unionList[i].id) != -1){
                    user.avatar = require('electron').remote.getGlobal('cdnUrl') + user.account+'/logo.jpg';
                    user.isTenant = true;
                    break;
                }
            }
			var type = message.type,
				from = message.from,
                avatar = user.avatar,
				showNick = message.scene === 'team' && from !== xnImId,//群消息显示姓名，个人消息不显示
                content = message.content? JSON.parse(message.content):null,
                isTenant = user.isTenant?true:false,//是否是承租人消息
                msgHtml;
            if(type==="tip"){
                msgHtml ='<p class="u-notice tc item" data-time="'+ message.time +'" data-id="'+ message.idClient +'" data-idServer="'+ message.idServer +'"><span class="radius5px">'+getMessage(message)+'</span></p>';
            }else{
                var name = teamInfo.serverCustom && JSON.parse(teamInfo.serverCustom).type == "tenant" ? getRealName(from):getNick(from);

                //红包
                if(type == 'custom' && content && content.type == 7){
                    let text = (from == xnImId)?'发出红包，请在手机上查看':'收到红包，请在手机上查看';
                    msgHtml ='<p class="u-notice tc item" data-time="'+ message.time +'" data-id="'+ message.idClient +'" data-idServer="'+ message.idServer +'"><span class="radius5px">'+ text + '</span></p>';
                    return msgHtml;
                }
                //图文消息
                if(type == 'custom' && content && content.type == 30){
                    let text = (from == xnImId)?'[您发送一条图文消息，请在手机端查看]':'[您收到一条图文消息，请在手机端查看]';

                    msgHtml = ['<div data-time="'+ message.time +'" data-id="'+ message.idClient +'" id="'+ message.idClient +'" data-idServer="'+ message.idServer +'" class="item item-' + buildSender(message) + '">',
                        '<img class="img j-img" src="'+getAvatar(avatar)+'" onerror="this.src=\'images/advanced.png\'" data-account="' + from + '"/>',
                        showNick?'<p class="nick">' + name + '</p>':'<p style="height:9px">&nbsp;</p>',
                        '<div class="msg msg-text "  data-id="'+ message.idClient +'">' +
                             '<div class="box" data-id="'+ message.idClient +'">' +
                                 '<div class="cnt" data-id="'+ message.idClient +'">'+text+'</div>' +
                            '</div>' +
                        '</div>',
                        '</div>'].join('');

                    return msgHtml;
                }
                //正常消息
    			msgHtml = ['<div data-time="'+ message.time +'" data-id="'+ message.idClient +'" id="'+ message.idClient +'" data-idServer="'+ message.idServer +'" class="item item-' + buildSender(message) + '">',
    						'<img class="img j-img" src="'+getAvatar(avatar)+'" onerror="this.src=\'images/advanced.png\'" data-account="' + from + '"/>',
    						showNick?'<p class="nick">' + name + '</p>':'<p style="height:9px">&nbsp;</p>',
                            message.type == 'file'?
    						'<div class="msg msg-text msg-file" style="background-color:#fff" data-id="'+ message.idClient +'"><div class="box" data-id="'+ message.idClient +'"><div class="cnt" data-id="'+ message.idClient +'">'+getMessage(message)+'</div></div></div>':'<div class="msg msg-text" data-id="'+ message.idClient +'"><div class="box" data-id="'+ message.idClient +'"><div class="cnt" data-id="'+ message.idClient +'">'+getMessage(message)+'</div></div></div>',
    						message.status === "fail"?'<span class="error"><i class="icon icon-error"></i>发送失败</span>':'',
                            isTenant?'':'<div data-id="'+ message.idClient +'" class="readSetting">···</div>',
                            '<span class="readMsg"><i></i>已读</span>',
    					'</div>'].join('');
            }
        }
        return msgHtml;
    },

    /**
     * 云记录面板UI
     */
    buildCloudMsgUI:function(msg,cache){
         var msgHtml = '',
             len = msg.length,
             userInfo = cache.getUserById(msg.from),
             message;
        for (var i = len - 1; i >= 0; --i) {
            message = msg[i];
            if(i == (len -1)){
                msgHtml += this.makeTimeTag(transTime(message.time));
            }else{
                if(message.time-msg[i+1].time>5*60*1000){
                    msgHtml += this.makeTimeTag(transTime(message.time));
                }
            }
            if(userInfo == undefined || userInfo == null || !userInfo){
                yunXin.mysdk.getUsers([msg.from], function(err, data){
                    if (!err) {
                        for (var j = 0; j < data.length; j++) {
                            cache.updatePersonlist(data[j])
                        }
                        userInfo = cache.getUserById(msg.from);
                        msgHtml += this.makeChatContent(message,userInfo, cache);
                        return msgHtml;
                    } else {
                        console.log("获取用户信息失败");
                    }
                })
            }else{
                msgHtml += this.makeChatContent(message,userInfo, cache);
                return msgHtml;
            }
        }
    },

    /**
     * 群成员列表
     */
    buildTeamMemberList:function(list){
        return ['<li data-icon="' + list.avatar + '" data-uid="' + list.account + '" data-account="' + list.nick + '">',
                    '<i class="icon icon-radio"></i>',
                    '<img src="'+getAvatar(list.avatar)+'">',
                    '<span class="name">' + getNick(list.account) + '</span>',
                '</li>'].join('');
    },

    /**
     * 黑名单
     */
    buildBlacklist:function(data,cache){
        var html="";
        if(data.length===0){
            return '';
        }
        for(var i = 0;i<data.length;i++){
            var user = cache.getUserById(data[i].account);
            html += ['<li class="items f-cb">',
                        '<img src="'+getAvatar(user.avatar)+'" class="head">',
                        '<span class="nick">'+user.nick+'</span>',
                        '<button class="btn radius4px btn-ok j-rm" data-id="'+user.account+'">解除</button>',
                    '</li>'].join('');
        }
        return html;
    },

    /**
     * 系统消息
     */
    buildSysMsgs: function (data, cache) {
        var html = "",
            item,
            team,
            action,
            content;
        if (data.length === 0) {
            return '';
        }
        for (var i = 0; i < data.length; i++) {
            item = data[i];
            if (item.category == "team") {
                team = item.attach ? item.attach.team : cache.getTeamMapById(item.to);
                //拿不到群信息就过滤吧
                if (!team) {
                    continue;
                }
                if (item.type === "teamInvite") {
                    content = getNick(item.from) + "邀请你入群";
                    if (item.state === "init") {
                        action = '<a class="j-apply">同意</a><a class="j-reject">拒绝</a>';
                    } else if (item.state === "rejected") {
                        action = '已拒绝';
                    } else if (item.state === "passed") {
                        action = '已同意';
                    } else {
                        action = '已失效';
                    }
                } else if (item.type === "applyTeam") {
                    content = getNick(item.from) + "申请加入群";
                    if (item.state === "init") {
                        action = '<a class="j-apply">同意</a><a class="j-reject">拒绝</a>';
                    } else if (item.state === "rejected") {
                        action = '已拒绝';
                    } else if (item.state === "passed") {
                        action = '已同意';
                    } else {
                        action = '已失效';
                    }
                } else if (item.type === "rejectTeamApply" || item.type === "rejectTeamInvite") {
                    content = getNick(item.from) + "拒绝了你的入群邀请";
                    action = '已拒绝';;
                } else {
                    content = "未知";
                    action = "";
                }
                html += ['<div class="item">',
                    '<img src="images/advanced.png">',
                    '<div class="text">',
                    '<p><span>' + (team ? team.name : item.to) + '</span><b class="time">' + transTime2(item.time) + '</b></p>',
                    '<p><span class="first-msg">' + content + '</span><b class="action" data-type="' + item.type + '" data-idServer="' + item.idServer + '" data-id="' + team.teamId + '" data-from="' + item.from + '">' + action + '</b></p>',
                    '</div>',
                    '</div>'].join('');
            } else if (item.category == "friend") {
                //处理好友的系统通知
                  if(item.type==="applyFriend"){
                    content = getNick(item.from)+ "申请加你为好友";
                    if(item.state ==="init"){
                        action = '<a class="f-apply">同意</a><a class="f-reject">拒绝</a>';
                    }else if(item.state==="rejected"){
                        action = '已拒绝';
                    }else if(item.state==="passed"){
                        action = '已同意';
                    }else{
                        action = '已失效';
                    }
                }else if(item.type==="rejectFriendApply"){
                    content = getNick(item.from) + "拒绝了你的好友申请";
                    action = '已拒绝';
                }else if(item.type=="passFriendApply"){
                      content = getNick(item.from) + "同意了你的好友申请";
                      action = '已同意';
                 }else if(item.type=="deleteFriend"){
                      content = getNick(item.from) + "解除了与你的好友关系";
                      action = '已删除';
                  }else{
                    content ="未知";
                    action = "";
                }
                $('.new-friend-who').html(content);
            }
        }
        return html;
    },
    buildApplyFriendUI:function(data,cache){
        let html = '';
        for(let i=0;i<data.length;i++){
            let item = data[i];
            let id = item.from;
            if(data[i].type == 'deleteFriend'){
                continue;
            }
            if(!cache.getUserById(id)){
                yunXin.mysdk.getUsers([id],function(err,data){
                    if (!err){
                        for (var j = 0;j < data.length;j++) {
                            cache.updatePersonlist(data[j])
                        }
                        html += this.applyFriendUI(item,id,cache);
                    } else {
                        console.log("获取用户信息失败");
                    }
                })
            }else{
                html += this.applyFriendUI(item,id,cache);
            }
        }
        $('.apply-list').html(html);
    },
    applyFriendUI:function(item,id,cache){
        let person = cache.getUserById(id);
        let avatar = person.avatar ? person.avatar:'./images/default-icon.png';
        let name = getNick(id);
        let remark = item.ps;
        let currentItem = '<li class="apply-item"><img class="apply-avatar" src="'+avatar+'" alt=""><div class="apply-content"><div class="apply-name">'+name+'</div><div class="apply-remark">'+remark+'</div></div><div class="apply-btn handle-before">接受</div></li>';
        return currentItem;
    },
    // 自定义系统通知
    buildCustomSysMsgs: function (data, cache) {
        var html = "",
            content,
            from,
            scene,
            to,
            nick,
            avatar;
        if (data.length === 0) {
            return html;
        }
        data = data.sort(function (a, b) {
            return b.time - a.time;
        });
        for (var i = 0; i < data.length; i++) {
            scene = data[i].scene;
            content = JSON.parse(data[i].content).content;
            from = data[i].from;
            to = data[i].to;
            if (scene === "p2p") {
                nick = getNick(from);
                avatar = getAvatar(cache.getUserById(from) ? cache.getUserById(from).avatar : "");
            } else {
                var teamInfo = cache.getTeamById(to + "");
                if (teamInfo) {
                    nick = teamInfo.name + "-->" + getNick(from);
                    avatar = "images/" + teamInfo.type + ".png";
                } else {
                    nick = to + "-->" + getNick(from);
                    avatar = "images/normal.png";
                }
            }
            html += ['<div class="item">',
                '<img src="' + avatar + '">',
                '<div class="text">',
                '<p><span>' + nick + '</span><b class="time">' + transTime2(data[i].time) + '</b></p>',
                '<p><span class="first-msg">' + content + '</span></p>',
                '</div>',
                '</div>'].join('');
        }
        return html;
    },
    //聊天消息中的时间显示
    makeTimeTag: function (time) {
        return '<p class="u-msgTime"><span >'+time+'</span></p>';
    },
    // 多人音视频列表
    buildmeetingMemberUI: function (data) {
        // data.nick = getNick(data.account);
        data.avatar = getAvatar(data.avatar);
        data.avatar = /default-icon\.png/gi.test(data.avatar) ? "" : data.avatar;
        return '<li class="item loading" style="'+ (data.avatar ? 'background-image:url(' + data.avatar + ')' : '') + '" data-account=' + data.account + '>'+
            '<span class="fullScreenIcon" title="切换全屏">&nbsp;</span>'+
            '<span class="tip"><i></i><i></i><i></i></span>'+
            '<p class="name" data-account="' + data.account + '">' + data.nick + '</p>'+
            '<p class="volume-show" style="width:0"></p>'+
            '</li>';
    },
    // 多人禁言ui
    buildspeakBanUI: function(data){
        data.nick = getNick(data.account);
        data.nick = data.nick === data.account ? "" : data.nick;
        return '<li data-icon="' + data.avatar +'" data-account="' + data.account + '" data-nick="' + (data.nick || data.name || data.account) + '">' +
            '<i class="icon-control icon-micro"></i>' +
            '<img src="' + getAvatar(data.avatar) + '">' +
            '<span class="name">' + (data.nick || data.name || data.account) + '</span>' +
            '</li>';
    },
};

/*聊天页面的右键功能*/
document.getElementById('j-chatContent').addEventListener('contextmenu',function (e) {
    let ev = e || window.event;
    ev.preventDefault();
    var userSelection;
    if (window.getSelection) { //现代浏览器
        userSelection = window.getSelection();
    } else if (document.selection) { //IE浏览器 考虑到Opera，应该放在后面
        userSelection = document.selection.createRange();
    }
    if (userSelection.getRangeAt) {
        if(!(userSelection.anchorNode==userSelection.focusNode && userSelection.anchorOffset==userSelection.focusOffset)){
            let menu = new Menu();
            menu.append(new MenuItem({label: '复制',role:"copy",visible:true}));
            menu.popup(remote.getCurrentWindow())
        }
    }
},false);

/*聊天页面点击隐藏消息操作列表*/
document.getElementById('j-chatContent').addEventListener('click',function (e) {
    $('.msgSetting').remove();
},false);
