//"use strict";
function isArray(o) {
    return Object.prototype.toString.call(o) === "[object Array]";
}

var getPostParameter = function (request) {
    //300017
    var app_key = require("electron").remote.getGlobal("app_key"); //dev
    var secret = require("electron").remote.getGlobal("secret"); //dev

    var post_data = "";
    var param_array = new Object();
    this.session = request.session ? request.session : localStorage.getItem("xn_session");

    if (this.session != undefined && this.session != null && this.session > 0) {
        param_array.session = this.session;
        param_array.passportId = this.session;
        //当时union 时候,实际passportID存放的是union ID的indentity 身份护照ID
    }
    param_array.format = "json";
    param_array.sign_method = "md5";
    param_array.timestamp = Date.parse(new Date());
    param_array.app_key = app_key;
    param_array.v = "1.0";

    for (var p in request) {
        // 方法
        if (request[p] != null && request[p] != undefined && typeof request[p] != "function") {
            param_array[p] = request[p];
        }
    }
    {
        var param_sign;
        var arrayKey = [];
        var strTemp;
        var arrayKeyTemp = [];
        for (var p in param_array) {
            // 方法
            if (typeof param_array[p] != "function") {
                arrayKeyTemp.push(p);
                // console.log(param_array [ p ] );
            }
        } // 最后显示所有的属性
        arrayKeyTemp.sort();
        var strTemp = secret;
        for (var i = 0; i < arrayKeyTemp.length; i++) {
            if (isArray(param_array[arrayKeyTemp[i]])) {
                strTemp = strTemp + arrayKeyTemp[i] + JSON.stringify(param_array[arrayKeyTemp[i]]);
            } else {
                strTemp = strTemp + arrayKeyTemp[i] + param_array[arrayKeyTemp[i]];
            }
        }
        strTemp = strTemp + secret;

        param_sign = MD5(strTemp).toUpperCase();

        post_data = "sign=" + param_sign.toUpperCase();
        for (var i = 0; i < arrayKeyTemp.length; i++) {
            if (isArray(param_array[arrayKeyTemp[i]])) {
                post_data =
                    post_data + "&" + arrayKeyTemp[i] + "=" + encodeURI(JSON.stringify(param_array[arrayKeyTemp[i]]));
            } else {
                post_data = post_data + "&" + arrayKeyTemp[i] + "=" + encodeURI(param_array[arrayKeyTemp[i]]);
            }
        }
    }
    var post_url = require("electron").remote.getGlobal("serveUrl");
    var returnValue = {};
    returnValue.url = post_url;
    returnValue.data = post_data;
    return returnValue;
};

var updateSession = function (params) {
    return new Promise((resolve, reject) => {
        $.ajax({
            type: "post",
            url: params.url,
            data: params.data,
            success: function (data) {
                resolve(data);
            },
            error: function (error) {
                if (error.status == 0) {
                    let data = { errors: [{ message: "网络异常，请连接后重试！" }] };
                    reject(data);
                }
            },
        });
    });
};

var http_post = function (request, callback) {
    var postP = getPostParameter(request);
    $(function () {
        $.ajax({
            type: "post",
            url: postP.url,
            data: postP.data,
            success: function (data) {
                if (data.subErrors != null && data.subErrors.length > 0) {
                    if (data.errors == undefined || data.errors == null || data.errors instanceof Array == false) {
                        data.errors = [];
                    }
                    data.errors.push(data.subErrors);
                }
                callback(data);
            },
            error: function (error) {
                if (error.status == 0) {
                    let data = { errors: [{ message: "网络异常，请连接后重试！" }] };
                    callback(data);
                }
            },
        });
    });
};

var xn_http_post = function (request, callback) {
    if (!request.session) {
        let expireTime = localStorage.getItem("expireTime");
        let nowTime = Number(new Date());
        if (Number((expireTime - nowTime) / 1000 / 60 / 60) < 1) {
            var UpdatePassport = new updatePassport();
            UpdatePassport.setUnionId(localStorage.getItem("uid"));
            var params = getPostParameter(UpdatePassport);
            updateSession(params).then(function (result) {
                localStorage.removeItem("expireTime");
                localStorage.removeItem("xn_session");
                localStorage.setItem("expireTime", result.identity.expireTime);
                localStorage.setItem("xn_session", result.identity.id);
                http_post(request, callback);
            });
        } else {
            http_post(request, callback);
        }
    } else {
        http_post(request, callback);
    }
};
