"use strict";
var remote=require('electron').remote;
var electron = require('electron'); // 控制应用生命周期的模块。
var BrowserWindow = electron.remote.BrowserWindow;  // 创建原生浏览器窗口的模块

const session = remote.session;

var appInfo=JSON.parse(require('electron').remote.getGlobal('appInfo'));


var thisBrowserWindow= require('electron').remote.getCurrentWindow();
thisBrowserWindow.setTitle(appInfo.productName);


var ref = [
    "xn.common",
    "xn.service.interceptor",
    "xn.talk.service",
    "xn.talk.method",
    "ui.bootstrap",
    "xn.directive.form",
    "monospaced.qrcode"
];
var app = angular.module("myApp", ref);

app.value("xnConfig",{
    env:remote.getGlobal('env'),
    platform:remote.getGlobal('platform'),
    appInfo:JSON.parse(remote.getGlobal('appInfo'))
});



//拦截器
app.config(["$httpProvider", function ($httpProvider) {
    $httpProvider.interceptors.push("httpInterceptor");
}]);
// 全局配置 form提交验证
app.config(["xnValidatorProvider", function (xnValidatorProvider) {
    // 全局配置
    xnValidatorProvider.config({
        blurTrig: false,
        showError: false,
        removeError: false
    });
    xnValidatorProvider.setRules({
        account:{
            required : "用户名不能为空！"
        },
        password:{
            required : "密码不能为空！"
        }
    });
}]);
app.controller("BodyController", ["$scope","$interval", "talkService","xnAppTool","dialogService","xnConfig",function ($scope,$interval,talkService,xnAppTool,dialogService,xnConfig) {
    $scope.timer = null;
    $interval.cancel($scope.timer);
    $scope.loading = false;
    $scope.showPrompt = false;
    $scope.rememberUser = true;
    $scope.phoneAccountList = JSON.parse(localStorage.phoneAccount || '[]');
    $scope.codeAccountList = JSON.parse(localStorage.codeAccount || '[]');
    $scope.busAccountList = JSON.parse(localStorage.busAccount || '[]');

    $scope.global={
        tab:"ACCOUNT",
        platform:xnConfig.platform,  //系统环境xnConfig.platform
        showInfo:false,
        appInfo:xnConfig.appInfo
    };
    //路径跳转
    $scope.winLogin=function (account, pwd) {

        xnAppTool.setStorage('imId',account);//MD5
        xnAppTool.setStorage('sdktoken',pwd);//MD5

        var	mainWindow = new BrowserWindow({frame: false, resizable: true,center:true, useContentSize:true,class:'Main',width:1100, height: 735,minWidth:960,minHeight:620,webPreferences:	{
            webSecurity: false,allowDisplayingInsecureContent:true, allowRunningInsecureContent:true
        }
        });

        mainWindow.setMenuBarVisibility(false);
        if(remote.getGlobal('isDebug') == true){
            mainWindow.openDevTools();
        }
        mainWindow.class = 'Main';
        // 加载应用的 index.html
//		mainWindow.loadURL("file://" + remote.getGlobal('dirname')+"/xnLayout/page/main.html");

        mainWindow.loadURL("file://" + remote.getGlobal('dirname')+"/xnChat/page/main.html");
        if(remote.getGlobal('isDebug')){
            mainWindow.setSize(1024, 768);
        }
        mainWindow.center();
        window.close();
    };

    var xnLoginAccount= localStorage.getItem("xnLoginAccount");
    var xnLoginPassword= localStorage.getItem("xnLoginPassword");
    var xnLoginLength= localStorage.getItem("xnLoginLength");
    var passwordActive=true;

    if(xnLoginAccount=="null"){
        xnLoginAccount="";
    }
    if(xnLoginPassword == "null"){
        xnLoginPassword="";
    }
    if(xnLoginLength=="null" || xnLoginLength=="" || xnLoginLength=="undefined"){
        xnLoginLength=0;
    }

    function newPassword(number){
        if(Number(number)!=0){
            var a=[];
            for(var i=0;i<Number(number);i++){
                a.push("1")
            }
            return a.join("");
        }else{
            return ""
        }
    }

    $scope.passwordChange=function(){
        passwordActive=false;
    };

    $scope.vm={
        account:xnLoginAccount,
        password:newPassword(xnLoginLength),
        getCode:true,
        title:'账号密码登录',
        accountLogShow:false,
        messageLogShow:true,
        busAccountLogShow:true,
        codeMsg:'获取验证码'
    };

    /*回车键登录*/
    document.addEventListener('keydown',function(e){
        let ev = e || window.event;
        if (ev.keyCode === 32 || ev.keyCode === 13) {
            ev.preventDefault();
            if(!$scope.vm.accountLogShow){
                $scope.doAccountLogin();
            }else if(!$scope.vm.messageLogShow){
                $scope.doMsgLogin();
            }else if(!$scope.vm.busAccountLogShow){
                $scope.doBusAccountLogin();
            }
        }
    });

    $scope.getCode = function(){
        $scope.vm.getCode = false;
        $scope.vm.code = '';
        $interval.cancel($scope.timer);
        $scope.vm.codeMsg = 60;
        $scope.timer = $interval(function(){
            if($scope.vm.codeMsg > 1){
                $scope.vm.codeMsg = $scope.vm.codeMsg - 1;
            }else{
                $scope.vm.codeMsg = '获取验证码';
                $scope.vm.getCode = true;
            }
        },1000);
        talkService.xnTalkMsgGet({verificationType:'SHORT_MOBILE',object:'+86'+$scope.vm.phoneNumber}).success(function (data) {
            if (data.errors.length == 0) {
                $scope.uniteFormErrors = data.errors[0].message;
            }else{
                $scope.uniteFormErrors = '验证码已发送，请注意查收'
            }
        })
    };

    $scope.changeLogin = function(type){
        $scope.uniteFormErrors = '';
        if(type == 'account'){
            $scope.vm.accountLogShow = false;
            $scope.vm.messageLogShow = true;
            $scope.vm.busAccountLogShow = true;
            $scope.vm.title = '账号密码登录';
        }else if(type == 'message'){
            $scope.vm.accountLogShow = true;
            $scope.vm.messageLogShow = false;
            $scope.vm.busAccountLogShow = true;
            $scope.vm.title = '短信验证码登录';
        }else if(type == 'busAccount'){
            $scope.vm.accountLogShow = true;
            $scope.vm.messageLogShow = true;
            $scope.vm.busAccountLogShow = false;
            $scope.vm.title = '企业账号登录';
        }
    };

    // 记住登录的账号密码
    $scope.rememberLoginAccount = function (key) {
        var phoneAccountList = JSON.parse(localStorage.phoneAccount || '[]').slice(0, 4);
        var busAccountList = JSON.parse(localStorage.busAccount || '[]').slice(0, 4);
        var codeAccountList = JSON.parse(localStorage.codeAccount || '[]').slice(0, 4);
        if (key === 'phoneAccount' && phoneAccountList.indexOf($scope.vm.account) === -1) {
            phoneAccountList.unshift($scope.vm.account);
        }
        if (key === 'codeAccount' && codeAccountList.indexOf($scope.vm.phoneNumber) === -1) {
            codeAccountList.unshift($scope.vm.phoneNumber);
        }
        if (key === 'busAccount' && busAccountList.indexOf($scope.vm.busAccount) === -1) {
            busAccountList.unshift($scope.vm.busAccount);
        }
        localStorage.clear();
        xnAppTool.setStorage('phoneAccount', JSON.stringify(phoneAccountList));
        xnAppTool.setStorage('codeAccount', JSON.stringify(codeAccountList));
        xnAppTool.setStorage('busAccount', JSON.stringify(busAccountList));
    }

    // 删除保存的账号
    $scope.deleteLoginAccount = function (index, key, storage) {
        var list = JSON.parse(localStorage.getItem(storage) || '[]');
        var count = list.indexOf($scope[key][index]);
        if (count > -1) {
            list.splice(count, 1);
            localStorage.setItem(storage, JSON.stringify(list));
        }
        $scope[key].splice(index, 1);
    }

    $scope.doAccountLogin=function () {
        if($('.signIn-btn').hasClass('signIn-notCan')){
            return;
        }

        var password="";
        if(!passwordActive){
            password = MD5($scope.vm.password);
            xnLoginLength = $scope.vm.password.length;
        }else{
            password = xnLoginPassword;
        }

        if(!$scope.loading) {
            $scope.loading = true;
            var vm={
                account:$scope.vm.account,
                password:password,
                deviceId:"0",
                deviceType:"PC",
                id:"127.0.0.1"
            };

            talkService.login(vm).success(function (data) {
                if (data.errors.length){
                    $scope.uniteFormErrors = data.errors[0].message;
                    $scope.loading = false;
                }else {
                    if ($scope.rememberUser) {
                        $scope.rememberLoginAccount('phoneAccount')
                    }
                    localStorage.setItem("xnLoginAccount",$scope.vm.account);
                    localStorage.setItem("xnLoginPassword",password);
                    localStorage.setItem("xnLoginLength",xnLoginLength);

                    xnAppTool.setStorage('xn_session',data.identity.id);//MD5
                    xnAppTool.setStorage('expireTime',data.identity.expireTime);//MD5

                    xnAppTool.setStorage('account',data.union.account);
                    xnAppTool.setStorage('avatarUrl',data.union.avatarUrl);//MD5
                    xnAppTool.setStorage('diskId',data.union.diskId);//MD5
                    xnAppTool.setStorage('name',data.union.name);//MD5
                    xnAppTool.setStorage('nickName',data.union.nickName);//MD5
                    xnAppTool.setStorage('mobilePhone',data.union.mobilePhone);//MD5
                    xnAppTool.setStorage('avatarId',data.union.avatarId);//MD5
                    xnAppTool.setStorage('union',JSON.stringify(data.union));//MD5

                    xnAppTool.setStorage('uid',data.union.id);
                    talkService.getTenant({unionId:data.union.id}).success(function(res){
                        $scope.loading = false;
                        if(res.errors == null || res.errors.length > 0){
                            alert(res.errors[0].message);
                        }else{
                            if(res.result.length == 0){
                                alert('用户暂无承租人')
                            }else{
                                xnAppTool.setStorage('unionList',JSON.stringify(res.result));
                                $scope.winLogin(data.identity.imId, data.identity.imId);
                            }
                        }
                    });
                }
            });
        }
    };

    $scope.doBusAccountLogin = function(){
        if($('.signIn-btn').hasClass('signIn-notCan')){
            return;
        }
        if(!$scope.loading) {
            $scope.loading = true;
            var vm={
                account:$scope.vm.busAccount,
                password:MD5($scope.vm.busPassword),
                deviceId:"0",
                deviceType:"PC",
                ip:"127.0.0.1",
                loginType:'USER'
            };
            talkService.login(vm).success(function(data){
                if (data.errors.length != 0){
                    $scope.uniteFormErrors = data.errors[0].message;
                    $scope.loading = false;
                }else {
                    if ($scope.rememberUser) {
                        $scope.rememberLoginAccount('busAccount')
                    }
                    xnAppTool.setStorage('xn_session',data.identity.id);//MD5
                    xnAppTool.setStorage('expireTime',data.identity.expireTime);//MD5

                    xnAppTool.setStorage('account',data.union.account);
                    xnAppTool.setStorage('avatarUrl',data.union.avatarUrl);//MD5
                    xnAppTool.setStorage('diskId',data.union.diskId);//MD5
                    xnAppTool.setStorage('name',data.union.name);//MD5
                    xnAppTool.setStorage('nickName',data.union.nickName);//MD5
                    xnAppTool.setStorage('mobilePhone',data.union.mobilePhone);//MD5
                    xnAppTool.setStorage('avatarId',data.union.avatarId);//MD5
                    xnAppTool.setStorage('union',JSON.stringify(data.union));//MD5

                    xnAppTool.setStorage('uid',data.union.id);
                    talkService.getTenant({unionId:data.union.id}).success(function(res){
                        $scope.loading = false;
                        if(res.errors == null || res.errors.length > 0){
                            alert(res.errors[0].message);
                        }else{
                            if(res.result.length == 0){
                                alert('用户暂无承租人')
                            }else{
                                xnAppTool.setStorage('unionList',JSON.stringify(res.result));
                                $scope.winLogin(data.identity.imId, data.identity.imId);
                            }
                        }
                    });
                }
            });
        }
    };

    $scope.doMsgLogin = function(){
        if($('.signIn-btn').hasClass('signIn-notCan')){
            return;
        }
        if(!$scope.loading){
            $scope.loading = true;
            var identityRequest = {
                deviceSystemName:'PC',
                deviceId:'0',
                issueIp:'127.0.0.1',
                issueClient:'PC',
                deviceName:'XNTALK',
                deviceSystemVersion:'1.0',
                deviceCarrierName:'XNTALK',
                deviceApplicationName:'XNTALK',
                deviceApplicationVersion:'1.0'
            };
            var vm={
                account:'86-'+$scope.vm.phoneNumber,
                code:$scope.vm.code,
                deviceId:"0",
                deviceType:"PC",
                ip:"127.0.0.1",
                identityCreateRequest: JSON.stringify(identityRequest),
            };
            talkService.xnTalkCodeLogin(vm).success(function(data){
                if (data.errors.length != 0){
                    $scope.uniteFormErrors = data.errors[0].message;
                    $scope.loading = false;
                }else {
                    if ($scope.rememberUser) {
                        $scope.rememberLoginAccount('codeAccount')
                    }
                    xnAppTool.setStorage('xn_session',data.identity.id);//MD5
                    xnAppTool.setStorage('expireTime',data.identity.expireTime);//MD5

                    xnAppTool.setStorage('account',data.union.account);
                    xnAppTool.setStorage('avatarUrl',data.union.avatarUrl);//MD5
                    xnAppTool.setStorage('diskId',data.union.diskId);//MD5
                    xnAppTool.setStorage('name',data.union.name);//MD5
                    xnAppTool.setStorage('nickName',data.union.nickName);//MD5
                    xnAppTool.setStorage('mobilePhone',data.union.mobilePhone);//MD5
                    xnAppTool.setStorage('avatarId',data.union.avatarId);//MD5
                    xnAppTool.setStorage('union',JSON.stringify(data.union));//MD5

                    xnAppTool.setStorage('uid',data.union.id);
                    talkService.getTenant({unionId:data.union.id}).success(function(res){
                        $scope.loading = false;
                        if(res.errors == null || res.errors.length > 0){
                            alert(res.errors[0].message);
                        }else{
                            if(res.result.length == 0){
                                alert('用户暂无承租人')
                            }else{
                                xnAppTool.setStorage('unionList',JSON.stringify(res.result));
                                $scope.winLogin(data.identity.imId, data.identity.imId);
                            }
                        }
                    });
                }
            });
        }
    };

    // 点击展开账号提示
    $scope.slidDownAccountPrompt = function () {
        $scope.showPrompt = true;
    }

    // 点击其他地方收起账号提示
    $scope.slidUpAccountPrompt = function ($event) {
        if ($event.target.tagName !== 'INPUT' && $event.target.className !== 'auto-list' && $event.target.className !== 'auto-closed') {
            $scope.showPrompt = false;
        }
    }

    // 输入账号进行模糊匹配
    $scope.inputAccountPrompt = function (value, key, storage) {
        var list = JSON.parse(localStorage.getItem(storage) || '[]');
        if (list.length) {
            if ($scope.vm[value]) {
                var result = [];
                for (var i = 0; i < list.length; i++) {
                    if (list[i].indexOf($scope.vm[value]) > -1) {
                        result.push(list[i])
                    }
                }
                $scope[key] = result;
            } else {
                $scope[key] = list;
            }
        }
        $scope.uniteFormErrors = '';
        $scope.vm.password = '';
    }

    // 选择自动提示的账号
    $scope.selectedAccountPrompt = function (key, value) {
        $scope.vm[key] = value;
        $scope.showPrompt = false;
    }

    //扫码登陆
    $scope.code={
        loginId:null,
        interval:null
    };
    function bCheckLogin () {
            talkService.scanLoginGet({id:$scope.code.loginId}).success(function (data) {
                if(data.identity != null && data.identity != undefined) {
                    xnAppTool.setStorage('xn_session', data.identity.id);//MD5
                    xnAppTool.setStorage('expireTime', data.identity.expireTime);//MD5

                    xnAppTool.setStorage('account', data.union.account);//MD5
                    xnAppTool.setStorage('avatarUrl', data.union.avatarUrl);//MD5
                    xnAppTool.setStorage('diskId', data.union.diskId);//MD5
                    xnAppTool.setStorage('name', data.union.name);//MD5
                    xnAppTool.setStorage('nickName', data.union.nickName);//MD5
                    xnAppTool.setStorage('mobilePhone', data.union.mobilePhone);//MD5
                    xnAppTool.setStorage('avatarId', data.union.avatarId);//MD5
                    xnAppTool.setStorage('union', JSON.stringify(data.union));//MD5

                    if (!$scope.loading) {
                        $scope.loading = true;
                        xnAppTool.setStorage('uid', data.union.id);
                        talkService.getTenant({unionId: data.union.id}).success(function (res) {
                            $scope.loading = false;
                            if (res.errors == null || res.errors.length > 0) {
                                alert(res.errors[0].message);
                            } else {
                                if (res.result.length == 0) {
                                    alert('用户暂无承租人')
                                } else {
                                    xnAppTool.setStorage('unionList', JSON.stringify(res.result));
                                    $scope.winLogin(data.union.imId, data.union.imId);
                                }
                            }
                        });
                    }
                }
            });
    };

    function createScanLogin() {
        talkService.scanLoginCreate({}).success(function (data) {
            $scope.code.loginId=data.id;
            $scope.code.loginCode="XNTALK_PC_SCAN_LOGIN_"+data.id;
            if($scope.global.tab=="QRCODE"){
                $scope.code.interval=setInterval(bCheckLogin, 1000);
            }
        });
    }

    //切换
    $scope.tab=function (type) {
        $scope.global.tab=type;

        if(type=='QRCODE'){
            /*扫码*/
            createScanLogin();
        }else {
            window.clearInterval($scope.code.interval);
        }
    };

    /**
     * 关闭工程
     */
    $scope.xnTalkClose=function () {

        // window.location.href = '/index.html';

        const dialog = require('electron').remote.dialog;
        var dialogOption = {
            type:'question',
            title:'退出',
            buttons:['确定', '取消'],
            defaultId:0,
            message:'确定要退出'+$scope.global.appInfo.productName+'吗？',
            detail:'',
            cancelId:1
        };

        dialog.showMessageBox(dialogOption,function(e){
            // e 是选择的目录
            if(e == 0){
                try {
                    xnAppTool.clearStorage()
                } catch (e){
                }
                require('electron').remote.app.quit();
            }
        });
    };
}]);
