(function () {
    "use strict";
    angular.module("app.filter", [])
      .filter("fileSize",function() {
        return function (input) {
            if(input){
                if (input < 1024) {
                    return input + "B";
                } else if (input < 1024 * 1024) {
                    return Math.round(input / 1024) + "KB";
                } else if (input < 1024 * 1024 * 1024){
                    return (input / 1024 / 1024).toFixed(2) + "MB";
                } else {
                    return (input / 1024 / 1024 / 1024).toFixed(2) + "GB";
                }
            }
        };
    })
    .filter('pageOffset', function() {
        return function(input, start) {
            if(input){
                start = parseInt(start, 10);
                return input.slice(start);
            };
        }
    })

})();