/**
 * Created by DEV005 on 2016/3/31.
 */
(function () {
    'use strict';
    var fs = require("fs");
    const electron = require('electron');
    var remote =  require('electron').remote;
    var path = require('path');
    var app =  electron.app;
    const ipcRenderer = electron.ipcRenderer;

    function mainController($scope,$modal,xnUploadService,dialogService) {

         $scope.itemList=[];

         var temporaryList=[];
         //没查询到的物料图片
         $scope.noItemList=[];
         //重复图片
         $scope.repeatItemList=[];

         $scope.vm={
            uploadedTotal:0,
            hasUploaded:0
         }

         $scope.page={
           pageSize:5,
           pageNumber:1,

         }

//        //读取文件
//        $scope.selectFile=function(){
//            ipcRenderer.send('selectFile',["Images"]);
//        };
//        /*返回读取目录*/
//        ipcRenderer.on('savedFile', function (event, fileList) {
//            setItemList(fileList);
//        });

          $("#selectFile").on("change", function (event) {
                setItemList(event.target.files);
          })


        //处理图片
         function  setItemList(fileList){
             temporaryList=[];
             var  numberSpecCodes=[];
             for(var i=0;i<fileList.length;i++){
                // 判断是否重复
                var isHave=false;

                 angular.forEach($scope.itemList,function(list){
                     if(list.numberSpecCode==fileList[i].name.substring(0,fileList[i].name.lastIndexOf('.'))){
                        isHave=true;
                      }
                 })

                  var item={
                     localUrl:fileList[i].path,
                     imgType:fileList[i].type,
                     imgName:fileList[i].name,
                     numberSpecCode:fileList[i].name.substring(0,fileList[i].name.lastIndexOf('.')),
                     imgBase64:fs.readFileSync(fileList[i].path,"base64"),
                     imgSize:fileList[i].size,
                     imgFile:fileList[i],
                  }
                 if(!isHave){
                      temporaryList.push(item);
                      numberSpecCodes.push(item.numberSpecCode);
                 }else{
                   $scope.repeatItemList.push(item)
                 }

             }

            xnUploadService.findItem({numberSpecCodes:numberSpecCodes}).success(function(data){
                if (data.errors == null || data.errors.length > 0) {
                    dialogService.tip(data.errors)
                }else {
                   angular.forEach(temporaryList,function(temporary){
                      var isHave=false;
                      if(Number(data.totalCount)>0){
                         angular.forEach(data.result,function(result){
                            if(result.numberSpecCode==temporary.numberSpecCode){
                                result.localUrl=temporary.localUrl;
                                result.imgType=temporary.imgType;
                                result.imgBase64=temporary.imgBase64;
                                result.imgSize=temporary.imgSize;
                                result.imgName=temporary.imgName;
                                result.imgFile=temporary.imgFile;

                                result.haveUpload=false;  //是否以上传

                                $scope.itemList.push(result);
                               console.log($scope.itemList);
                               isHave=true;
                            }
                         });
                      }
                      if(!isHave){
                         $scope.noItemList.push(temporary);
                      }
                  })

            };

         })
         }


        // 删除行
        $scope.doDelete=function(index){
           $scope.itemList.splice(index,1);
        }
         //$scope.itemList
        $scope.clearFile=function(){
          $scope.itemList=[];
        }

        $scope.clearUploadFile=function(){
          for(var i=$scope.itemList.length;i>0;i--){
            if($scope.itemList[i-1].haveUpload){
               $scope.itemList.splice(i-1,1);
            }
          }
        }

        //清空未查询到的物料
        $scope.clearNoItem=function(){
          $scope.noItemList=[];
        }
        //  清空未查询到的物料
        $scope.clearRepeatItem=function(){
          $scope.repeatItemList=[];
        }
        //更新并导入

        //上传中的文件
        $scope.uploadList=[];

        $scope.importFile=function(){

            var nameList = [];
            for(var i=0; i<$scope.itemList.length; i++) {
                if(!$scope.itemList[i].haveUpload){
                   nameList.push($scope.itemList[i].imgName);
                }
            }

            $scope.vm.uploadedTotal=nameList.length;
            $scope.vm.hasUploaded=0;


            if(nameList.length==0){
              dialogService.tip([{"message": "暂无文件上传！"}], null, 1000);
              return
            }

            xnUploadService.getUploadInfo({nameList:nameList}).success(function (data) {
                 if (data.errors == null || data.errors.length > 0) {
                        dialogService.tip(data.errors)
                }else {
                     var infoList = data.infoList;
                     console.log(infoList);

                    for(var i=0; i<infoList.length; i++) {
                        for(var j=0; j<$scope.itemList.length; j++) {

                           var info = infoList[i];
                           var file = $scope.itemList[j];
                           if(info.title==file.numberSpecCode){

                            file.imgFile.imgId = info.id
                            file.imgId = info.id
                             var userData = '{"Vod":{"Title":"' + info.title + '"}}';
                            console.log(file.imgFile)
                             uploader.addFile(file.imgFile, info.endpoint, info.bucket, info.fileUrl, userData);
                             break;
                           }
                        }
                    }
                    uploader.startUpload();

                }
            });
        };


        $scope.getTicket = function (param, callback) {
              // 获取文件上传凭证
              xnUploadService.getUploadAuth(param).success(function (data) {
                  if (data.errors === null || data.errors.length > 0) {
                      // 如果失败弹出提示框报错
                      dialogService.tip(data.errors, null, null)
                  } else {
                      $scope.tenantId = data.tenantId;
                      callback(data);
                  }
              })
        };

         var uploader = new VODUpload({
            // 文件上传失败
            'onUploadFailed': function (uploadInfo, code, message) {
                  console.log("onUploadFailed: file:" + uploadInfo.file.name + ",code:" + code + ", message:" + message);
            },
            // 文件上传完成
            'onUploadSucceed': function (uploadInfo) {
                // 处理视频路径，将bucket信息加入endpoint信息中
                 var fileUrl = uploadInfo.endpoint.replace("://", "://" + uploadInfo.bucket + ".") + "/" + uploadInfo.object;
                 var extension=fileUrl.substring(fileUrl.lastIndexOf('.')+1,fileUrl.length);
                // 上传的行
                 var upItem={};

                 for(var i=0; i<$scope.itemList.length; i++) {
                     var v = $scope.itemList[i];
                     if (uploadInfo.file.imgId === v.imgId) {
                          upItem = $scope.itemList[i];
                     }
                 }

                var item = {
                  storagePath: fileUrl,
                  name: uploadInfo.file.name,
                  extension:extension,
                  size:uploadInfo.file.size,
                  sourceType:"DIRECT",
                  type:"OTHER",
                };
                console.log(item);
                // 调用后台接口创建视频记录
                 xnUploadService.createFile(item).success(function (file) {
                     if (file.errors === null && file.errors.length > 0) {
                         dialogService.tip(file.errors);
                     } else {

                          var param={
                            id:upItem.id,
                            pictureId:file.id,
                            rowVersion:upItem.rowVersion
                          }
                         xnUploadService.updatePicture(param).success(function (data) {
                              if (data.errors === null || data.errors.length > 0) {
                                  // 如果失败弹出提示框报错
                                  dialogService.tip(data.errors, null, null)
                              } else {
//                               成功
                                    upItem.haveUpload=true;
                                   $scope.vm.hasUploaded++;

                                   if($scope.vm.hasUploaded==$scope.vm.uploadedTotal){
                                     dialogService.tip([{"message": "上传成功！"}], null, 1000);
                                     $scope.vm.uploadedTotal=0;
                                   }
                              }
                         })
                     }
                 })



            },
            // 文件上传进度
            'onUploadProgress': function (uploadInfo, totalSize, uploadedSize) {
                console.log("onUploadProgress")
                console.log(uploadInfo.file)
                for(var i=0; i<$scope.itemList.length; i++) {
                    var v = $scope.itemList[i];
                    if (uploadInfo.file.imgId === v.imgId) {
                        var item = $scope.itemList[i];
                        item.percent = Math.ceil(uploadedSize * 100 / totalSize) + "%";
                        item.uploadedSize = uploadedSize;
                        $scope.$apply();
                        break;
                    }
                }
            },
            // STS临时账号会过期，过期时触发函数
            'onUploadTokenExpired': function () {
                // log("onUploadTokenExpired");
                // OSS直接上传:STS方式，安全但是较为复杂，建议生产环境下使用。
                // 临时账号过期时，在onUploadTokenExpired事件中，用resumeWithToken更新临时账号，上传会续传。
                // 实现时，从新获取STS临时账号用于恢复上传
                $scope.getTicket({}, function (data) {
                    uploader.resumeUploadWithToken(data.accessKeyId, data.accessKeySecret, data.securityToken, data.expiration);
                });
            },
            // 开始上传
            'onUploadstarted': function (uploadInfo) {
                 console.log("onUploadStarted:" + uploadInfo.file.name + ", endpoint:" + uploadInfo.endpoint + ", bucket:" + uploadInfo.bucket + ", object:" + uploadInfo.object);
             }
        });

        $scope.getTicket({}, function (data) {
              // OSS直接上传:STS方式，安全但是较为复杂，建议生产环境下使用。
              // 临时账号过期时，在onUploadTokenExpired事件中，用resumeWithToken更新临时账号，上传会续传。
              uploader.init(data.accessKeyId, data.accessKeySecret, data.securityToken, data.expiration);
        });


    }

    angular.module('app')
        .controller('MainController', ["$scope","$modal","xnUploadService","dialogService",mainController]);
})();